/*
 * DemoFrame.java
 *
 * Created on 01 February 2005, 14:48
 */

package MiscTests;

/**
 *
 * @author  Jean-Alain Grunchec
 */
/* Copyright (C) 2002 J. M. Spivey */

import java.awt.*;
import java.applet.*;
import java.awt.event.*;

/** Common base class for applet windows.
 * 
 * Responds to closing events by stopping and releasing resources.
 */
public class DemoFrame extends Frame {
    private boolean isApplet;
    public DemoApplet parent = null;

    public DemoFrame(String name, boolean isApplet) {
        super(name);
        this.isApplet = isApplet;

        // Respond to closing event by dying
        addWindowListener(new WindowAdapter () {
            public void windowClosing(WindowEvent e) { die(); }
        });
        
        setLocation(400, 100);
    }
    
    public void initApplet(DemoApplet applet) { parent = applet; }
    
    public void die() {
        if (! isApplet) System.exit(0);
        this.dispose();
        parent.forgetFrame();
    }
}
