package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;


import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
    
import guikit.*; 
/** Superclass for Nodes / Links / Control Points.
 */
public class BasicClickablePoint implements ClickablePoint {
    Vector notifyPoints = new Vector(); 
    static protected NetEditPanel netPanel=null;    
    static protected ClickablePoint EmphasizedPoint = null;
    
    double clickXOffset = 0.;
    double clickYOffset = 0.;
    
    public double cx,cy; // Centre of clickable point
    Object data; // Data object;
    int depth = 5; // depth on display // default value? but what if > max?
    String baseClass; // base class of data object
    Object parent; // parent set (usually?)

    // parent is a Set / List to be notified when this changes..
    public Object getParentSet() { return parent; }
    public void setParentSet(Object p) { parent = p; }

  
    public double getX() { return cx; }
    public double getY() { return cy; }

    public void initUserData( Environment env, neuroml.core.Set parentset, String path ) {
	// We should make the user data here...
	this.parent = parentset; 	
    }

    public Object getData() { return data; }
    public void setData(Object o) { this.baseClass = o.getClass().getName(); data = o; }
    public void setData(String baseClass, Object o) { this.baseClass = baseClass; data = o; }
    public String getBaseClass() { return baseClass; }

    public BasicClickablePoint() {
	// null constructor
    }
    
     public NamedObject initUserData(neuroml.core.Set parentset) { 
         return null;
     }

    public void notifyTargetChanged(ClickablePoint child) { 
	// do nothing
    }
    public ClickablePoint getSource() { 
	return null;
    }
    public ClickablePoint getTarget() {
	return null;
    }

    public BasicClickablePoint(double cx, double cy) {
	this.cx = cx; this.cy = cy;
    }
    public void addListener( ClickablePoint cp ) { 
	notifyPoints.addElement( cp );
    }
    public void removeListener( ClickablePoint cp ) { 
	notifyPoints.removeElement( cp );
    }

    /** Is the point in the bounds? 
     */
    public boolean inBounds( double xp, double yp ) {
	return false; // subclasses to bounds checking
    }

    /** Basic intersection of */
    public boolean intersect( double x, double y, double w, double h ) {
	return cx>=x && cx<=x+w && cy>=y && cy<=y+h;
    }

    /** Has the point been clicked on?
     */
    public boolean queryClick( double xp, double yp ) {	
	boolean ret = inBounds(xp,yp);
	if (ret) { 
	    clickXOffset = xp - getX();
	    clickYOffset = yp - getY();
	}
	return ret;
    }
    public void mouseMoved( double xp, double yp ) {    }

    /** Move this point by dx,dy */
    public void move( double dx, double dy ) {
	cx += dx; cy += dy;
    }
    
    public void setPos( double dx, double dy ) {
	cx = dx; cy = dy;
    }

    /** Move this control point
     */
    public void mouseDragged( double xp, double yp ) {
	this.cx = xp - clickXOffset; 
	this.cy = yp - clickYOffset;
    }      

    int state = Constants.NORMAL; // dragging / normal

    /** Relative has been clicked : so redraw us too.
     */
    public void notifyStateChange(int state) {
	this.state = state;	
    }

    /** We have been clicked - tell relatives
     */
    public void setState(int state) {
	this.state = state; 
	for (int i=0; i<notifyPoints.size(); i++) {
	    ((ClickablePoint)(notifyPoints.elementAt(i))).notifyStateChange( state );
	}
    }
    public int getState() { return state;    }
    public void setHighlighted() { state |= Constants.HIGHLIGHTED; }
    public void clearHighlighted() { if (isHighlighted()) state -=  Constants.HIGHLIGHTED; }
    public boolean isHighlighted() { return ((state &  Constants.HIGHLIGHTED) !=0) ? true : false; }    
    public void toggleHighlight() { if (isHighlighted()) clearHighlighted(); else setHighlighted(); }


  // display depth
    public int getDepth(){
	return depth;
    }
    public void setDepth(int i){
	depth = i;
    }
    
   static  public int StartSet(String path){
        int j=1;
        int length=path.length();
        char[] str=path.toCharArray();
        while(str[length-j]>='0'&&str[length-j]<='9') j++;
        //Make something crazy
        if(j==1) return -32001;
        return Integer.parseInt(path.substring(length-j+1,length));
    }
    
    public void initUserData(Environment env, neuroml.core.Set parentset, String path, Connector p) {
    }    
    public static void setLastPanel(NetEditPanel pan){
        netPanel=pan;
    }
    public static NetEditPanel getLastPanel(){
        return netPanel;
    }   
    public void ClearNotifyPoints(){
        notifyPoints=new Vector();
    }
}
