package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import guikit.*;   
/** Vector of clickable points
 */    
public class ClickablePoints {
    int depthMax = 10;
    int depthReached = 0;
    int LastDepth;
    // array of vector of points by depth
    Vector[] pointsByDepth = new Vector[depthMax]; 
    
    public void add( ClickablePoint cp ) { 
	int depth = cp.getDepth();
	if (depth>=depthMax) depth = depthMax-1;

	if (depthReached<depth) depthReached = depth;
	Vector points = pointsByDepth[depth];
	if (points==null) points = new Vector();
	if(!points.contains(cp)) points.addElement(cp);
	pointsByDepth[depth]=points;
        LastDepth=depth;
    }

    /** Check for intersect in reverse addition order, 
     * and first checking nodes then other points
     */
    public ClickablePoint queryClick(double x, double y) {

	for (int d=0;d<=depthReached;d++) {
	    Vector points = pointsByDepth[d];

	    if (points!=null){
		for (int i=points.size()-1; i>=0; i--) {
		    ClickablePoint cp = (ClickablePoint) points.elementAt(i);
		    if (cp.queryClick( x,y )) {
			return cp;
		    }
		}	
		
	    }
	}

	return null;
    }

    /** Check for intersect of rectangle with a Node
     */
    public ClickablePoint intersectNode(double x, double y, double w, double h) {
	for (int d=0;d<=depthReached;d++) {
	    Vector points = pointsByDepth[d];
	    if (points!=null){
		for (int i=points.size()-1; i>=0; i--) {
		    ClickablePoint cp = (ClickablePoint) points.elementAt(i);
		    if (cp instanceof Node) {
			if (cp.intersect( x,y,w,h )) {
			    return cp;
			}
		    }
		}
	    }
	}
	return null;
    }
    
    public void remove()
    {
        Vector points=pointsByDepth[LastDepth];
        points.remove(points.size()-1); 
        pointsByDepth[LastDepth]=points;
    }
    public void remove(ClickablePoint cp)
    {
        int i;
        boolean found = false;
        Vector points;
        for(i=0;i<depthMax;i++)
        {
            points=pointsByDepth[i];
            if(points!=null)
            {
                if(points.contains(cp)) 
                {
                    found=true;
                    break;
                }
            }
        }
        if(found)
        {
             pointsByDepth[i].remove(cp); 
        }
        else
        {
            System.out.println("Not found clicked point!");
        }
    }
}
