package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;
import javax.swing.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
    
import guikit.*;  
/** Basic control point - for ends of links etc
 */
public class ControlPoint extends BasicClickablePoint {
    public double xsize, ysize;  // size of bounding box
    ClickablePoint parent = null; // Owner of point (e.g. a link)
    ClickablePoint target = null; // Target of point (where it's stuck, e.g. a Node)
    
    public double getX() { return cx; }
    public double getY() { return cy; }
    public double getX0() { return getX() - xsize/2; } // top left
    public double getY0() { return getY() - ysize/2; }
    public double getWidth() { return xsize; }
    public double getHeight() { return ysize; }
    public ControlPoint() {
	this(5,5,5,5);  
        ClickablePoint stuff=NetEditPanel_GuiKit.getLastClick();
        if(stuff==null||! (stuff instanceof Link))
            return;
        double[] truc=((Link)stuff).PointThere(0.5);
        this.cx=truc[0];
        this.cy=truc[1];
    }
    public ControlPoint(double x, double y, double xsize, double ysize) {
	super(x,y);
	this.xsize = xsize; 
	this.ysize = ysize;
        setDepth(0);
        if(this.getClass()!=ControlPoint.class||netPanel==null) return;
        if(netPanel !=null){
            ClickablePoint o=netPanel.getLastClicked();
            if(o!=null)  parent=o; 
        }             
    }
    public void setTarget( ClickablePoint t ) {	
	target = t;    
	if (parent!=null) {
	    parent.notifyTargetChanged(this);
	}
    }
    public ClickablePoint getTarget() { 
	return target; 
    }
    public void setParent( ClickablePoint t ) { 
	parent = t; 
    }
    public ClickablePoint getParent() { return parent; }

    public boolean inBounds1D( double a, double w, double pa, double pw ) {
	return (a>=pa && a<=pa+pw) || ((a+w)>=pa && (a+w)<=(pa+pw));
    }
    public boolean intersect( double x, double y, double w, double h ) {
	return inBounds1D( x,w,getX0(), getWidth()) &&inBounds1D( y,h,getY0(), getHeight()) ;
    }
    public boolean inBounds( double xp, double yp ) {
	return (xp >= cx-xsize/2  && xp <= cx+xsize/2) && 
	    (yp >= cy-ysize/2  && yp <= cy+ysize/2);
    }
    public void notifyStateChange(int state) {
	this.state = state;	
	if (parent!=null) parent.setState(state);
    }
    public void draw(Graphics2D g) {
	g.setColor(Color.green); 
	g.fill(new Rectangle2D.Double(getX0(), getY0(), getWidth(), getHeight()));
    }
    
 
}
  
