package guikit;
// CVS is wonderful !!!!!!!!!!!!
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
       

/** A sample Network editor application
 *
 */
public class DisplayApp extends BasicApp  {

    private static ResourceBundle resources;

    static {
        try {
            resources = ResourceBundle.getBundle("guikit.resources/DisplayApp", 
						 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("guikit.resources/DisplayApp.properties not found");
        }
    }
 
    boolean onoff = false;
 
    Hashtable nodes = new Hashtable();
    NetEditPanel panel;
    MenuPanel menupanel;
    ImageUtils imgLoader;

    NetworkPkg netPkg;
    NeuromlPkg np;
    Network n;


    /** A Test Network Displayer Application
     */
    public DisplayApp(String args) {
	super(args);
	imgLoader = new ImageUtils( this, resources );
	
 
	// Top object is NeuromlPkg
	np = (NeuromlPkg)topObject;

	// Then there's a NetworkPkg
	netPkg = new NetworkPkg("pkg1");
	np.models.addElement( netPkg );

	// Then there's a Network
	n = new Network(); n.setName("network1");
	netPkg.networks.addElement( n );

	Environment env = new Environment( ns, np, imgLoader );
	SpecialEditors.setEnvironment(env);
	getContentPane().setLayout(new BorderLayout());
	JPanel tmp = new JPanel();
	tmp.setLayout(new BoxLayout(tmp, BoxLayout.Y_AXIS ));
	tmp.setBackground(Color.blue);
	getContentPane().add(tmp);
	tmp.setMinimumSize(new Dimension(300,100));

	System.out.println("Net Application starting...");
	//	getContentPane().setLayout(new BorderLayout());


	// *** OK, now launch edit object on the network package...
	ObjectNode on = new ObjectNode(netPkg);
	on.setPath( "models.pkg1" );
	EditObjectPanel eop = new EditObjectPanel(ns, on, "NetworkPkg", true, false );
	tmp.add(eop);
 
    }  

    /** Sample main program
     */
    public static void main(String[] args) {
	System.out.println("Starting Network Displayer Applet");

	SpecialEditors.put("neuroml.model.network.Network", "guikit.SubnetDisplayer" );


        JFrame frame = new DisplayApp("Example network displayer");
	frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) { System.exit(0);  }
	    });  	
        frame.pack();
        frame.setVisible(true);
    } 
}

