/*
 * EditBooleanPanel.java
 *
 * Created on 18 February 2004, 14:17
 */

package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.sim.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class EditBooleanPanel extends EditPanel implements ActionListener {
    boolean value;       // Value
    JCheckBox chk = null;
    JLabel paramLabel;
    
    ElementChangedListener notifyParent = null;
    /** Creates a new instance of EditBooleanPanel */
    public EditBooleanPanel(ObjectNode node) {
        this(node,node.getName());
    }
    
    public EditBooleanPanel(ObjectNode node, String label) {
        //this(node,node.getName());
        super(node);
	value =false;
	Boolean val = (Boolean)node.getContent();
        value= val.booleanValue();
	//System.out.println("Making a boolean check box f "+smin+" "+smax);
	setMinimumSize(new Dimension(200,32));
        setPreferredSize(new Dimension(200,32));
	chk = new JCheckBox(label,value);
        chk.setMinimumSize(new Dimension(200,32));
        chk.setPreferredSize(new Dimension(200,32));
        chk.addActionListener(this);
        add(chk);
    }
    
     public void addElementChangedListener( ElementChangedListener p ) {
	notifyParent = p;
    }
     
     public void actionPerformed(ActionEvent e) {
         value = !value;
         node.setContent(new Boolean( value ) );
	/** tell parent that things have changed... */
	if (notifyParent!=null) {	    
	    notifyParent.elementChanged( node,node );
        }
     }
     
     /*
    public void changedUpdate(DocumentEvent e) {
        
    }
    
    public void insertUpdate(DocumentEvent e) {
        updateDisplayValue(e);
    }
    
     public void updateDisplayValue(DocumentEvent e) {
	//busy = true;
	value = !value;
	
	
	
	

	confirm();
	
    }
    
    public void removeUpdate(DocumentEvent e) {
        updateDisplayValue(e);
    }
    
     public void updateDisplay(Object newob) {
	System.out.println("updating display to "+newob);
	try {
	    value = ((Boolean)newob).booleanValue();

	   // chk.  .setValue( value );
	    updateDisplayValue(null);
	} catch (Exception e) {}
    }
     
    public void confirm() {
	node.setContent(new Boolean( value ) );
	/** tell parent that things have changed... 
	if (notifyParent!=null) {	    
	    notifyParent.elementChanged( node,node );
	}
    }  */
    
}
