/*
 * EditRefInterfaces.java
 *
 * Created on 27 January 2004, 12:50
 */

package guikit;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;
//import java.lang.reflect.*;
import neuroml.core.*;
import neuroml.util.*;
import neuroml.sim.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class EditRefInterfaces extends EditPanel  implements ActionListener, Editor {
    String baseClass; 
    Namespace ns;
    Object truc;
    JList JListClasses, JListInterfaces,JInterfaces;
    DefaultListModel ListClasses,ListInterfaces,Interfaces;
    JLabel SuperClass;
    RefInterfaces value;
    ElementChangedListener notifyParent = null;
    /** Creates a new instance of EditRefInterfaces */
    public EditRefInterfaces() { 	
    }
    
    public void editObject(Object o) {
        editObject(o,null);
    }
    
    public void editObject(Object o, ElementChangedListener n) {
        editObject( o, "RefInterfaces", n );
    }
    
    public void editObject(Object o, String path, ElementChangedListener n) {
        if(o instanceof RefInterfaces)
        {    
            truc=o;
            notifyParent=n;
            value=(RefInterfaces)o;                        
            ns=SpecialEditors.getEnvironment().getNamespace();
            JFrame ed = new JFrame("Param. of "+value.getName()+" inherits from:");
	    ed.getContentPane().setLayout( new BorderLayout());
	    JPanel contents = new JPanel();
	    contents.setLayout(new BoxLayout(contents, BoxLayout.Y_AXIS ));
            //new GridLayout(0,2));
	    ed.getContentPane().add(contents);
            ListClasses=new DefaultListModel();
            JListClasses=new JList(ListClasses);
            JListClasses.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            ListInterfaces=new DefaultListModel();
            JListInterfaces=new JList(ListInterfaces);
            Interfaces=new DefaultListModel();
            JInterfaces=new JList(Interfaces);
            
            JPanel scrollClasses=newList(ns.getListClasses(),JListClasses, ListClasses,"Select","Known classes");
            JPanel scrollListInterfaces=newList(ns.getListInterfaces(),JListInterfaces, ListInterfaces,"Add","Known interfaces");
            String[] name=new String[value.Interfaces.size()];
            for(int i=0;i<value.Interfaces.size();i++)
            {
                name[i]=value.Interfaces.elementAt(i).toString();
            }            
            JPanel scrollInterfaces=newList(name,JInterfaces, Interfaces,"Remove","Implemented interfaces");
            JPanel NamePanel=new JPanel();
            if(value.SuperClass==null)
                SuperClass=new JLabel("The superclass is "+"<not set>");
            else
                SuperClass=new JLabel("The superclass is "+value.SuperClass);
            NamePanel.add(SuperClass);
            JPanel Clean=new JPanel();
            Clean.add(makeButton("Clean", "Clean", this));
            contents.add(NamePanel);
            contents.add(Clean);
            contents.add(scrollInterfaces);
            contents.add(scrollClasses);
            contents.add(scrollListInterfaces);
            ed.pack();
	    ed.setVisible(true);
        }
    }
    
     private JPanel newList(String[] names,JList jlist,DefaultListModel list, String Button,String PanelTitle)
     {
        JPanel pan=new JPanel();
        if(names!=null)
        {
            for(int i=0;i<names.length;i++)
                list.addElement(names[i]); 
        }      
        
	JScrollPane scrollInterfaces = new JScrollPane(jlist);
        scrollInterfaces.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	scrollInterfaces.setMinimumSize( new Dimension(200,30) );
	scrollInterfaces.setPreferredSize( new Dimension(450,100) );
        pan.setLayout(new BoxLayout(pan, BoxLayout.Y_AXIS ));
        pan.add(scrollInterfaces);
        pan.setBorder( BorderFactory.createTitledBorder(PanelTitle) );
        JPanel truc=new JPanel();
        truc.add(makeButton(Button, Button, this));
        pan.add(truc);
        return pan;
    }
   
    public void actionPerformed(ActionEvent e) {
         if (e.getActionCommand().equals("Add")) {
             
             Object[] Selected_Values=JListInterfaces.getSelectedValues();
             JListInterfaces.clearSelection();
             for(int i=0;i<Selected_Values.length;i++)
                if(!Interfaces.contains(Selected_Values[i].toString())) 
                {
                    Interfaces.addElement(Selected_Values[i].toString());
                    value.Interfaces.addElement(Selected_Values[i].toString());
                }
             change();  
        } else if (e.getActionCommand().equals("Remove")) {
            Object[] Selected_Values=JInterfaces.getSelectedValues();
            for(int i=0;i<Selected_Values.length;i++)
            {
                Interfaces.removeElement(Selected_Values[i].toString());
                value.Interfaces.removeElement(Selected_Values[i].toString());
            }
            change(); 
        } else if (e.getActionCommand().equals("Select")) {          
            Object Selected_Value=JListClasses.getSelectedValue();
            SuperClass.setText("The superclass is "+ Selected_Value.toString());
            value.SuperClass=Selected_Value.toString();
            change(); 
        } else if (e.getActionCommand().equals("Clean")) {          
            SuperClass.setText("The superclass is <not set>");
            value.SuperClass=null;
            change(); 
        } else { 
            System.out.println("Unknown command");
        }
    }
    
    public void confirmElementChanged(Object object, Object object_1_) {
    }
        
    private void change()
    {
        notifyParent.elementChanged(truc, value);
        ns.UpdateRefInterfaces(value.getName(),value);
        repaint();
    }
    
    public void startMain() {
    }
    
}
