package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;

   
/** Image utilities
 */
public class ImageUtils {
    private  Vector images = new Vector();   // Image files we have loaded
    private  Vector imgNames = new Vector(); // And the names of the files

    private  ResourceBundle resources=null;
    private  JFrame mainframe=null; // for getting images
    
    /** Set resources, top frame
     */
    public ImageUtils( JFrame mc, ResourceBundle rb ) {
	mainframe=mc; 
	resources = rb;
    }

    /** Get a string from resources */
    public  String getResourceString(String nm) {
        String str;
        try {
            str = resources.getString(nm);
        } catch (MissingResourceException mre) {
            str = null;
        }
        return str;
    }
    public  URL getResource(String key) {
        String name = getResourceString(key);
        if (name != null) {
            URL url =  mainframe.getClass().getResource(name);
            return url;
        } else {
            System.out.println("Couldn't get resource "+key);
        }
        return null;
    }

    public  void setResources( JFrame mc, ResourceBundle rb ) { mainframe=mc; resources = rb; }

    /** Get an Image from a URL
     */
    public static Image getImage(URL imgUrl) {
	Image image = null;	
	ImageIcon icon2 = new ImageIcon(imgUrl);
	image = icon2.getImage();
	MediaTracker track = new MediaTracker( new JPanel() );
	track.addImage(image, 0);
	try { 
	    track.waitForID(0);		
	} catch ( InterruptedException e) { 
	    System.out.println("Image read OK"); 
	}
	return(image);
    }

    /** Get an Image from a resource name
     */
    public  Image getImage(String name) {
	if (resources==null) {
	    System.out.println("Need to call ImageUtils.setResources first!!!"); 
	    return null;  
	} else {
	    int index;
	    Image image = null;	
	    index = imgNames.indexOf(name);
	    if (index == -1) {
		System.out.println("Loading image resource:"+name);
		URL imgUrl = getResource(name);
		if (imgUrl==null) {
		    System.out.println("Error - URL null");
		    return null;
		} else {
		    image = getImage(imgUrl);
		    imgNames.addElement( name );
		    images.addElement(image);
		    return image;	 
		}
	    } else {
		return((Image)images.elementAt(index));
	    }
	}
    }
}
