package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import guikit.*;  

/** A link
 */
public class Link extends BasicClickablePoint {
    static public boolean Block=false;
    public double w;
    public RGBColour colour = new RGBColour("00ffff");
    public RGBColour quiet_colour = new RGBColour("-ff66cd");
    public RGBColour active_colour = new RGBColour("-ff66cd");
    public double SpikesPerSecond=100.0;
    Vector s=null;   
    static Font font = new Font("serif", Font.PLAIN, 14);


    /** Nasty way to ensure control points get XMLified...
     * Better to include proper support for [] ???
     */
    ControlPoint[] ctrls = null;
    public ControlPoint[] getControls() { 
	if (ctrls==null) {
	    ctrls = new ControlPoint[controls.size()];
	    for (int i=0; i<controls.size(); i++) { 
		ctrls[i] = (ControlPoint)controls.getElements().elementAt(i);
	    }
	}
	return ctrls; 	
    }
    public neuroml.core.Set controls = new neuroml.core.Set("guikit.ControlPoint");
    
    public double getX1() { 
	return getControls()[0].cx; 
    }
    public double getY1() { 
	return getControls()[0].cy; 
    }
    public double getX() { 
	return getControls()[1].cx; 
    }
    public double getY() { 
	return getControls()[1].cy; 
    }
    public double getX2() { 
	//return getControls()[2].cx;
        ControlPoint truc=(ControlPoint)(controls.getElements().elementAt(controls.getElements().size()-1));
        return truc.cx;
    }
    public double getY2() { 
        ControlPoint truc=(ControlPoint)(controls.getElements().elementAt(controls.getElements().size()-1));
        return truc.cy;
    }
    public double getX(int i) { 
	//return getControls()[2].cx;
        ControlPoint truc=(ControlPoint)(controls.getElements().elementAt(i));
        return truc.cx;
    }
    public double getY(int i) { 
        ControlPoint truc=(ControlPoint)(controls.getElements().elementAt(i));
        return truc.cy;
    }
    
    public int getSize() {
        return controls.size();
    }
    
    
    Node source = null;
    Node target = null;

    public void notifyTargetChanged(ClickablePoint child) { 
	// One of our control points has changed its target...
    }
    public ClickablePoint getSource() { 
	return source;
    }
    public ClickablePoint getTarget() {
	return target;
    }


    public Link() {
	// Null constructor for XMLIn's use
	super();
	setDepth(2);
    }
    public Link(double x1, double y1, double cx, double cy, double x2, double y2, double w, RGBColour rc) {
	this(x1,y1,cx,cy,x2,y2,w);
	colour=rc;
    }

    public Link(double x1, double y1, double cx, double cy, double x2, double y2, double w) {
	super( 0,0 ); // cx,cy ignored
	this.w = w;
	controls.getElements().addElement( new ControlPoint(x1,y1,w,w) );
	controls.getElements().addElement( new ControlPoint(cx,cy,w,w) );
	controls.getElements().addElement( new ControlPoint(x2,y2,w,w) );
	for (int i=0; i<3; i++) { 
	    ControlPoint p = (ControlPoint) controls.getElements().elementAt(i);
	    p.addListener( this ); 
	    p.setParent( this );
	}
	setDepth(2);
		
    }
    public void setShape( Vector s ) { this.s = s; }
    public Vector getShape( ) { return s; }
    
    // New link with end points
    public Link(double x1, double y1, double x2, double y2, double w, RGBColour rc) {
	this( x1,y1,(x1+x2)/2,(y1+y2)/2, x2,y2,w);
	colour = rc;
    }
    public Link(double x1, double y1, double x2, double y2, double w) {
	this( x1,y1,(x1+x2)/2,(y1+y2)/2, x2,y2,w);
    }
 
    public void setSource(Node t) { source = t; }
    public void setTarget(Node t) { target = t; }

    // Collision bounds detection 0 using bounding box
    public boolean inBounds1D( double p, double p1, double p2, double tol ) {
	if (p1 < p2) {
	    return (p>=(p1-tol)) && (p<=(p2+tol));
	} else {
	    return (p<=(p1+tol)) && (p>=(p2-tol));
	}
    }

    /** Mouse on the link? -- stupid algorithm 1st
     */
    public boolean inBounds( double xp, double yp ) {
	if (s!=null) {
            double tolerance = 10;//4

	    double a = xp-tolerance/2;
	    double b = yp-tolerance/2;
            for(int i=0;i<this.s.size();i++)
            {
                Shape truc=(Shape)(s.elementAt(i));
	    
	        if(truc.intersects(a,b,tolerance,tolerance)) 
                    return true;
//	    System.out.println("xp "+xp+" yp "+yp+" a "+a+" b "+b+"w "+w+" intersects? "+inter);
	    //boolean cont = s.contains(xp,yp);
//	    System.out.println("contains? xy "+xp+" yp "+yp+" : "+cont); 
//            return inter;
            }
            return false;
	   // return s.intersects(xp-tolerance/2,yp-tolerance/2, tolerance,tolerance);
	}
	System.out.println("link shape null :(");
	return false;
	//	return inBounds1D(xp, getX1(),getX2(),w) && inBounds1D(yp, getY1(),getY2(),w);
        /*return (xp >= cx-20/2  && xp <= cx+20/2) && 
	    (yp >= cy-20/2  && yp <= cy+20/2);*/
    }

    /** Mouse dragged
     */
    public void mouseDragged( double xp, double yp ) {
	double dx = xp - clickXOffset - getX();
	double dy = yp - clickYOffset - getY();
	
	// Only if not attached...
	for (int i=0; i<getControls().length; i++) {
	    //System.out.println("try to move link : get Target "+getControls()[i].getTarget());
	    if (getControls()[i].getTarget()==null) 
		getControls()[i].move(dx,dy);
	}
    }
    
     public void setPos( double dx, double dy ) {
         double X=dx-getX();
         double Y=dy-getY();
         for (int i=0; i<getControls().length; i++) {
	    //System.out.println("try to move link : get Target "+getControls()[i].getTarget());
	    if (getControls()[i].getTarget()==null) 
		getControls()[i].move(X,Y);
	}

    }
   
    // Angle b/w two points
    double angle(double x1,double y1, double x2, double y2) {
	double ang;
	double xp = x2-x1; 
	double yp = y2-y1;
	int xsgn=1, ysgn=1;
	if (xp<0.0) { xsgn=-1; xp=-xp; }
	if (yp<0.0) { ysgn=-1; yp=-yp;   }
        
	if (xp==0.0 && yp==0.0)    
            return( 0.0 );
	else if (xp>yp) {
	    ang = Math.atan(yp/xp);
	} else {
	    ang = (Math.PI/2.0) - Math.atan(xp/yp);
	}

	return (xsgn==1) ?  ((ysgn==1) ? ang      : (2.0*Math.PI) - ang ) :  
	    ((ysgn==1) ? Math.PI - ang : Math.PI + ang       );
    }
 
    /** Draw this link
     */
    public void draw(Graphics2D g) {
        RGBColour colour;
        if(this==BasicClickablePoint.EmphasizedPoint)
            colour=new RGBColour("-ffcd");
        else 
            colour=this.colour;
        
	g.setColor(colour.getColor()); 
        
        if(!Block) 
            g.setStroke(new BasicStroke((float)w, BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER));
        else
            g.setStroke(new BasicStroke((float)w*2, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER));

	double x = getX();
	double y = getY();
	double x1 = getX1();
	double y1 = getY1();
	double x2 = getX2();
	double y2 = getY2();
        Vector ShapeArray=new Vector(1,1);
        
        Vector chose = controls.getElements();
        ctrls=new ControlPoint[getSize()];
        for(int i=0;i<getSize();i++)
        {
            ctrls[i]=(ControlPoint)chose.elementAt(i);
            if(netPanel!=null&&ctrls[i]!=null&&netPanel instanceof NetEditPanel)
                ((NetEditPanel)netPanel).addControlPoint(ctrls[i]);
        }
        for(int i=0;i<getSize()-2;i++)
        {
            Shape s = new Line2D.Double(getX(i),getY(i),getX(i+1),getY(i+1));
            ShapeArray.add(s);
            g.draw( s );
            s = new Line2D.Double(getX(i+1),getY(i+1),getX(i+2),getY(i+2));
            ShapeArray.add(s);
            g.draw( s );
            
        }
	// For bounds checking...
	setShape( ShapeArray );

        double a = angle( getX(getSize()-2), getY(getSize()-2), x2, y2 );
        
        double a1 = a + Math.PI/4;
        double a2 = a - Math.PI/4;
        double ahead = w * 3;
        AffineTransform at = new AffineTransform();
        at.setToRotation(a1);
        Point2D head1 = at.transform( new Point2D.Double( ahead, 0 ), null );
        at.setToRotation(a2);
        Point2D head2 = at.transform( new Point2D.Double( ahead, 0 ), null );        
        if(!Block) 
        {
            // Draw arrow...
            GeneralPath p = new GeneralPath();
            p.moveTo((float)(x2-head1.getX()), (float)(y2-head1.getY()));
            p.lineTo((float)x2, (float)y2);
            p.lineTo((float)(x2-head2.getX()), (float)(y2-head2.getY()));

            g.draw( p );
        }
        else{
            at.setToRotation(a);
            Point2D head3 = at.transform( new Point2D.Double( -w, w ), null );
            at.setToRotation(a);
            Point2D head4 = at.transform( new Point2D.Double( -w, -w ), null );        
//        g.fillP
            double[] Xs,Ys;
            Xs=new double[4];
            Ys=new double[4];
            
            Xs[0]=x2-head3.getX();
            Xs[1]=Xs[0]-head1.getX();
            Xs[3]=x2-head4.getX();
            Xs[2]=Xs[3]-head2.getX();
        
            Ys[0]=y2-head3.getY();
            Ys[1]=Ys[0]-head1.getY();
            Ys[3]=y2-head4.getY();
            Ys[2]=Ys[3]-head2.getY();
            GeneralPath p = new GeneralPath();
            p.moveTo((float)Xs[0], (float)Ys[0]);
            p.lineTo((float)Xs[1], (float)Ys[1]);
            p.lineTo((float)Xs[2], (float)Ys[2]);
            p.lineTo((float)Xs[3], (float)Ys[3]);            
            g.fill(p);
          //  g.fillPolygon(
        }
        
        ControlPoint[] cps = getControls();
	for (int i=0; i<cps.length; i++) {
	    cps[i].draw(g);
	}
        drawName(g);
	
            
    }

    protected void drawName(Graphics2D g){
        Font f = font;
	String msg=getName();
	int sw = g.getFontMetrics(f).stringWidth(msg);
	g.setFont(f);
	g.setColor(Color.white);
        int k=getSize()/2;
        double dbl_k=getSize()*0.5;
        if(Double.compare(k, dbl_k)==0)
            g.drawString(msg, (float)((getX(k)+getX(k-1))*0.5) - sw/2, (float)((getY(k)+getY(k-1))*0.5)-16);
        else
            g.drawString(msg, (float)getX(k) - sw/2, (float)getY(k)-16);
    }
    
    public Link duplicate() { 
	return new Link(getX1(),getY1(),getX2(),getY2(),w,colour);
    }
    public String toString() { return "Link "+getName()+" w "+w; }
    public String getName() { 	
	if (data instanceof Nameable) {
	    return ((Nameable)data).getName(); 
	} else return "NewLink";
    }
    public void setName(String name) { 	
	if (data instanceof Nameable) {
	    ((Nameable)data).setName(name); 
	} 
    }
    
    public void addCtrlPoint()
    {
        int size=getSize()-1;
        ctrls = null;
        ControlPoint last=getControls()[size],before_last=getControls()[size-1];
        double width=last.xsize;
        double height=last.ysize;
        double X=(last.cx+before_last.cx)*0.5;
        double Y=(last.cy+before_last.cy)*0.5;
        //controls.getElements().addElement( new ControlPoint(np,x1,y1,w,w) );
        ControlPoint cpt=new ControlPoint(X,Y,w,w);
        controls.getElements().add(size,cpt );
        cpt.addListener(this);
        cpt.setParent(this);
        
    }
    
    public void redraw(Vector vecPath,double srcx,double srcy,double destx,double desty )
    {
        int size=vecPath.size();
         w=3;
        ClickablePoint start,end;
        start=((ControlPoint)(controls.getElements().elementAt(0))).getTarget();
        
        end=((ControlPoint)(controls.getElements().elementAt(controls.getElements().size()-1))).getTarget();
        ((PopulationNode)start).removeListener(getControls()[0]);
        ((PopulationNode)end).removeListener(getControls()[2]);
        
        controls = new neuroml.core.Set("guikit.ControlPoint");
        Dimension d=(Dimension)(vecPath.get(0));
        ControlPoint cpt=new ControlPoint(srcx+d.width,srcy+d.height,w,w);//+d.width//+d.height
        controls.getElements().add(cpt);
        cpt.addListener(this);
        cpt.setParent(this);
        cpt.setTarget(start);
        ((PopulationNode)start).addListener(cpt);

        for(int i=1;i<size;i++)
        {
            d=(Dimension)(vecPath.get(i));
            cpt=new ControlPoint(d.width,d.height,w,w);
            controls.getElements().add(cpt);
            cpt.addListener(this);
            cpt.setParent(this);
        }
        cpt.cx+=destx;
        cpt.cy+=desty;
        if(size==2)
            addCtrlPoint();   
        cpt.setTarget(end);
        ((PopulationNode)end).addListener(cpt);
        colour.SetRandom();
        ctrls=null;
    }

    
    public double[] PointThere(double fraction){
        double[] ArrayLength = new double[getSize()-1];
        double totalLength=0.0;
        int i;
        for(i=0;i<getSize()-1;i++)
        {
            ArrayLength[i]=java.lang.Math.sqrt(java.lang.Math.pow((getX(i+1)-getX(i)),(int)2)+java.lang.Math.pow((getY(i+1)-getY(i)),(int)2));
            totalLength+=ArrayLength[i];
        }
        totalLength*=fraction;
        i=0;
        while(totalLength>ArrayLength[i])
            totalLength-=ArrayLength[i++];       
        double[] point=new double[2];
        if(ArrayLength[i]==0.0){
            point[0]=getX(i);
            point[1]=getY(i);
        }
        else{
            totalLength=totalLength/ArrayLength[i];
            point[0]=getX(i)+(getX(i+1)-getX(i))*totalLength;
            point[1]=getY(i)+(getY(i+1)-getY(i))*totalLength;
        }
        return point;
    }
    
}

  
