package guikit;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;
import javax.swing.*;
import neuroml.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;

import guikit.*;

public class NetApp extends BasicApp  {
    private static ResourceBundle resources=null;
    static {
        try {
            resources = ResourceBundle.getBundle("guikit.resources/NetworkDesigner", Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("guikit.resources/NetworkDesigner.properties not found");
        }
    }
    boolean onoff = false;
    Hashtable nodes = new Hashtable();
    ImageUtils imgLoader;
    NetworkPkg netPkg;
    NeuromlPkg np;
    SubnetsEditor stuff;
    
    public NetApp(String args) {
	super(args);
	imgLoader = new ImageUtils( this, resources );      
	np = (NeuromlPkg)topObject;
	netPkg = new NetworkPkg("pkg1");
	np.models.addElement( netPkg );

	Environment env = new Environment( ns, np, imgLoader );
	SpecialEditors.setEnvironment(env);
	getContentPane().setLayout(new BorderLayout());

	System.out.println("Net Application starting...");

        ObjectNode on = new ObjectNode(netPkg);
	on.setPath( "models.pkg1" );
        ns.addRef("models.pkg1", netPkg); 
  
       stuff=new SubnetsEditor_StandAlone(netPkg);//GuiKit

        this.getContentPane().add(stuff,BorderLayout.CENTER);
        pack();
        setVisible(true);
        stuff.validate();
    }
       
    public static void main(String[] args) {
	System.out.println("Starting Network Editor Applet");
//       SpecialEditors.put("neuroml.model.network.NetworkPkg","guikit.SubnetsEditor_GuiKit");
        SpecialEditors.put("neuroml.model.network.NetworkPkg","guikit.SubnetsEditor_Animation");
        SpecialEditors.put("neuroml.util.RefInterfaces","guikit.EditRefInterfaces");
        SpecialEditors.put("neuroml.core.Module","guikit.ModuleEditor");
        EditTreeRefPanel.put("SubNetwork", "guikit.SubNetNode");

        JFrame frame = new NetApp("Example network editor");
	frame.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
	});
    }
}
