package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import neuroml.util.NeuromlSys;
import guikit.*;
import neuroml.sim.*;
import neuroml.util.module.*;
import java.lang.Math.*;
//First update with WinCVS under NetBeans
 
/** A network editor - superclass for user network editors.
 */
public class NetEditPanel extends NetPanel implements ElementChangedListener, ImageObserver {
    Network    network;  
    public ClickablePoint ToBeAdded =null;
    protected Hashtable populationTable = new Hashtable();
    boolean hasMoved=false;    
    static public boolean VisibleGrid=true;    
    boolean ZoomingBack=false; 
    protected boolean MenuPopupVisible=false;
    int dragX;
    double realDragX;

    EditObjectPanel eop; 
 
    protected String path;
    protected JPopupMenu menu;
    Environment env;
    static protected ResourceBundle resources;
    static boolean TextureDisplay=false;
    
    static {
        try {
            resources = ResourceBundle.getBundle("guikit.resources/NetworkDesigner", Locale.getDefault());
            String TextDisp=resources.getString("TextureDisplay");
            if(TextDisp.compareTo("false")==0) 
                setDisplayTexture(false);
            else if(TextDisp.compareTo("true")==0) 
                setDisplayTexture(true);
        } catch (MissingResourceException mre) {
            System.err.println("guikit.resources/NetworkDesigner.properties not found");
        }
    }    
    public NetEditPanel(Environment env, Network n, String path) {
        super();
            
        if(NetworkDesigner.resources==null) NetworkDesigner.init();
        BasicClickablePoint.setLastPanel(this);
        this.path=path;
        this.env=env;
        BasicClickablePoint.setLastPanel(this);
        Vector Proj=n.projections.getElements();
        Vector Elem=n.elements.getElements();
        Vector Atta=n.attachments.getElements();
        Vector Prob=n.probes.getElements();        
	this.network = n;
        if(network.editorInfo==null)
            network.editorInfo=new NetworkTransform();
        else{
            tx=((NetworkTransform)(network.editorInfo)).X;
            ty=((NetworkTransform)(network.editorInfo)).Y;
            zoomFactor=((NetworkTransform)(network.editorInfo)).Zoom;
        }
        for(int i=0;i<Proj.size();i++)
        {
            Projection stuff=(Projection)Proj.elementAt(i);
            ((TreeRef)stuff.dest).setElements(Elem);
            ((TreeRef)stuff.source).setElements(Elem);
            ((TreeRef)stuff.source).addLeaf("RealPopulation");
            ((TreeRef)stuff.source).addNode("SubNetwork");
            ((TreeRef)stuff.dest).addLeaf("RealPopulation");
            ((TreeRef)stuff.dest).addNode("SubNetwork");
        }
        for(int i=0;i<Atta.size();i++)
        {
            Attachment stuff=(Attachment)Atta.elementAt(i);
            ((TreeRef)stuff.source).setElements(Elem);
            ((TreeRef)stuff.source).addLeaf("RealPopulation");
            ((TreeRef)stuff.source).addNode("SubNetwork");
        }
	addToDisplay( n );
        setBorder(new javax.swing.border.MatteBorder(null));
        
        /**JAG Added popup menus to make life simpler*/
        menu = new JPopupMenu();
        this.add(menu);
    // Create and add a menu item
    }

    public void addToDisplay( Network n ) {
	//System.out.println("NetEditPanel addToDisplay "+n);
	int gridsz = (int) Math.sqrt( n.elements.getElements().size() );
	int xsz = 85; int ysz = 50;
        Node ndpop = null;
        Namespace ns=env.getNamespace();
	for (int i=0; i<n.elements.getElements().size(); i++) {
	    ElementRef elem = (ElementRef) n.elements.getElements().elementAt(i);

            PopulationNode nd;

		if (elem.editorInfo instanceof PopulationNode) {
		    nd = (PopulationNode)elem.editorInfo;
		    nd.setData( elem );
                    nd.setElement(elem.elementClass.getTargetName(), (Element)ns.deRef(elem.elementClass));
                    nd.ClearNotifyPoints();
		    BasicClickablePoint.setLastPanel(this);
		    addNode( nd );
		    populationTable.put(elem.getName(),nd);
		} else {
		    System.out.println("NetEditPanel elem.editorInfo not a Node : "+elem.editorInfo);
		    nd = new PopulationNode( (i%gridsz+1) * xsz * 2,  
					    (i/gridsz+1) * ysz * 2, 
					    xsz, ysz, 
					    new RGBColour("-df25e0"));
		    nd.setData( elem );
                    
		    elem.editorInfo = nd;
		    addNode( nd );
		    populationTable.put(elem.getName(),nd);
		}
                nd.setParentSet((neuroml.core.Set)n.elements);
	}
	for (int i=0; i<n.probes.getElements().size(); i++) {
	    Probe elem = (Probe) n.probes.getElements().elementAt(i);

            Node nd;

		if (elem.editorInfo instanceof Node) {
		    nd = (Node)elem.editorInfo;
		    nd.setData( elem );
                    nd.ClearNotifyPoints();
		    BasicClickablePoint.setLastPanel(this);
		    addNode( nd );
		    populationTable.put(elem.getName(),nd);
		} else {
		    System.out.println("NetEditPanel elem.editorInfo not a Node : "+elem.editorInfo);
		    nd = new PopulationNode( (i%gridsz+1) * xsz * 2,  
					    (i/gridsz+1) * ysz * 2, 
					    xsz, ysz, 
					    new RGBColour("-df25e0"));
		    nd.setData( elem );
                    
		    elem.editorInfo = nd;
		    addNode( nd );
		    populationTable.put(elem.getName(),nd);
		}
                nd.setParentSet((neuroml.core.Set)n.probes);
	}        
	for (int j=0; j<n.projections.getElements().size(); j++) {
	    Projection p = (Projection)n.projections.getElements().elementAt(j);
	    Link nd = (Link)p.editorInfo;
            String srcpop = p.source.getTargetName();
            String destpop = p.dest.getTargetName();
            int dotindex = srcpop.lastIndexOf("elements.");
            if (dotindex!=-1)
            srcpop = srcpop.substring(dotindex+9);
            dotindex = srcpop.indexOf('.');
            if (dotindex!=-1)
                srcpop=srcpop.substring(0,dotindex);
            dotindex = destpop.lastIndexOf("elements.");
            if (dotindex!=-1)
		destpop = destpop.substring(dotindex+9);
            dotindex = destpop.indexOf('.');
            if (dotindex!=-1)
                destpop=destpop.substring(0,dotindex);
            Node ndSource = (Node)populationTable.get(srcpop);
            Node ndTarget = (Node)populationTable.get(destpop);
	    if (nd!=null) {
		nd.setData( p );
		BasicClickablePoint.setLastPanel(this);;
		addLink( nd );   
	    } else {
		double srcX = 0;
		double srcY = ((j+1) * ysz) - (xsz/2);
		double dstX = 100;
		double dstY = ((j+1) * ysz) - (xsz/2);

		if (ndSource!=null){
		    srcX = ndSource.getX();
		    srcY = ndSource.getY();
		}
		if (ndTarget!=null){
		    dstX = ndTarget.getX();
		    dstY = ndTarget.getY();
		}
		double xmid = 0.0;
		double ymid = 0.0;
		if (srcpop.equals(destpop)) { //autolink case
		    xmid = srcX;
		    ymid = srcY-(ysz*2);
		} else {
		    xmid = srcX-dstX;
		    if (xmid < 0) xmid = -xmid;
		    ymid = srcY-dstY;
		    if (ymid < 0) ymid = -ymid;
		}
                nd =  new ProjectionLink(srcX,srcY,xmid,ymid,dstX,dstY,10.0,new RGBColour("-ff3301"));
		nd.setData(p);
                p.editorInfo=nd;
		addLink(nd);
                
	    }
            nd.setParentSet((neuroml.core.Set)n.projections);
            SetTargetControls(nd,ndSource,ndTarget); 
            
            //If the stuff below is let, then setTraget changes the target of projections, and the projections can't be connected by NEOSIM
            
           /* ControlPoint[] cpts = nd.getControls();

            if (ndSource!=null){
                cpts[0].setTarget(ndSource);
                ndSource.addListener(cpts[0]);
            }
            if (ndTarget!=null){
                cpts[cpts.length-1].setTarget(ndTarget); 
                ndTarget.addListener(cpts[cpts.length-1]);
            }    
            for (int i=0; i<cpts.length; i++) 
            {
		cp.add( cpts[i] );
                cpts[i].setParent(nd);
            }    */

        }
        
        for (int j=0; j<n.attachments.getElements().size(); j++) {
	    Attachment p = (Attachment)n.attachments.getElements().elementAt(j);
	    Link nd = (Link)p.editorInfo;
            String srcpop = p.source.getTargetName();
            String destpop = p.dest.getTargetName();
            int dotindex = srcpop.lastIndexOf("elements.");
            if (dotindex!=-1)
            srcpop = srcpop.substring(dotindex+9);
            dotindex = srcpop.indexOf('.');
            if (dotindex!=-1)
                srcpop=srcpop.substring(0,dotindex);
            dotindex = destpop.lastIndexOf("probes.");
            if (dotindex!=-1)
		destpop = destpop.substring(dotindex+7);
            dotindex = destpop.indexOf('.');
            if (dotindex!=-1)
                destpop=destpop.substring(0,dotindex);
            Node ndSource = (Node)populationTable.get(srcpop);
            Node ndTarget = (Node)populationTable.get(destpop);
	    if (nd!=null) {
		nd.setData( p );
		BasicClickablePoint.setLastPanel(this);;
		addLink( nd );   
	    } else {
		double srcX = 0;
		double srcY = ((j+1) * ysz) - (xsz/2);
		double dstX = 100;
		double dstY = ((j+1) * ysz) - (xsz/2);

		if (ndSource!=null){
		    srcX = ndSource.getX();
		    srcY = ndSource.getY();
		}
		if (ndTarget!=null){
		    dstX = ndTarget.getX();
		    dstY = ndTarget.getY();
		}
		double xmid = 0.0;
		double ymid = 0.0;
		if (srcpop.equals(destpop)) { //autolink case
		    xmid = srcX;
		    ymid = srcY-(ysz*2);
		} else {
		    xmid = srcX-dstX;
		    if (xmid < 0) xmid = -xmid;
		    ymid = srcY-dstY;
		    if (ymid < 0) ymid = -ymid;
		}
                nd =  new ProjectionLink(srcX,srcY,xmid,ymid,dstX,dstY,10.0,new RGBColour("-ff3301"));
		nd.setData(p);
                p.editorInfo=nd;
		addLink(nd);
                
	    }  
            nd.setParentSet((neuroml.core.Set)n.attachments);
            SetTargetControls(nd,ndSource,ndTarget);   
        }
    }
    
    protected void SetTargetControls(Link nd, Node ndSource, Node ndTarget){
            ControlPoint[] cpts = nd.getControls();
            
            for (int i=0; i<cpts.length; i++) 
            {
		cp.add( cpts[i] );
                cpts[i].setParent(nd);
            }
            
            if (ndSource!=null){
                cpts[0].setTarget(ndSource);
                ndSource.addListener(cpts[0]);
            }
            if (ndTarget!=null){
                cpts[cpts.length-1].setTarget(ndTarget); 
                ndTarget.addListener(cpts[cpts.length-1]);
            }     

    }

    // Add a node from the menu
    public void addMenuNode( ClickablePoint p ) {
	System.out.println("NetEditPanel addMenuNode "+p);
            BasicClickablePoint.setLastPanel(this);
	// add a copy of the node
	if (p instanceof Node) {
	    Node n = (Node)p;
	    Node newn = n.duplicate(platonicXPixelSize, platonicYPixelSize);
	    newn.setState(Constants.DRAGGING);
	    net.addNode( newn  );	    
	    cp.add( newn );
	    clickedPoint = newn;
	    dragging = true;
            if(n.getData() instanceof neuroml.model.network.Population)
                newn.initUserData( env, network.elements, path+"."+network.elements.getName() );    
            else if(n.getData() instanceof neuroml.model.network.Probe)
                newn.initUserData( env, network.probes, path+"."+network.probes.getName() );    
                
	} else if (p instanceof Link) {
	    Link l = (Link)p;
	    Link newl = l.duplicate();
	    newl.setState(Constants.DRAGGING);
	    //	    undrawLink( newl, g2 );
	    net.addLink( newl );
	    cp.add(newl);

	    // Add control points...
	    ControlPoint[] cpts = newl.getControls();
	    for (int i=0; i<cpts.length; i++) {
		cp.add( cpts[i] );
	    }
	    clickedPoint = newl;
	    dragging = true;
           Object obj=l.getData();
            neuroml.core.Set mySet=null;
            if(obj instanceof Projection)
                mySet=network.projections;
            else if(obj instanceof Attachment)    
                mySet=network.attachments;
            else 
                System.out.println("Error: should be connector instead of "+l.getClass().getName()+" in NetEditPanel");
	    newl.initUserData(env, mySet, path+"."+mySet.getName(),(neuroml.core.Connector)obj);
	}
    }
   
    public void removeMenuNode( ClickablePoint p ) {
	System.out.println("NetEditPanel removeMenuNode "+p);
        Object[] ListObj=null;
        Object obj=p.getData();
	if (p instanceof Node) {
	    net.removeNode();	    
	    //cp.remove();  
            cp.remove(p);
            if(obj!=null && obj instanceof Population){
                ListObj=network.elements.toArray();
                network.elements.remove(ListObj[ListObj.length-1]);
            }
            else if(obj!=null && obj instanceof Probe){
                ListObj=network.probes.toArray();
                network.probes.remove(ListObj[ListObj.length-1]);
            }
	} else if (p instanceof Link) {
            net.removeLink();	    
	    //cp.remove(); 
            cp.remove(p);
            if(obj!=null && obj instanceof Projection){
                ListObj=network.projections.toArray();
                network.projections.remove(ListObj[ListObj.length-1]);     
            }
            else if(obj!=null && obj instanceof Attachment)
                ListObj=network.attachments.toArray();
                network.attachments.remove(ListObj[ListObj.length-1]);     
	}
        else{
            p=((ControlPoint)p).getParent();
            removeMenuNode(p);
        }
    }
    public void RemoveElement(ObjectNode ne)
    {
        Class varclass=null;
        Object MyPoint=ne.getContent();
        String Name;
        int i;
        boolean found=false; 
        String stuff=ne.getContent().getClass().getName();
        Object[] ListObj;
        varclass=NeuromlSys.createClass(stuff);
        if(varclass==null) return;

        if(neuroml.model.network.Population.class.isAssignableFrom(varclass)) {
            Name=((Node)clickedPoint).getName();
            net.removeNode((Node)clickedPoint);	    
	    cp.remove(clickedPoint);  
            ListObj=network.elements.toArray();
            for(i=0;i<ListObj.length;i++){
                if(Name.compareTo( ((Population)(ListObj[i])).getName())==0)
                {
                  found=true;
                  break;
                }
            }
            if(found) network.elements.remove((Population)(ListObj[i]));
            else{
            }
        }
        else if(neuroml.model.network.Probe.class.isAssignableFrom(varclass)) {
            Name=((Node)clickedPoint).getName();
            net.removeNode((Node)clickedPoint);	    
	    cp.remove(clickedPoint);  
            ListObj=network.probes.toArray();
            for(i=0;i<ListObj.length;i++){
                if(Name.compareTo( ((Probe)(ListObj[i])).getName())==0)
                {
                  found=true;
                  break;
                }
            }
            if(found) network.probes.remove((Probe)(ListObj[i]));
            else{
            }
        }
        else if (neuroml.model.network.Projection.class.isAssignableFrom(varclass)){
            Name=((Link)clickedPoint).getName();
            net.removeLink((Link)clickedPoint);	    
	    cp.remove(clickedPoint);  
            ListObj=network.projections.toArray();
            for(i=0;i<ListObj.length;i++){
                if(Name.compareTo( ((Projection)(ListObj[i])).getName())==0)
                {
                  found=true;
                  break;
                }
            }
            if(found) network.projections.remove((Projection)(ListObj[i]));
            else{
            }
        }
        else if (neuroml.model.network.Attachment.class.isAssignableFrom(varclass)){
            Name=((Link)clickedPoint).getName();
            net.removeLink((Link)clickedPoint);	    
	    cp.remove(clickedPoint);  
            ListObj=network.attachments.toArray();
            for(i=0;i<ListObj.length;i++){
                if(Name.compareTo( ((Attachment)(ListObj[i])).getName())==0)
                {
                  found=true;
                  break;
                }
            }
            if(found) network.attachments.remove((Attachment)(ListObj[i]));
            else{
            }
         }   
        rerender();
	repaint();
    }    
    
    public Network getNetwork()
    {
        return network;
    }
    
    public void addControlPoint(ControlPoint truc){
        cp.add(truc);
    }
    
    
   public void mousePressed(MouseEvent e) {  
	int modif = e.getModifiers();
	double rx = realX( e.getX() );
	double ry = realY( e.getY() );
        if(this.MenuPopupVisible){
            MenuPopupVisible=false;
            return;
        }

	if ((modif & InputEvent.BUTTON1_MASK) != 0) {
	    clickedPoint = cp.queryClick( rx,ry );
	    if (clickedPoint != null) {
		// Edit the object!
		//System.out.println("Clicked on "+clickedPoint+" count "+e.getClickCount());
	    
		if (e.getClickCount()>1) {
		    if (clickedPoint.getData()!=null) {	
                        PopupClickedPoint(clickedPoint);
		    }
                    else if(clickedPoint.getClass() == ControlPoint.class){
                        Object o=((ControlPoint)clickedPoint).getParent();
                        if(o instanceof Link)
                            PopupClickedPoint((Link)o);
                    }
		}
                else {
                    clickedPoint.setState(Constants.DRAGGING);
                    dragging = true;
                    rerender();
                    repaint();
                }
	    }
            else ZoomingBack=true;               
	}
        else if ((modif & InputEvent.BUTTON3_MASK) != 0) {
	      RightClick(e);  
	}        
	else if ((modif & InputEvent.BUTTON2_MASK) != 0) {
            clickedPoint = cp.queryClick( rx,ry );
	    //System.out.println("Clicked on "+clickedPoint);
	    if (clickedPoint != null) {
		clickedPoint.setState(Constants.DRAGGING);
		dragging = true;
		rerender();
		repaint();
	    }
	}
   }
   
   public void mouseReleased(MouseEvent e) {  
        boolean Inavigate=navigating,Moved=hasMoved;
        navigating = false;
        hasMoved = false;
        if(ZoomingBack)
        {
                t.scale(1.1,1.1);
	        zoomFactor*=1.1;
                ((NetworkTransform)(network.editorInfo)).Zoom*=1.1;
                rerender();
                repaint();
                ZoomingBack =false;
        }
        else if(Inavigate)
        {
            if(!Moved)
            {
                double InvZoom=1.0/1.1;
                t.scale(InvZoom,InvZoom);
	        zoomFactor*=InvZoom;
                ((NetworkTransform)(network.editorInfo)).Zoom*=InvZoom;
                rerender();
                repaint();   
            }            
        }
        else if (dragging) {
	    dragging = false;
	    clickedPoint.setState(Constants.NORMAL);
 	    if (clickedPoint instanceof Node) {
	    } else if (clickedPoint instanceof Link) {
	    } else if (clickedPoint instanceof ControlPoint) {
		ControlPoint ctrlp = (ControlPoint) clickedPoint;		
		Node oldTarget = (Node)ctrlp.getTarget();
		Node target = (Node) highlightedPoint;
                if(target!=null){
	                Object target_data=target.getData();
        	        if(target_data!=null){
                		ClickablePoint ancestor=ctrlp.getParent();
		                if(ancestor!=null){
                		    Object ancestor_data=ancestor.getData();
		                    if(ancestor_data!=null){
                		        if(ancestor_data instanceof Projection && target_data instanceof Probe )
		                            return;
                                        else if(ancestor_data instanceof Attachment){ 
                                            ControlPoint[] muche=((Link)(ctrlp.getParent())).getControls();
                                            if(ctrlp==muche[muche.length-1]){
                                                if(!(target_data instanceof Probe))
                                                    return;
                                            }
                                            else if(ctrlp==muche[0]){
                                                if(!(target_data instanceof Population))
                                                    return;
                                            }
                                        }
                		    }
		                }
                	}
                }
                
                
		if (oldTarget != null) {
		    oldTarget.removeListener( clickedPoint ); // Disconnect
		}
		ctrlp.setTarget( target );
		if (highlightedPoint!=null) {
		    target.addListener( clickedPoint ); // Move end point
		    highlightedPoint.clearHighlighted();
		    highlightedPoint=null;
		}
	    }
            if ((e.getModifiers() & InputEvent.BUTTON3_MASK) != 0) 
                removeMenuNode(clickedPoint); 
	    rerender();
	    repaint();
	}	
        ToBeAdded=null;
    }    
    public void mouseDragged(MouseEvent e) {   
        if(ZoomingBack==true) ZoomingBack=false;
	if (navigating) {
	    double py = (e.getY() - dragY)/zoomFactor;
            double px = (e.getX() - dragX)/zoomFactor;
            dragX=e.getX();
            dragY=e.getY();
            
            hasMoved=true;
            
            t.translate(px,py);
            tx+=px;
            ty+=py;
            ((NetworkTransform)(network.editorInfo)).X=tx;
            ((NetworkTransform)(network.editorInfo)).Y=ty;
	    rerender();
	    repaint();
	} else super.mouseDragged(e);
    }
    public void render( int w, int h, Graphics2D g2) {
        int Y0,X0,Y1,X1,i;
        double X0_,Y0_,X1_,Y1_;
        int rest;

        X0_=realX(0);
        X1_=realX(w);
        Y0_=realY(0);
        Y1_=realY(h);
        
        X0=(int)X0_;
        X1=(int)X1_;
        Y0=(int)Y0_;
        Y1=(int)Y1_;
        if(TextureDisplay){   
            java.net.URL myURL=NetEditPanel.class.getResource(NetworkDesigner.resources.getString("texture_Editor"));
            ImageIcon myIcon=new ImageIcon(myURL);
            Image elementImage  = myIcon.getImage();
	
            int w_ = myIcon.getIconWidth(); int h_ = myIcon.getIconHeight();
            BufferedImage  bi = new BufferedImage(w_, h_, BufferedImage.TYPE_INT_RGB);
            Graphics2D gi = bi.createGraphics();
        
            if (elementImage!=null){
		gi.drawImage(elementImage, 0,0, this);
            }

            TexturePaint gradient = new TexturePaint(bi,new Rectangle(0,0,w_,h_));
            g2.setPaint(gradient);
            g2.fill(new Rectangle2D.Double(X0_,Y0_,X1_-X0_,Y1_-Y0_)); 
        }

        
        rest=X0%100;
        rest+=rest<0?100:0;
        X0-=rest;
        rest=Y0%100;
        rest+=rest<0?100:0;
        Y0-=rest;
        
        
        //java.net.URL myURL=getClass().getResource("");
        //ImageIcon myIcon=new ImageIcon(myURL);

         g2.setStroke(new BasicStroke(1.0f));       
        g2.setColor(Color.DARK_GRAY);
        if(VisibleGrid)
        {
            for(i=Y0;i<Y1;i+=100)
            {
                g2.draw(new Line2D.Double(X0,i,X1,i));
            }
            for(i=X0;i<X1;i+=100)
            {
                g2.draw(new Line2D.Double(i,Y0,i,Y1));
            }
            String msg = new String("tata");
            g2.setColor(Color.black);
            for(i=Y0;i<Y1;i+=100)
            {
                g2.drawString(new String(""+(-i)/100), X0+100+10, i+100+30);
            }
            for(i=X0;i<X1;i+=100)
            {
                g2.drawString(new String(""+i/100), i+100+20, Y0+100+20);
            }           
        }       

        super.render(w,h,g2);
        g2.setColor(Color.getHSBColor((float)1.0,(float)0.5,(float)0.5));
        g2.setStroke(new BasicStroke(3.0f));
        g2.draw(new Line2D.Double(X0_,Y0_,X0_,Y1_));
        g2.draw(new Line2D.Double(X0_,Y0_,X1_,Y0_));
        g2.draw(new Line2D.Double(X0_,Y1_,X1_,Y1_));
        g2.draw(new Line2D.Double(X1_,Y0_,X1_,Y1_));
        g2.setStroke(new BasicStroke(1.0f));
        g2.setColor(Color.getHSBColor((float)0.8,(float)0.4,(float)0.4));
        g2.draw(new Line2D.Double(X0_+1,Y0_+1,X0_+1,Y1_-1));
        g2.draw(new Line2D.Double(X0_+1,Y0_+1,X1_-1,Y0_+1));
        g2.draw(new Line2D.Double(X0_+1,Y1_-1,X1_-1,Y1_-1));
        g2.draw(new Line2D.Double(X1_-1,Y0_+1,X1_-1,Y1_-1));
    }

    
    public void elementChanged( Object oldobject, Object newobject ) {
        if((oldobject instanceof Projection||oldobject instanceof Attachment)&&(newobject instanceof TreeRef))
        {
            AdjustLink((Connector)oldobject,(TreeRef)newobject);
        }
        else if(oldobject instanceof Attachment && newobject instanceof Attachment){
            ((BasicClickablePoint)clickedPoint).setData("Attachment",newobject);
        }
        else if(oldobject instanceof Projection && newobject instanceof Projection){
            ((BasicClickablePoint)clickedPoint).setData("Projection",newobject);
        }
        else if(oldobject instanceof Probe && newobject instanceof Probe){
            ((BasicClickablePoint)clickedPoint).setData("Probe",newobject);
        }
        else if(oldobject instanceof Population && newobject instanceof Population){
            rerender();
            repaint();
        }
        else if((oldobject instanceof Population||oldobject instanceof Probe)&&newobject instanceof PopulationNode)
        {
            rerender();
            repaint();
        }   
        else if((oldobject instanceof Projection ||oldobject instanceof Attachment) &&newobject instanceof ProjectionLink)
        {
            rerender();
            repaint();
        }
        else if(oldobject instanceof RealPopulation  && newobject instanceof Ref && ((Ref)newobject).getContentClassName().compareTo("ElementPopulation")==0)  {
            Namespace ns=env.getNamespace();
            Enumeration elem=ns.getReferences("Attachment");
            Vector v=ns.getReferedHash("models.pkg1.networks."+this.network.getName()+".elements."+((RealPopulation)oldobject).getName());
            Object obj=ns.deRef(((Population)oldobject).elementClass);
            while(elem.hasMoreElements()){
                Attachment att=(Attachment)elem.nextElement();
                if(v.contains(att.source)){
                    if (obj instanceof ModuleNeuron) {
                        try {
                            ModuleNeuron mn = (ModuleNeuron) obj;
                            ModuleRef mr = mn.module; 
                            
                            PermanentSet truc=mn.getMeasurementList().Clone();
                            if(truc!=null&&att.MeasurementList!=null&&truc.size()==att.MeasurementList.size())
                            {
                                boolean On=true;
                                for(int i=0;i<truc.size()&&On;i++)
                                    if(truc.elementAt(i).getClass()!=att.MeasurementList.elementAt(i).getClass())
                                        On=false;
                                    if(!On)
                                        att.MeasurementList=truc;
                            }
                            else
                               att.MeasurementList=truc;                            
                        }
                        catch(Exception except){
                        }
                    }
                }
            }
        }
        else
        {
            String StrOld=oldobject.getClass().getName();
            String StrNew=newobject.getClass().getName();
            Class stuff=oldobject.getClass();
            if((StrOld.compareTo(StrNew)!=0)&&!(stuff.isAssignableFrom(newobject.getClass()))) 
                System.out.println("INFORMATION(NOT A BUG): Unforseen case: "+StrOld+" "+ StrNew );
            else
                oldobject=newobject;
        }
    }
  
    public void confirmElementChanged(Object oldn, Object newn) {
    }    
   protected void AdjustLink(Connector oldobject,TreeRef newobject){
        
            Connector pr=oldobject;
            ProjectionLink prlnk=(ProjectionLink)pr.editorInfo;
            TreeRef ThatRef=(TreeRef)newobject;
            PopulationNode Popnode;
            Population Pop;
            Hashtable temp;
            int i,j;
            String ThatTarget=ThatRef.getTargetName();
            if(pr.dest==ThatRef) j=prlnk.getControls().length-1;
            else if(pr.source==ThatRef) j=0;
            else
            {
                System.out.println("Eeh?");
                return;
            }                                   
            temp=(Hashtable)env.getNamespace().getReferences().get("Population");

            
            i=ThatTarget.length();
            while(i>-1)
            {
               ThatTarget=ThatTarget.substring(0,i);
               if(temp.containsKey(ThatTarget))
               {
                  Pop=(Population)temp.get(ThatTarget);
                  
                  Popnode=(PopulationNode)Pop.editorInfo;
                  ControlPoint ctrl=prlnk.getControls()[j];
                  Node oldTarget = (Node)ctrl.getTarget();
                  if(oldTarget!=null) oldTarget.removeListener(ctrl);
                  ctrl.cx=Popnode.cx;
                  ctrl.cy=Popnode.cy;
                  ctrl.setTarget(Popnode);
                  Popnode.addListener(ctrl);
                  i=-1;
               }
               else 
               {
                   i=ThatTarget.lastIndexOf(".");
               }         
            }
            
            rerender();
            repaint();      
         
    } 
     
    public String getPath() { return path; }
    public void  setPath(String path) {
        this.path=path; 
    }    

    protected void PopupClickedPoint(ClickablePoint clickedPoint){                      
    }   
    public ClickablePoint getLastClicked(){
        return clickedPoint;
    }    
    public static void setDisplayTexture(boolean Display){
        TextureDisplay=Display;
        PopulationNode.TextureDisplay=Display;
    }    
    
    public static boolean getDisplayTexture(){
        return TextureDisplay;
    }
    
    protected void RightClick(MouseEvent e){
        dragX = e.getX(); dragY = e.getY();
	realDragX = realX( dragX );
	realDragY = realY( dragY );
	navigating  = true;
	System.out.println("navigating!"); 
    }
}


