/*
 * NetEditPanel_Animation.java
 *
 * Created on 26 May 2004, 13:32
 */

package guikit;
import neuroml.sim.run.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import neuroml.util.NeuromlSys;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NetEditPanel_Animation extends NetEditPanel implements ActionListener {
    SubnetsEditor_Animation superParent;
    JPanel eop;
    /** Creates a new instance of NetEditPanel_Animation */
    public NetEditPanel_Animation(Environment env, Network n, String path, SubnetsEditor_Animation ttt) {
        super(env,n,path);
        superParent=ttt;
        

    }
    protected void PopupClickedPoint(ClickablePoint clickedPoint){
        if(clickedPoint instanceof PopulationNode){
            Object data=((PopulationNode)clickedPoint).getData();
            if(data instanceof SubNetwork){
                superParent.SetSelection(path+"."+((SubNetwork)data).getName());
                //                System.out.println("Path : "+this.path);
            }
            else if(data instanceof Probe||data instanceof RealPopulation){
                System.out.println("Path : "+this.path);
                /*eop = new EditObjectPanel( ns, ne, base , true,true,this);
                eop.addElementChangedListener(this);*/
                //JPanel eop=new JPanel();
                eop=buildProbeRendering(((NamedObject)data).getName());
                JPanel PanelEdit=new JPanel(new BorderLayout());
                int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
                int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
                JScrollPane jsp = new JScrollPane(eop,v,h);
                PanelEdit.add(jsp,BorderLayout.CENTER);
                JPanel buttons = new JPanel();
                buttons.setLayout( new BoxLayout(buttons, BoxLayout.X_AXIS) );
                
                buttons.add(EditPanel.makeButton("Expand", "expand", this));
                buttons.add(EditPanel.makeButton("Close", "close", this));
                buttons.add(EditPanel.makeButton("Reduce", "reduce", this));
                buttons.add(EditPanel.makeButton("Refresh", "refresh", this));
                PanelEdit.add(buttons,BorderLayout.SOUTH);
                superParent.DisplaySide(PanelEdit);
                if(eop instanceof PlusMinusPanel)
                    ((PlusMinusPanel)eop).Open();
            }
        }
    }
    
    public JPanel buildProbeRendering(String str){
        int i=path.lastIndexOf("MAIN.");
        if(i==-1)
            return superParent.buildProbeRendering(str);
        else
            return superParent.buildProbeRendering(path.substring(i+5)+"."+str);
        
    }
    
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("close")){
            superParent.HideSide();
            if(eop instanceof PlusMinusPanel)
                ((PlusMinusPanel)eop).Close();
            
        }
        if (e.getActionCommand().equals("expand")){
            superParent.Expand();
            if(eop instanceof PlusMinusPanel)
                ((PlusMinusPanel)eop).Expand();
        }
        if (e.getActionCommand().equals("reduce")){
            superParent.Reduce();
            if(eop instanceof PlusMinusPanel)
                ((PlusMinusPanel)eop).Reduce();
        }
        if (e.getActionCommand().equals("refresh")){
            superParent.Reduce();
            if(eop instanceof PlusMinusPanel)
                ((PlusMinusPanel)eop).Refresh();
        }
    }
    
    protected void SetTargetControls(Link nd, Node ndSource, Node ndTarget){
        ControlPoint[] cpts = nd.getControls();
        
        for (int i=0; i<cpts.length; i++) {
            cp.add( cpts[i] );
            cpts[i].setParent(null);
        }
        
        if (ndSource!=null){
            cpts[0].setTarget(ndSource);
            ndSource.addListener(cpts[0]);
        }
        if (ndTarget!=null){
            cpts[cpts.length-1].setTarget(ndTarget);
            ndTarget.addListener(cpts[cpts.length-1]);
        }
        for (int i=0; i<cpts.length; i++) {
            cpts[i].setParent(nd);
        }
        
    }
}
