package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import neuroml.model.MeasurementTool.*;
   


import neuroml.util.module.BasicRunnableCellFactory;
import guikit.*;
/** A population node
 */
public class PopulationNode extends Node implements ImageObserver {

    String elementRef = null;
    Element element = null;
    Image elementImage = null;
   static int Count=0; 
   static boolean FirstAddition=true;
   public static boolean TextureDisplay=false;
   static BufferedImage  bi=null;
   static BufferedImage  bi_LightGreen=null;
   static BufferedImage  bi_Blue=null;

    public PopulationNode() { 
	super();
        if(NetworkDesigner.resources==null) NetworkDesigner.init();
	colour = new RGBColour("ff8000"); 
    }
    public PopulationNode(double x, double y) { 
	super(x,y);
        if(NetworkDesigner.resources==null) NetworkDesigner.init();
	colour = new RGBColour("ff8000"); 
    }   
    public PopulationNode(double x, double y, double xsize, double ysize, RGBColour rc) { 
	super(x,y,xsize,ysize,rc);  
        if(NetworkDesigner.resources==null) NetworkDesigner.init();
    }   

    /** Move this population node
     */
    public void mouseDragged( double xp, double yp ) {
	double dx = xp - clickXOffset - getX();
	double dy = yp - clickYOffset - getY();
	this.cx = xp - clickXOffset;
	this.cy = yp - clickYOffset;
	for (int i=0; i<notifyPoints.size(); i++) {
	    if (notifyPoints.elementAt(i) instanceof ControlPoint){
		ControlPoint cpt = (ControlPoint)(notifyPoints.elementAt(i));
		// check if cpt belongs to a link
		if (cpt.getParent() instanceof Link){
		    Link lk = (Link)cpt.getParent();
		    // in that case, we move all the "free" points of the link
		    // find the other bound of the link
		    ControlPoint[] linkpts = lk.getControls();
		    // assume that we are only interested in extreme points
		    ControlPoint ptFirst = linkpts[0];
		    ControlPoint ptLast = linkpts[linkpts.length-1];
		    // find other end
		    ControlPoint ptOtherEnd = null;
                    boolean bilink=(linkpts.length<=2),start=false; 
		    if (cpt==ptFirst){
                        ptOtherEnd = ptLast;
                        start=true;
                    }
		    else if (cpt==ptLast){
                        start=false;
                        ptOtherEnd = ptFirst;
                    }
		    else {
			System.out.println("PopulationNode : impossible to move attached link") ;
			
		    }
                    double Linkmove[]=null;
                    if(!bilink) 
                        Linkmove=MoveLink(start, linkpts, dx, dy);
		    if (ptOtherEnd!=null){
			// only if other end attached somewhere
			if (ptOtherEnd.getTarget()!=null){
			    // if autolink
			  
			    Node target1 = (Node)ptOtherEnd.getTarget();
			    Node target2 = (Node)cpt.getTarget();
			    if ((target1.getName().equals(target2.getName()))&&(!target1.getName().equals("NewNode"))){
				for(int j=0;j<linkpts.length;j++){
				    if (linkpts[j].getTarget()==null){
					linkpts[j].move( dx/2 , dy/2 );
					// because it is autolink, 
					// it will be moved twice 
					// as the other bound will also be dealt with
				    }
				}
			    } else { // not autolink
				/*for(int j=0;j<linkpts.length;j++){
				    if (linkpts[j].getTarget()==null){
					linkpts[j].move(Linkmove[0],Linkmove[1]);
				    }
				}*/
                                if(start) 
                                    linkpts[1].move(Linkmove[0],Linkmove[1]);
                                else
                                    linkpts[linkpts.length-2].move(Linkmove[0],Linkmove[1]);
			    }
			}
		    }
		}
		cpt.move( dx, dy );
	    } 
            else ((ClickablePoint)(notifyPoints.elementAt(i))).move( dx, dy );
	}
    }   

    /** calcul movement for a free link control points between two linked nodes, one moving
     * @param nodePos : initial position of the moving node
     * @param nodeMove : node's movement delta
     * @param pointPos : initial link point's position : the point to be moved
     * @param linkedNodePos : position of the linked node
     *
     *
     */
    protected double calcLinkMove(double nodePos, double nodeMove, double pointPos, double linkedNodePos){
	double res;
	double ratio = 1.0;// distance ratio of the link's point between the two nodes

	
	if (nodePos>linkedNodePos){
	    // C A	    
	    if (pointPos<nodePos) {
		if (pointPos>linkedNodePos) {
		    // C B A
		    
		    // R = A - B / A - C = D - X / D - C
		    ratio = (nodePos-pointPos)/(nodePos-linkedNodePos);
		    // - X = R * (D-C) - D
		    res = (ratio * ((nodePos+nodeMove)-linkedNodePos))-(nodePos+nodeMove);
		    // Delta = -X - B
		    res = -res - pointPos;
		}
		else if (pointPos<linkedNodePos) {
		    //  B C A
		    res = 0;

		}
		else res = nodeMove; // B = C
	    }
	    else if (pointPos>nodePos) {
		// C A B
		// R = B-C/A-C = X-C/D-C
		ratio = (pointPos-linkedNodePos)/(nodePos-linkedNodePos);
		// X = R *(D-C)+C
		res = (ratio * ((nodePos+nodeMove)-linkedNodePos))+linkedNodePos;		    
		// Delta = X - B
		res = res - pointPos;

	    }
	    else res = nodeMove; // B = A

	}
	else if (nodePos<linkedNodePos){
	    // A C
	    if (pointPos>nodePos) {
		if (pointPos>linkedNodePos) {
		    // A C B
		    // R = B-C/C-A = X-C/C-D
		    ratio = (pointPos-linkedNodePos)/(linkedNodePos-nodePos);
		    // X = R*(C-D)+C
		    res = (ratio * (linkedNodePos-(nodePos+nodeMove)))+linkedNodePos;
		    // Delta = X - B
		    res = res - pointPos;
		} 
		else if (pointPos<linkedNodePos) {
		    // A B C
		    // R = C-B/C-A = C-X/C-D
		    ratio = (linkedNodePos-pointPos)/(linkedNodePos-nodePos);
		    // X = R*(C-D)-C
		    res = (ratio * (linkedNodePos-(nodePos+nodeMove)))-linkedNodePos;
		    // Delta = -X - B
		    res = -res - pointPos;
		}
		else res = nodeMove; // B = C
	    }
	    else if (pointPos<nodePos) {
		// B A C
		// R = C-B/C-A = C-X/C-D
		ratio = (linkedNodePos-pointPos)/(linkedNodePos-nodePos);
		// X = R*(C-D)-C
		res = (ratio * (linkedNodePos-(nodePos+nodeMove)))-linkedNodePos;
		// Delta = -X - B
		res = -res - pointPos;

	    }
	    else res = nodeMove; // B = A
	 
	}
	else res = nodeMove; // A = C

	return res;
	
	}

	protected double valAbs(double val){
	    if (val<0) return -val;
	    else return val;
	}
     public NamedObject initUserData(neuroml.core.Set parentset) { 
        Object[] ListObj;
        NamedObject po;
        int temp,i;         
        if(element instanceof neuroml.model.network.Network)
        {
             po = (SubNetwork)NeuromlSys.makeNeuromlObject("SubNetwork");
        }
        else if(element instanceof neuroml.model.cell.AbstractNeuron)
        {
             po = (RealPopulation)NeuromlSys.makeNeuromlObject("RealPopulation");
        }
        else if(element instanceof neuroml.model.network.Probe)
        {
             po = (Probe)NeuromlSys.makeNeuromlObject("Probe");
        }
        else
        {
            System.out.println("What do I need to create ? ->PopulationNode");
            po=null;
        }
	/*
         * If element set... make a ref to it
	 */
        if(po instanceof ElementRef){
            if (elementRef != null) {
                ((ElementRef)po).elementClass.setTargetName( elementRef );
            } else {   
                ((ElementRef)po).elementClass.setTargetName( "notset" );
            }
        }
       if(FirstAddition)
        {          
            if(!parentset.isEmpty())
            {
                ListObj=parentset.toArray();
                Count=0;
                for(i=0;i<ListObj.length;i++)
                {
                    temp=StartSet(((NamedObject)(ListObj[i])).getName());
                    if(temp>=Count) Count=temp+1;
                }
            }
            FirstAddition=false;
        }
	if (element !=null) {
            String str=element.getName();
 //           str=str.substring(str.lastIndexOf('.'));
            po.setName(str+Count);
	} else {
            po.setName("population"+Count);
	}
        Count++;
	po.editorInfo = this;
	parentset.addElement( po ); 
	setData( po );
	setParentSet( parentset );	
        return po;
     }
     
    /** Make an instance of the Neuroml model object */
    public void initUserData( Environment env, neuroml.core.Set parentset, String path ) { 
        NamedObject po;
	System.out.println("Adding a population... path "+path);
        po = initUserData(parentset);
	env.getNamespace().addRef( path+"."+po.getName(), po );	    
    }

    /** Set the element reference + object
     */
    public void setElement(String r, Element e) {
	elementRef = r;
	element = e;
    }

    /** Deal with async image plotting */
    public boolean imageUpdate(Image img, int f, int x, int y, int w, int h ) {
	if ((f & ImageObserver.ALLBITS) !=0) {
	    System.out.println("Image: done it all!"+f);
	    //	    rerender();
	    //	    repaint();
	    return false;
	} else {
	    return true;
	}
    }

    /** Draw this node 
     */
    public void draw( Graphics2D g ) {
        RGBColour colour;
	Font f = font;
        boolean selected=false;
	String msg=getName();
        if(this==BasicClickablePoint.EmphasizedPoint){
            colour=new RGBColour("-ffcd");
            selected=true;
        }
        else 
            colour=this.colour;
        Object Param=HaveDrawingParameter();
        if(Param!=null)
        {
		((BasicRunnableCellFactory)Param).draw(g,getData(), getX(), getY(), getWidth(), getHeight(), msg, selected, f);
		return;                
        }
        
            
	int sw = g.getFontMetrics(f).stringWidth(msg);
	int sh = g.getFontMetrics(f).getHeight();
	g.setFont(f);
	
       
        
        if (getData() instanceof SubNetwork||(element!=null&&element instanceof neuroml.model.network.Network)) {
            double SIZE=getHeight();
            if(SIZE>getWidth()) SIZE=getWidth();        
            BasicStroke stroke = new BasicStroke(2.0f);
            g.setStroke(stroke);
            g.setColor(Color.DARK_GRAY);
            double[] Xs;
            double[] Ys;
            Xs=new double[4];
            Ys=new double[4];
        
            Xs[0]=getX();
            Ys[0]=getY()-getHeight()*0.5+SIZE*0.1;
            Xs[1]=getX()-getWidth()*0.5+SIZE*0.1;
            Ys[1]=getY();        
            Xs[2]=getX()+getWidth()*0.5-SIZE*0.1;
            Ys[2]=getY();                
            Xs[3]=getX();
            Ys[3]=getY()+getHeight()*0.5-SIZE*0.1;        
            for(int i=0;i<4;i++){
                for(int j=i+1;j<4;j++){
                    g.draw(new Line2D.Double(Xs[i],Ys[i],Xs[j],Ys[j]));
                }
            }
            String machin;
            if(element==null)
                machin=((SubNetwork)getData()).elementClass.getTargetName();
            else 
                machin=element.getName();
          
            Color[] arrayColor;
            arrayColor=new Color[4];
            int length=machin.length();
            for(int l=0;l<4;l++)
            {
                if(l>=length)
                    arrayColor[l]=createColor(l);
                else
                    arrayColor[l]=createColor((int)machin.charAt(length-1-l));
                
            }
                
            g.setColor(Color.white); 
            g.setStroke(new BasicStroke(1.0f));
            if(selected) g.draw( new RoundRectangle2D.Double(  getX()-getWidth()*0.5, getY()-getHeight()*0.5, getWidth(), getHeight(),getWidth()*0.2, getHeight()*0.2) );
            //g.setColor(Color.RED);
            g.setColor(arrayColor[0]);
            g.fill(new Ellipse2D.Double( getX()-SIZE*0.1,  getY()-getHeight()*0.5, SIZE*0.2,SIZE*0.2));
            //g.setColor(Color.BLUE);
            g.setColor(arrayColor[1]);
            g.fill(new Ellipse2D.Double( getX()-getWidth()*0.5,  getY()-SIZE*0.1, SIZE*0.2,SIZE*0.2));
            g.setColor(arrayColor[2]);
            //g.setColor(Color.GREEN);
            g.fill(new Ellipse2D.Double( getX()+getWidth()*0.5-SIZE*0.2,getY()-SIZE*0.1, SIZE*0.2,SIZE*0.2));
           // g.setColor(new Color(that[3]));
            //g.setColor(Color.YELLOW);
            g.setColor(arrayColor[3]);
            g.fill(new Ellipse2D.Double( getX()-SIZE*0.1,  getY()+getHeight()*0.5-SIZE*0.2, SIZE*0.2,SIZE*0.2));
        }
        else{
            int shadow = 4;


            
            
            g.setColor(colour.getColor().darker());
            g.fill( new RoundRectangle2D.Double( getX0()+shadow, getY0()+shadow, getWidth(), getHeight(),
					     getWidth()*0.2, getHeight()*0.2) );

            
//            g.setColor(colour.getColor()); 
            if(TextureDisplay&&!selected){
                Graphics2D gi;
                TexturePaint gradient;
                if(elementImage==null)
                     BuildTexture();
                if(colour.value.compareTo("-df25e0")==0){
                    gi = bi_LightGreen.createGraphics();
                    if (elementImage!=null)
                    gi.drawImage(elementImage, 0,0, this);                
                    gradient = new TexturePaint(bi_LightGreen,new Rectangle2D.Double(getX0(),getY0(),getWidth(),getHeight()));
                }
                else if(data !=null && data instanceof Probe)
                {
                    gi = bi_Blue.createGraphics();
                    if (elementImage!=null)
                    gi.drawImage(elementImage, 0,0, this);                
                    gradient = new TexturePaint(bi_Blue,new Rectangle2D.Double(getX0(),getY0(),getWidth(),getHeight()));
                }
                else
                {
                    gi = bi.createGraphics();
                    if (elementImage!=null)
                    gi.drawImage(elementImage, 0,0, this);                
                    gradient = new TexturePaint(bi,new Rectangle2D.Double(getX0(),getY0(),getWidth(),getHeight()));
                }
                
                g.setPaint(gradient);
            }
            else
                g.setColor(colour.getColor()); 
            g.fill( new RoundRectangle2D.Double( getX0(), getY0(), getWidth(), getHeight(),
					     getWidth()*0.2, getHeight()*0.2) );
        }
        
        
        
        
        
        
        
	g.setColor(Color.white); // Should be foreground!!
	g.drawString(msg, (float)(getX() - sw/2), (float)(getY() - getHeight()/4));


	// Here we draw something about the element of the population...
	// Should it just access the population.elementClass instead???
	// IF it's a ModuleNeuron, deRef --> module --> imageUrl --> image --> plot it! 



	Object d = getData();
	if (d instanceof Population) { // Maybe it's a named object...

	    // OK, now draw something about the structure...
	    Population p = (Population)getData();
	    if (p!=null) {
		// OK, maybe draw something about the element...
		Namespace ns = SpecialEditors.getEnvironment().getNamespace();
		Object el = ns.deRef( p.elementClass );
		if (el instanceof ModuleNeuron) {
		    if (elementImage == null) {
			try {
			    ModuleNeuron mn = (ModuleNeuron) el;
			    ModuleRef mr = mn.module;
/*MODULE--JAG			    Ref m = mr.module;
			    Module mod = (Module) ( ns.deRef(m) );
			    String imgUrl = mod.imageUrl;

			    if (imgUrl.equals("")) elementImage = null;
			    else {
				ImageIcon ii = BrowseModulesPanel.getScaledIcon(imgUrl);                              

                                ImageIcon ii1 = new ImageIcon( ii.getImage().getScaledInstance( 32,32,Image.SCALE_SMOOTH));

                                elementImage  = ii1.getImage();
			    }MODULE--JAG*/
			} catch (Exception e) {
			    System.out.println("Something went wrong with getting ModuleNeuron image "+e);
			}
		    } 
		    if (elementImage!=null){
			AffineTransform it = new AffineTransform();
			it.translate( getX(), getY() );
			g.drawImage(elementImage, it, this);
		    }
		} else {
		    // System.out.println("element class "+p.elementClass+" not ModuleNeuron :(");
		}
                if(p instanceof RealPopulation)
                {
                    PopulationStructure ps = ((RealPopulation)p).structure;
                    if (ps instanceof Grid1DStructure) {
                        int sz = ((Grid1DStructure)ps).size;
                        if (sz > 50)
                            g.drawString("size="+sz,
				     (float)getX() - sw/2, (float)getY() +sh*1.5f);
                         else {
                            double x0 = getX0();
                            double y0 = getY0();
                            double spc  = getWidth() / (sz*2);
                            double dotw = spc/4;
                            for (int i=0; i<sz; i++) {
                                g.fill( new Ellipse2D.Double( getX()-(getWidth()/4)+i*spc - dotw/2,
							  y0+sh*1.5-dotw/2, dotw, dotw) );
                            }
                        }//if sz
		    // Draw dots?
		    // This is where hase had StateParams, NVParams &c...
                    } else if (ps instanceof Grid3DStructure) {
                        int xs = ((Grid3DStructure)ps).xsize;
                        int ys = ((Grid3DStructure)ps).ysize;
                        int zs = ((Grid3DStructure)ps).zsize;
                        if ((xs*ys*zs < 500) && (xs*ys*zs>0)) {
			// Draw v simple 3D rendition...
                            double x0 = getX0();
                            double y0 = getY0();
                            double xspc = getWidth() / (xs*2);
                            double yspc = getHeight() / (ys*2);
                            double zxspc = getWidth()  / (zs*10);
                            double zyspc =  getHeight() / (zs*10);
                            double dotw = xspc/4;
                            double doth = yspc/4;
                            if (dotw > doth) { dotw = doth; } else { doth = dotw; }
                            for (int i=0; i<xs; i++) {
                                double xp = getX()-(getWidth()/4)+i*xspc;
                                for (int j=0; j<ys; j++) {
                                    double yp = y0+sh*1.5+j*yspc+doth/2;
                                    for (int k=0; k<zs; k++) {
                                        g.fill( new Ellipse2D.Double( xp + zxspc*k - dotw/2,
								  yp + zyspc*k - doth/2, dotw, doth) );
                                    }
                                }
                            }//for int i
                        } else {
                            g.drawString("size=["+
				     ((Grid3DStructure)ps).xsize+","+
				     ((Grid3DStructure)ps).ysize+","+
				     ((Grid3DStructure)ps).zsize+"]",
				     (float)getX() - sw/2, (float)getY() +sh*1.5f);
                        } //xz yz
                    } else if (ps instanceof IndexedStructure) {
                        g.drawString("index ndims=["+
				 ((IndexedStructure)ps).ndims+"]",
				 (float)getX() - sw/2, (float)getY() +sh*1.5f);
                    }
                }//RealPopulation
	    }
	}
    }
 
    public Node duplicate(double xpix, double ypix) { 
	PopulationNode ret = new PopulationNode(cx,cy, xsize, ysize, colour);
	ret.setElement( elementRef, element );
	return ret;
    }
  

    public String toString() { return "PopulationNode "+getName()+" at "+cx+" "+cy; }
    
    private double[] MoveLink( boolean Start, ControlPoint[] linkPoint, double dx, double dy) 
    {
        double Xdir1,Ydir1,Xdir2,Ydir2;
        double to_return[];
        to_return=new double[2];
        int pt1,pt2;
        if(!Start){
            Xdir1= ((ControlPoint)(linkPoint[linkPoint.length-1])).cx-((ControlPoint)(linkPoint[linkPoint.length-2])).cx;
            Ydir1= ((ControlPoint)(linkPoint[linkPoint.length-1])).cy-((ControlPoint)(linkPoint[linkPoint.length-2])).cy;
            Xdir2= ((ControlPoint)(linkPoint[linkPoint.length-3])).cx-((ControlPoint)(linkPoint[linkPoint.length-2])).cx;
            Ydir2= ((ControlPoint)(linkPoint[linkPoint.length-3])).cy-((ControlPoint)(linkPoint[linkPoint.length-2])).cy;            
            pt2=linkPoint.length-3;            
            pt1=linkPoint.length-1;
        }
        else{
            Xdir1= ((ControlPoint)(linkPoint[0])).cx-((ControlPoint)(linkPoint[1])).cx;
            Ydir1= ((ControlPoint)(linkPoint[0])).cy-((ControlPoint)(linkPoint[1])).cy;
            Xdir2= ((ControlPoint)(linkPoint[2])).cx-((ControlPoint)(linkPoint[1])).cx;
            Ydir2= ((ControlPoint)(linkPoint[2])).cy-((ControlPoint)(linkPoint[1])).cy;
            pt2=2;            
            pt1=0;            
        }
        double d,e;
        if(Xdir1<0.001 &&Xdir1>-0.001 ){
            Ydir1=1.0;
            Xdir1=0.0;
            d=((ControlPoint)(linkPoint[pt1])).cx+dx;
        }
        else{
            Ydir1=-Ydir1/Xdir1;
            Xdir1=1.0;
            d=((ControlPoint)(linkPoint[pt1])).cy+dy+Ydir1*(((ControlPoint)(linkPoint[pt1])).cx+dx);
        }
        if(Xdir2<0.001 &&Xdir2>-0.001 ){
            Ydir2=1.0;
            Xdir2=0.0;
            e=((ControlPoint)(linkPoint[pt2])).cx;
        }        
        else{
            Ydir2=-Ydir2/Xdir2;
            Xdir2=1.0;
            e=((ControlPoint)(linkPoint[pt2])).cy+Ydir2*((ControlPoint)(linkPoint[pt2])).cx;
        }
        double det=-Ydir2*Xdir1+Ydir1*Xdir2;
        double det2=det*det/((Ydir2*Ydir2+Xdir2*Xdir2)*(Ydir1*Ydir1+Xdir1*Xdir1));
        if(det2<0.01)
        {
            to_return[0]=dx*0.5;///2
            to_return[1]=dy*0.5;////2
            return to_return;
        }
        det=1.0/det;
        
        //Just for this way
        int k=Start?-1:1;
        pt2+=k;
        //End just for this way
        to_return[0]=(( Xdir2*det*d-Xdir1*det*e -((ControlPoint)(linkPoint[pt2])).cx));
        to_return[1]=((-Ydir2*det*d+Ydir1*det*e -((ControlPoint)(linkPoint[pt2])).cy));
        
        return to_return;
    }
    
    private Object HaveDrawingParameter( ){
        Object d = getData();
	if (d instanceof Population) { // Maybe it's a named object...

	    // OK, now draw something about the structure...
	    Population p = (Population)getData();
	    if (p!=null) {
		// OK, maybe draw something about the element...
		Namespace ns = SpecialEditors.getEnvironment().getNamespace();
		Object el = ns.deRef( p.elementClass );
		if (el instanceof ModuleNeuron) {
                    Object Parameter=((ModuleNeuron)el).module;
                    if(Parameter==null||!(Parameter instanceof ModuleRef)) 
                        return null;
                    Parameter=((ModuleRef)Parameter).parameters;
                    if(Parameter==null||!(Parameter instanceof BasicRunnableCellFactory)) 
                        return null;
                    if(((ModuleNeuron)el).MeasureLists==null){
                        ((ModuleNeuron)el).MeasureLists=new MeasurementSet("ModuleMeasurement");//MeasurementTool
                        ((BasicRunnableCellFactory)Parameter).setFactory(((ModuleNeuron)el).MeasureLists, "models.CellModel.neurons."+((ModuleNeuron)el).getName());
                    }
                    else if(((ModuleNeuron)el).MeasureLists.size()==0){
                        ((ModuleNeuron)el).MeasureLists=new MeasurementSet("ModuleMeasurement");//MeasurementTool
                        ((BasicRunnableCellFactory)Parameter).setFactory(((ModuleNeuron)el).MeasureLists, "models.CellModel.neurons."+((ModuleNeuron)el).getName());                        
                    }
                    return Parameter;
                }
            }
        } else if (d!=null && d instanceof ModuleProbe) {
            Object Parameter=((ModuleProbe)d).module;
            if(Parameter==null||!(Parameter instanceof ModuleRef)) 
               return null;
            Parameter=((ModuleRef)Parameter).parameters;
            if(Parameter==null||!(Parameter instanceof BasicRunnableCellFactory)) 
               return null;
            return Parameter;
        }
        return null;
    }
    
    private Color createColor(int a)
    {
        int s=a%8;     
        if(s==0)
            return Color.BLUE;
        else if(s==1)
            return Color.CYAN;
        else if(s==2)
            return Color.GREEN;
        else if(s==3)
            return Color.MAGENTA;
        else if(s==4)
            return Color.ORANGE;
        else if(s==5)
            return Color.PINK;
        else if(s==6)
            return Color.RED;
        else 
            return Color.YELLOW;       
    }
    
    public static void setDisplayTexture(boolean Display){
        TextureDisplay=Display;
    } 
    
    private void BuildTexture(){
       java.net.URL myURL;
       Image FormerImage;
       elementImage=null;
       String str=NetworkDesigner.resources.getString("texture_green");
       myURL=PopulationNode.class.getResource(str);
       ImageIcon myIcon=new ImageIcon(myURL);
       elementImage  = myIcon.getImage();         
       int w_ = myIcon.getIconWidth(); int h_ = myIcon.getIconHeight();
       bi = new BufferedImage(w_, h_, BufferedImage.TYPE_INT_RGB);
       
       myURL=PopulationNode.class.getResource(NetworkDesigner.resources.getString("texture_light_green"));
       myIcon=new ImageIcon(myURL);
/*       FormerImage=elementImage;
       elementImage  = myIcon.getImage();*/
       w_ = myIcon.getIconWidth(); h_ = myIcon.getIconHeight();
       bi_LightGreen = new BufferedImage(w_, h_, BufferedImage.TYPE_INT_RGB);
       if(colour.value.compareTo("-df25e0")==0)
          elementImage  = myIcon.getImage();
       
       myURL=getClass().getResource(NetworkDesigner.resources.getString("texture_blue"));
       myIcon=new ImageIcon(myURL);
       
       w_ = myIcon.getIconWidth(); h_ = myIcon.getIconHeight();
       bi_Blue = new BufferedImage(w_, h_, BufferedImage.TYPE_INT_RGB);
       if(data!=null && data instanceof Probe)
          elementImage  = myIcon.getImage();
    }
}
