package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;

import neuroml.util.module.*;
import guikit.*;  
import java.lang.Math.*;


/** A projection link
 */
public class ProjectionLink extends Link {
    static int Count=0;
//    public Ref MySource,MyDest; 
    static boolean FirstAddition=true; 
    
    public ProjectionLink() {
	super();
    }
    public ProjectionLink(double x1, double y1, double cx, double cy, double x2, double y2, double w) {
	super( x1,y1,cx,cy,x2,y2,w );
    }
    public ProjectionLink(double x1, double y1, double x2, double y2, double w, RGBColour rc) {
	super( x1,y1,(x1+x2)/2,(y1+y2)/2, x2,y2,w,rc);
    }
    public ProjectionLink(double x1, double y1, double cx, double cy, double x2, double y2, double w, RGBColour rc) {
	super( x1,y1,cx,cy,x2,y2,w,rc);
    }

    /*
     * Somehow update the proj.source and dest references 
     */
    public void notifyTargetChanged(ClickablePoint child) { 
	// One of our control points has changed its target...
	ClickablePoint cp = child.getTarget();
	//System.out.println("Projection link told about change to "+child);
	if (cp instanceof Node) {
	    Node nd = (Node)cp;
	    // We've hit a node!!!
	    // Which clickable point is child??
	    Object d = getData();
	    if (d instanceof Projection) {
		Projection p = (Projection)d;
		int end = controls.getElements().indexOf(child);
		if (end==0) { // source
                    String NewName=((ElementRef)nd.getData()).getName();
                    if(NewName.compareTo(getRealTarget(p.source))!=0)          
                        p.source.setTargetName(netPanel.getPath()+".elements."+NewName);
		} else if (end==controls.getElements().size()-1) { // target
                    String NewName=((ElementRef)nd.getData()).getName();
                    if(NewName.compareTo(getRealTarget(p.dest))!=0)
                        p.dest.setTargetName(netPanel.getPath()+".elements."+NewName);
		} else {
		    System.out.println("end "+end+" not found"); 
		}
	    } 
            else if(d instanceof Attachment){
                Attachment p = (Attachment)d;
		int end = controls.getElements().indexOf(child);
		if (end==0) { // source
                    String NewName=((ElementRef)nd.getData()).getName();
                    if(NewName.compareTo(getRealTarget(p.source))!=0) {         
                        p.source.setTargetName(netPanel.getPath()+".elements."+NewName);
                        try{
                            Population pop=(Population)NeuromlSys.getNewestNamespace().deRef(p.source);
                            Object obj=NeuromlSys.getNewestNamespace().deRef(pop.elementClass);
                        
                            if (obj instanceof ModuleNeuron) {
                            	try {
                    		    ModuleNeuron mn = (ModuleNeuron) obj;
                        	    ModuleRef mr = mn.module; 
                                    
                                    PermanentSet truc=mn.getMeasurementList().Clone();
                                    if(truc!=null&&p.MeasurementList!=null&&truc.size()==p.MeasurementList.size())
                                    {
                                        boolean On=true;
                                        for(int i=0;i<truc.size()&&On;i++)
                                            if(truc.elementAt(i).getClass()!=p.MeasurementList.elementAt(i).getClass())
                                                On=false;
                                        if(!On)
                                             p.MeasurementList=truc;
                                    }
                                    else
                                        p.MeasurementList=truc;                                       
                                }
                                catch(Exception e){
                                }
                            }
                        }
                        catch(Exception excp){
                            
                        }
                    }
		} else if (end==controls.getElements().size()-1) { // target
                    String NewName=((Element)nd.getData()).getName();
                    if(NewName.compareTo(getRealTarget(p.dest))!=0)
                        p.dest.setTargetName(netPanel.getPath()+".probes."+NewName);
		} else {
		    System.out.println("end "+end+" not found"); 
		}
            }
            else { System.out.println("ProjLink has no projection or attachment"); }
	} else { System.out.println("target has no Node"); }
    }

    /** Make a projection
     */

    public void initUserData( Environment env, neuroml.core.Set parentset, String path, neuroml.core.Connector data) { 
        Connector pr = (Connector)NeuromlSys.makeNeuromlObject(data.getClass().getName());
        pr.copy(data);
        Object[] ListObj;
        int i,temp=0;

	setData(pr);
        if(FirstAddition)
        {   
            if(!parentset.isEmpty())
            {
                ListObj=parentset.toArray();
                Count=0;
                for(i=0;i<ListObj.length;i++)
                {
                    temp=StartSet(((Connector)(ListObj[i])).getName());
                    if(temp>=Count) Count=temp+1;
                }
            }
            FirstAddition=false;
        }
        pr.setName(data.getClass().getName()+Count);
        Count++;
	pr.editorInfo = this;

	parentset.addElement( pr );
        String str =pr.getName();
        str=str.substring(str.lastIndexOf('.')+1);
	setName(str);
	//setName(pr.getName());
	setParentSet( parentset );  
        init();
        env.getNamespace().addRef( path+"."+pr.getName(), pr );	
    }

    public Link duplicate() { 
	return new ProjectionLink(getX1(),getY1(),getX2(),getY2(),w, colour);
    }
    public String toString() { return "ProjectionLink "+getName()+" w "+w; }
    
    void init()
    {
           Object d = getData();
           NetEditPanel myPan=getLastPanel();
           Network myNet=myPan.getNetwork();
           
	   if (d instanceof Projection) {
		Projection p = (Projection)d;
                p.source=new TreeRef(myNet.elements);
                p.source.setContentClassName("Population"); //even if it is NOT a population
                p.dest=new TreeRef(myNet.elements);
                p.dest.setContentClassName("Population");
                ((TreeRef)p.source).addLeaf("RealPopulation");
                ((TreeRef)p.source).addNode("SubNetwork");
                ((TreeRef)p.dest).addLeaf("RealPopulation");
                ((TreeRef)p.dest).addNode("SubNetwork");
           }
           else if (d instanceof Attachment) {
		Attachment p = (Attachment)d;
                p.source=new TreeRef(myNet.elements);
                p.source.setContentClassName("Population"); //even if it is NOT a population
                p.dest=new Ref("Probe");
                ((TreeRef)p.source).addLeaf("RealPopulation");
                ((TreeRef)p.source).addNode("SubNetwork");            
           }
    }
    
    protected String getRealTarget(Ref Target)
    {
        int i,j;
        String TempString=new String(netPanel.getPath()+".elements.");
        String ThatTarget=Target.getTargetName();
        i=ThatTarget.length();
        j=TempString.length();
        if(i>j)
        {
            TempString=ThatTarget.substring(j);
            i=TempString.indexOf(".");
            if(i>=0) TempString=TempString.substring(0,i);
            return TempString;
        }
        else return new String();
    }

    private void IconsDrawing(Graphics2D g){
        Connector d = (Connector)getData();   
        boolean ProjAtt;
        if (d==null) return;
	if (d instanceof GeneralProjection) 
            ProjAtt=true;
        else if (d instanceof ModuleAttachment)
            ProjAtt=false;
        else
            return;
        double[] point;
        Object Parameter;
        if(ProjAtt)
            Parameter=((GeneralProjection)d).sourceMethod.parameters;
        else
            Parameter=((ModuleAttachment)d).sourceMethod.parameters;
        
        if(Parameter!=null&&Parameter instanceof neuroml.sim.run.SourceMethod){
             point=PointThere(0.25);
             ((neuroml.sim.run.SourceMethod)Parameter).Draw(g,point[0],point[1]);
        }
        if(ProjAtt)
            Parameter=((GeneralProjection)d).destMethod.parameters;
        else
            Parameter=((ModuleAttachment)d).destMethod.parameters;
        
        if(Parameter!=null&&Parameter instanceof neuroml.sim.run.DestMethod){
             point=PointThere(0.75);
             ((neuroml.sim.run.DestMethod)Parameter).Draw(g,point[0],point[1]);
        }        
    }
     protected void drawName(Graphics2D g){
         IconsDrawing(g);
         super.drawName(g);
     }
    
    
}
