package guikit;
 
import neuroml.model.network.*;
import neuroml.model.cell.AbstractNeuron;
import neuroml.core.*;
import neuroml.sim.*;

import neuroml.util.*;
import neuroml.*;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;



/*
 * Subnet editor - popup an editor for a sub network
 */
public class SubnetsEditor extends EditPanel implements Editor, ElementChangedListener, ActionListener{

    protected NameNode name;
    protected JPanel menuPanel;
    protected NetPanel panel;
    protected JComponent NetworksPanel;//NetworksPanel_General
    protected JPanel Top,Bottom;
    protected JComponent jtp;    
    protected JFrame ed=null;
    //protected boolean Grid=true;  
    protected NetworkPkg netPkg;
    protected Network n=null;
    protected JPanel Buttons;
    protected JPanel namep;
    protected JPanel MainNetPanel;

    protected JPanel SidePanel=null;  
    protected Dimension NormalSideDimension=null;
    
    public SubnetsEditor() {
        ed=new JFrame();
        
    }
    public SubnetsEditor(Object o) {
        super();
        ed=null;
        editObject(o);
    }
    
    public SubnetsEditor(Object o, String path, ElementChangedListener ecl) {
        super();
        ed=null;
        editObject(o,path,ecl);
    }
        
    String path="models.pkg1";

    ElementChangedListener notifyParent = null;
    
    /** Add notification of parent */
    public void addElementChangedListener( ElementChangedListener p ) {
	notifyParent = p;
    }

    public void setPath( String p ) { path = p; }
       
    protected void BuildGUI(){       
        setLayout( new BorderLayout());
        if(BuildTop()!=null)
            add(Top,BorderLayout.NORTH); //ed.getContentPane().
        if(BuildBottom()!=null)
            add(Bottom,BorderLayout.CENTER); //ed.getContentPane().       
        validate();

      
        if(ed!=null){
            ed.getContentPane().add(this);
            ed.pack();
            ed.setVisible(false);
        }
    }
    
    protected JPanel BuildMenuPanel(){
        menuPanel=new JPanel();
        return menuPanel;
    }
    protected JPanel BuildNetworkName(){
           if(n!=null){
            String str=n.getName();
            str=str.substring(str.lastIndexOf('.'));
            name = new NameNode( n, n.getName() );
            namep = new JPanel();
            
            namep.add(new JLabel(str  ));
            namep.setPreferredSize(new Dimension(128,32));
            //namep.setPreferredSize(new Dimension(64,32),new Dimension(64,32));
            return namep;
        }
         else return null;
    }
    
    protected JPanel BuildNetworksPanel(){
      JPanel stuff=new JPanel();
        NetworksPanel = new JPanel();      
        stuff.add(NetworksPanel);
        NetworksPanel.setPreferredSize(new Dimension(360, 120));
        return stuff;    
    }   
    
    protected JPanel BuildNetEditPanel(){
        Environment env = SpecialEditors.getEnvironment();
        if(n!=null){
            panel=new NetEditPanel(env,n,path+".networks."+n.getName());
           // ((NetEditPanel)panel).VisibleGrid=Grid;
        }
        else
            panel=new NetPanel();
        panel.setPreferredSize(new Dimension(720,350));        
        return panel;
    }  
    protected JComponent BuildJTP(){
        jtp=new JPanel(new GridBagLayout());
        
        GridBagConstraints c = new GridBagConstraints();        
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridy = 0;        

        c.gridx = 0;
        c.weightx = 2;
            
        if(BuildNetworksPanel()!=null)
            ((JPanel)jtp).add(NetworksPanel.getParent(),c);
        c.gridx = 2;
        c.weightx = 1;
        if(BuildButtons()!=null)
            ((JPanel)jtp).add(Buttons,c);
        return jtp;
    }
    
    protected JPanel BuildTop(){
        Top=new JPanel(new BorderLayout());       
        if(BuildJTP()!=null)
            Top.add(jtp,BorderLayout.CENTER);
        return Top;
    }
    
    protected JPanel BuildBottom(){
        Bottom=new JPanel(new BorderLayout());
        if(BuildNetEditPanel()!=null)
           Bottom.add(panel,BorderLayout.CENTER); 
        return Bottom;
    }    
    protected JPanel BuildButtons(){
        Buttons=new JPanel();
        Buttons.setLayout(new GridLayout(0,1)); 
        JPanel B1_Panel=new JPanel();
        JButton B1=new JButton("Cleaning Wizzard");
        B1.setPreferredSize(new Dimension(144,32));
	B1.addActionListener(this);
	B1.setActionCommand("Clean");
        B1.getAccessibleContext().setAccessibleDescription("get the network automatically layed out"); 
        B1_Panel.add(B1);
        B1_Panel.setPreferredSize(new Dimension(100, 32));
        B1_Panel.setLayout(new GridBagLayout());
        
        
        JCheckBox chk1 = new JCheckBox("Block Diagrams");
        chk1.setPreferredSize(new Dimension(100, 32));
        chk1.setSelected(Link.Block);
        chk1.addActionListener(this);
        chk1.setActionCommand("Block");
        chk1.getAccessibleContext().setAccessibleDescription("Big arrows"); 
        
        JPanel B2_Panel=new JPanel();
        B2_Panel.setLayout(new GridBagLayout());
        
        JCheckBox chk2 = new JCheckBox("Display grid");
        chk2.setPreferredSize(new Dimension(100, 32));
        chk2.setSelected(NetEditPanel.VisibleGrid);
        chk2.addActionListener(this);
        chk2.setActionCommand("Grid");
        chk2.getAccessibleContext().setAccessibleDescription("Enable/disable the display of the grid"); 
        JCheckBox chk3 = new JCheckBox("Display textures");
        chk3.setPreferredSize(new Dimension(100, 32));
        chk3.setSelected(NetEditPanel.getDisplayTexture());
        chk3.addActionListener(this);
        chk3.setActionCommand("Texture");
        chk3.getAccessibleContext().setAccessibleDescription("Enable/disable the display of textures on the grid"); 

        GridBagConstraints c = new GridBagConstraints();        
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;       
        c.gridx = 0;
        c.gridy = 0;
        B2_Panel.add(chk1,c);
        c.gridx = 0;
        c.gridy = 1;
        B2_Panel.add(chk2,c);
        c.gridx = 0;
        c.gridy = 2;        
        B2_Panel.add(chk3,c);
        
        Buttons.add(B1_Panel);
        Buttons.add(B2_Panel);
        Buttons.setBorder( BorderFactory.createTitledBorder("Display options") );
        Buttons.setPreferredSize(new Dimension(160, 158));
        return Buttons;
    }    
    
    public void editObject( Object o ) {
	editObject(o,null);
    }

    public void editObject( Object o, ElementChangedListener ecl ) {
	editObject( o, "models", ecl );
    }

    public void editObject(Object o, String path, ElementChangedListener ecl) {
        
	//System.out.println("SubnetEditor path="+path);
	notifyParent = ecl;
	setPath(path);
        Enumeration enum_;
        Hashtable refs;
        Hashtable objs;
        int totalelement=0;

        if (o instanceof NetworkPkg) {
	    netPkg = (NetworkPkg)o;       
            
            if(netPkg.networks.size()>0){
                Object value=FindNetwork(netPkg.MainNetwork.getTargetName());
                if(value==null) 
                    value = (Network)netPkg.networks.elementAt(0);
                if(value instanceof Network)
                    n=(Network)value;
                else{
                    System.out.println("The first element of the network package should be a network.");
                    return;
                }
            }
            else{              
            }   
            BuildGUI();
            
	}
    }

    protected Network FindNetwork(String MainNetworkName){
        if(MainNetworkName==null) 
            return null;     
        Environment env = SpecialEditors.getEnvironment();
        Namespace ns = env.getNamespace();
	Hashtable refs = ns.getReferences();	 
	Hashtable objs = (Hashtable) refs.get("Network");
                  
        Vector ListElements=new Vector(1,1);
        if(objs!=null) {
	   for( Enumeration enum_ = objs.keys() ; enum_.hasMoreElements() ;) {
               String k = (String)enum_.nextElement();
               if(k.compareTo(MainNetworkName)==0)
                   return (Network) (objs.get(k));
           }
        }
        return null;
    }    
    
    public void startMain() {
    }
    
    public JPanel editObjectPanel(Object o, String path, ElementChangedListener ecl) {
        return null;
    }    
       
    public void elementChanged(Object oldn, Object newn) {
        
        if(oldn instanceof String&&((String)oldn).startsWith("NetworksPanel_General")){ 
           if(newn==null||newn instanceof Network)
                ChangeCurrentNetwork((Network)newn);    
        }
        else{ 
            Environment env = SpecialEditors.getEnvironment();
            if (newn instanceof String) {
                    
                    ((NetEditPanel)panel).setPath(path+".networks."+newn);
                    env.getNamespace().rename(path+".networks."+oldn, path+".networks."+newn);
                notifyParent.elementChanged( n,n );
            }
            
            
        }
    }
    
    /*
     * Listen to text field changes
     */
    
    public void confirmElementChanged(Object oldn, Object newn) {
    }        
    
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("Clean")) {
            GridReshaper stuff;
            try{
                URL[] urlsToLoadFrom = new URL[]{new URL("file:./Reshaper.jar")};//was"\\" // "C:\\GuiKit\\MyCVS\\guikit\\guikit\\ReshapeNetwork\\"
                URLClassLoader loader1 = new URLClassLoader(urlsToLoadFrom); 
                Class cls1 = Class.forName("ReshapeNetwork.JarInspectorReshaper", true, loader1); 
                 stuff=(GridReshaper)(cls1.newInstance());
                 stuff.Reshape(n,(NetEditPanel)panel);
                
            }
            catch(Exception except){
                System.out.println("No class");
            }
        }
        else  if (e.getActionCommand().equals("Block")) {
            JCheckBox truc=(JCheckBox)(e.getSource());
            Link.Block=truc.isSelected();
            panel.rerender();
            panel.repaint();
        }
        else  if (e.getActionCommand().equals("Grid")) {
            JCheckBox truc=(JCheckBox)(e.getSource());
            if(panel instanceof NetEditPanel){
                NetEditPanel.VisibleGrid=truc.isSelected();//Grid=
                panel.rerender();
                panel.repaint();
            }
        }
        else  if (e.getActionCommand().equals("Texture")) {
            JCheckBox truc=(JCheckBox)(e.getSource());
            boolean truc_boolean=truc.isSelected();
            NetEditPanel.setDisplayTexture(truc_boolean);
            PopulationNode.setDisplayTexture(truc_boolean);
            if(panel instanceof NetEditPanel){
                panel.rerender();
                panel.repaint();
            }
            if(menuPanel instanceof MenuPanel){
                ((MenuPanel)menuPanel).rerender();
                ((MenuPanel)menuPanel).repaint();
            }
        }
        else{
            System.out.println("Unknown command");
        }                 
    }
    
    public void ChangeCurrentNetwork(Network Net){
        if(n!=null){
            NetworksPanel.getParent().remove(namep);
        }
        n=Net;
        BuildNetworkName();
        if(Net!=null) 
            NetworksPanel.getParent().add(namep,BorderLayout.NORTH);
        NetworksPanel.getParent().repaint();            
        NetworksPanel.getParent().getParent().repaint();
        Bottom.remove(panel);
        BuildNetEditPanel();
        Bottom.add(panel);
        panel.rerender();
        Bottom.validate();                
    }
    
    public void DisplaySide(JPanel stuff){
        if(SidePanel!=null)
            Bottom.remove(SidePanel);
        int wdt=stuff.getPreferredSize().width;
        Rectangle rect=Bottom.getBounds();
        Bottom.setPreferredSize(new Dimension(rect.width,rect.height));
        panel.setPreferredSize(new Dimension(rect.width-wdt,rect.height)); 
        stuff.setPreferredSize(new Dimension(wdt,rect.height)); 
 
        rect=Top.getBounds();
        
        SidePanel=stuff;
        Bottom.add(SidePanel,BorderLayout.EAST);
        if(panel!=null && panel instanceof NetPanel) 
            ((NetPanel)panel).rerender();
        Bottom.validate();
    }
    
    public void Expand(){
        
        if(panel==null||SidePanel==null||!SidePanel.isVisible()) return;
        panel.setVisible(false);
        if(SidePanel!=null && SidePanel instanceof JPanel) {
            if(NormalSideDimension==null)
                NormalSideDimension=SidePanel.getSize();
            SidePanel.setPreferredSize(Bottom.getSize());
            SidePanel.repaint();
        }
        Bottom.validate();
        Bottom.repaint();      
    }
    public void Reduce(){
        if(panel==null) return;
        panel.setVisible(true);
        if(SidePanel!=null && SidePanel instanceof JPanel) {
            if(NormalSideDimension!=null)
                SidePanel.setPreferredSize(NormalSideDimension);
            NormalSideDimension=null;
        }
        SidePanel.repaint();
        Bottom.validate();
        Bottom.repaint();    
    }
    
    public void HideSide(){
        if(SidePanel==null) return;
        SidePanel.setVisible(false);
        if(panel!=null && panel instanceof NetPanel) {
            Rectangle rect=Bottom.getBounds();
            NormalSideDimension=null;
            panel.setVisible(true);
            panel.setPreferredSize(new Dimension(rect.width,rect.height));
            ((NetPanel)panel).rerender();
        }
        Bottom.validate();
        Bottom.repaint();
    }
}
