/*
 * SubNetsEditor_Animation.java
 *
 * Created on 25 May 2004, 14:23
 */

package guikit;
import neuroml.model.network.*;
import neuroml.model.cell.AbstractNeuron;
import neuroml.core.*;
import neuroml.sim.*;
import neuroml.sim.run.*;
import neuroml.util.*;
import neuroml.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import nmlplay.PlayerCallBack;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class SubnetsEditor_Animation extends SubnetsEditor implements TreeSelectionListener {
    Random rnd=null;   
    JTree TreeNet;
    Hashtable SubNetworkTree;//=new Hashtable()
    PlayerCallBack myNMLPlayer;
    JTabbedPane jtp;
    Panel Chose;

    /** Creates a new instance of SubNetsEditor_Animation */
    public SubnetsEditor_Animation() {
        super();
    }
    private void init(){
        path="MAIN";
        if(panel!= null)
            if(panel instanceof NetEditPanel )
                ((NetEditPanel)panel).setPath(path);
    }
    
    public SubnetsEditor_Animation(Object o) {
        super(o);
    }
    
    public SubnetsEditor_Animation(Object o, String path, ElementChangedListener ecl) {
        super(o,path,ecl);
       
    }
    public SubnetsEditor_Animation(Object o, String path, ElementChangedListener ecl,PlayerCallBack stuff) {
        super(o,path,ecl);
        myNMLPlayer=stuff;
        SetRendering();
    }
    protected void SetRendering(){
        Vector in=new Vector();
        Vector down=new Vector();
        Vector up=new Vector();
        if(netPkg==null||netPkg.MainNetwork==null||netPkg.MainNetwork.getTargetName()==null)
            return;
        String str1=this.netPkg.MainNetwork.getTargetName().substring(this.netPkg.MainNetwork.getTargetName().lastIndexOf('.')+1)+".";
        if(super.path.compareTo("MAIN")!=0)
        {
             str1+=super.path.substring(super.path.indexOf('.')+1)+".";
        }
        //Put the real populations of the current layer in a vector
        for(int i=0;i<n.elements.size();i++)
        {
            Population p=(Population)(n.elements.elementAt(i));
            String str=str1.toString();
            if(p instanceof RealPopulation){
                str+=p.getName(); 
                in.add(str);
            } 
        }
        //Put the populations in inferior layers connected to elements INSIDE this layer into another vector
        for(int i=0;i<n.projections.size();i++)
        {
            Projection p=(Projection)(n.projections.elementAt(i));
            String str = p.dest.getTargetName();
            str=str.substring(str.lastIndexOf("elements.")+9);
           
            String str2 = p.source.getTargetName();
            str2=str2.substring(str2.lastIndexOf("elements.")+9);
             if(str.lastIndexOf('.')>0&&str2.lastIndexOf('.')<=0){
                str=str1+str;
                if(!(down.contains(str)))
                    down.add(str);
            }
            if(str2.lastIndexOf('.')>0&&str.lastIndexOf('.')<=0){
                str2=str1+str2;
                if(!(down.contains(str2)))
                    down.add(str2);
            }
        }
        //Put the populations in superior layers connected to elements INSIDE this layer into another vector
        Network myNet;
        myNet=FindNetwork(netPkg.MainNetwork.getTargetName());
        String NetPath=myNet.getName()+".";
        while(NetPath.compareTo(str1)!=0)
        {
                int size=myNet.projections.size();
                for(int j=0;j<size;j++){
                    Projection p=(Projection)(myNet.projections.elementAt(j));
                    String str = p.dest.getTargetName();
                    str=str.substring(str.lastIndexOf("elements.")+9);
           
                    String str2 = p.source.getTargetName();
                    str2=str2.substring(str2.lastIndexOf("elements.")+9);
                    if(str.lastIndexOf('.')>0){
                        if(in.contains(NetPath+str)&&!up.contains(NetPath+str2))
                            up.add(NetPath+str2);
                    }
                    if(str2.lastIndexOf('.')>0){
                        if(in.contains(NetPath+str2)&&!up.contains(NetPath+str))
                            up.add(NetPath+str);                    
                    }
                }
                
                size=myNet.elements.size();
                for(int j=0;j<size;j++){
                    Object ThatElem=myNet.elements.elementAt(j);
                    if(ThatElem instanceof SubNetwork){
                        String str=((SubNetwork)ThatElem).getName();
                        if(str1.startsWith(new String(NetPath+str+"."))){
                            j=size;
                            NetPath=NetPath+str+".";
                            myNet=FindNetwork(((SubNetwork)ThatElem).elementClass.getTargetName());
                        }
                    }
                }                            
        }
        
        neosim.renderer.NetvisCtrl myStuff=(neosim.renderer.NetvisCtrl)(myNMLPlayer.getRendering());
        if(myStuff==null){
            myStuff=new neosim.renderer.NetvisCtrl(in,up,down);
            myNMLPlayer.SetRendering(myStuff);    
        }
        else myStuff.setVectors(in,up,down);
    }
    public JPanel buildProbeRendering(String str){
        String str2=netPkg.MainNetwork.getTargetName();
        str2=new String(str2.substring(str2.lastIndexOf(".networks.")+10)+"."+str);
        return myNMLPlayer.buildProbeRendering(str2);
    }
    
    protected JPanel BuildNetworksPanel(){
        init();
        DefaultMutableTreeNode top=BuildRecursive(netPkg.MainNetwork.getTargetName(),"MAIN");
        JPanel stuff=new JPanel(new GridLayout());
        NetworksPanel = new JPanel();      

        TreeNet=new JTree(top);
        TreeNet.addTreeSelectionListener(this);
        /*if(NodeToSelect!=null)
            TreeNet.setSelectionPath(new TreePath(NodeToSelect.getPath()));*/
        int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
        int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
        
        NetworksPanel = new JScrollPane(TreeNet,v,h);
        
      //  NetworksPanel.add(TreeNet);
        stuff.add(NetworksPanel);
        stuff.setBorder( BorderFactory.createTitledBorder("Network Navigation : "+n.getName()) );
        NetworksPanel.setPreferredSize(new Dimension(300, 150));
        return stuff;    
    } 
   
    
    protected DefaultMutableTreeNode BuildRecursive(String NetworkName, String Name){
        Network n=FindNetwork(NetworkName);
        if(n==null){
            System.out.println("Did not find "+NetworkName+" in SubnetsEditor_Animation.BuildRecursive JAG");
            return null;
        }
        DefaultMutableTreeNode top = new DefaultMutableTreeNode(Name);
        if(SubNetworkTree==null)
            SubNetworkTree=new Hashtable();
        SubNetworkTree.put(Name,top);
        int size=n.elements.size();
        for(int i=0;i<size;i++){
            Object myelem=n.elements.elementAt(i);
            if(myelem instanceof SubNetwork){
                top.add(BuildRecursive(((SubNetwork)myelem).elementClass.getTargetName(),Name+"."+((SubNetwork)myelem).getName()));
            }
        }
        return top;
    }   
    
   public void valueChanged(TreeSelectionEvent e) {
        //Network n=this.n;        
        Network n=FindNetwork(netPkg.MainNetwork.getTargetName());
        ChangeCurrentNetwork(n);
        //if(notifyParent!=null) notifyParent.elementChanged(ThatNode,ThatNode);
    }
   
    public void ChangeCurrentNetwork(Network Net){

        String selection=TreeNet.getLastSelectedPathComponent().toString();
        path = TreeNet.getLastSelectedPathComponent().toString();

        if(selection.compareTo("MAIN")==0){
            Net=FindNetwork(netPkg.MainNetwork.getTargetName());
        }
        else{
            String prefix;
            Object ThatElem;
            int i=0,j; 
            int size;
            while(i>-1){
                i=selection.indexOf('.');//lastIndex
                if(i>-1){
                    prefix=selection.substring(0,i);
                    selection=selection.substring(i+1);
                }
                else
                    prefix=selection;
                
                size=Net.elements.size();
                for(j=0;j<size;j++){
                    ThatElem=Net.elements.elementAt(j);
                    if(ThatElem instanceof SubNetwork){
                        if(((SubNetwork)ThatElem).getName().compareTo(prefix)==0){
                            Net=FindNetwork(((SubNetwork)ThatElem).elementClass.getTargetName());
                        }
                    }
                }                
            }
        }        
        
        n=Net;
        ((JPanel)(NetworksPanel.getParent())).setBorder( BorderFactory.createTitledBorder("Network Navigation : "+n.getName()) );
        
        jtp.remove(panel);
        jtp.remove(Chose);
        BuildNetEditPanel();
        jtp.add("2D",panel);
        jtp.add("3D",Chose);
        panel.rerender();
        Bottom.validate();

        HideSide();
        SetRendering();
    }
    

    
    protected JPanel BuildNetEditPanel(){
        Environment env = SpecialEditors.getEnvironment();
        if(n!=null){
            panel=new NetEditPanel_Animation(env,n,path,this );
        }
        else
            panel=new NetPanel();
        panel.setPreferredSize(new Dimension(720,350));        
        return panel;
    } 
    
    public void SetSelection(String path){
        DefaultMutableTreeNode NodeToSelect =  (DefaultMutableTreeNode)SubNetworkTree.get(path);
       
        if(NodeToSelect!=null)
            TreeNet.setSelectionPath(new TreePath(NodeToSelect.getPath()));
//        Network n=this.n;  
//        ChangeCurrentNetwork(n);
    }
   
    protected JPanel BuildBottom(){
        Bottom=new JPanel(new BorderLayout());
        
        jtp=new JTabbedPane();
        if(BuildNetEditPanel()!=null)
           jtp.add("2D",panel);        
        Chose=new Panel();
        jtp.add("3D",Chose); 
        neosim.renderer.AnimWindow.setPanel(Chose);
        //Chose.setLayout(new GridBadLayout());

        Bottom.add(jtp,BorderLayout.CENTER);
        return Bottom;
    }    
    
    
    public void SetRendering(RunnableControl path){
        if(myNMLPlayer==null)
            return;
        myNMLPlayer.SetRendering(path);
    }
    
    public void setActiveWindow(int i){
        jtp.setSelectedIndex(i);
    }
}
