package guikit;
 
import neuroml.model.network.*;
import neuroml.model.cell.AbstractNeuron;
import neuroml.core.*;
import neuroml.sim.*;
import neuroml.util.*;
import neuroml.*;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;



/*
 * Subnet editor - popup an editor for a sub network
 */
public class SubnetsEditor_GuiKit extends SubnetsEditor {

     int xsz = 85;
     int xspc = 20;
     int ysz = 50;
     int yspc = 20;
     int projl = 85;
     Random rnd=null;     
     protected JPanel SidePanel=null;
     protected JPanel First;

            
    public SubnetsEditor_GuiKit() {
        super();
    }
    public SubnetsEditor_GuiKit(Object o) {
        super(o);
        menuPanel.setVisible(false);
    }    
    
    public SubnetsEditor_GuiKit(Object o, String path, ElementChangedListener ecl) {
        super(o,path,ecl);
        menuPanel.setVisible(false);
    }
   
    protected JPanel BuildMenuPanel(){
        Enumeration enum_;
        Hashtable refs;
        Hashtable objs;
        menuPanel=new MenuPanel();
        menuPanel.setPreferredSize(new Dimension(512,192));	              
	PopulationNode pn1 =  new PopulationNode(0.0,  0.0, xsz, ysz, new RGBColour("-fe9fff") );
        
       // pn1.setData( new NamedObject("NewPop") );
        
        AbstractNeuron muchetruc=new AbstractNeuron("NewPop");
        RealPopulation p=new RealPopulation("NewPop");
	pn1.setData(p);
        p.elementClass.setTargetName(muchetruc.getClass().getName());
        ((Grid1DStructure)p.structure).size=0;
        pn1.setElement(muchetruc.getClass().getName(),muchetruc);
        
	((MenuPanel)menuPanel).addNode( pn1 );
        
        
        PopulationNode pn12 =  new PopulationNode(0.0,  0.0, xsz, ysz, new RGBColour("-cccc01") );
	
        
        //pn12.setData( new NamedObject("NewProbe") );
        
        Probe trucmuche=new Probe("NewProbe");
        pn12.setData(trucmuche);
        pn12.setElement(trucmuche.getClass().getName(),trucmuche);
        
        ((MenuPanel)menuPanel).addNode( pn12 );
        
        
	Environment env = SpecialEditors.getEnvironment();
	Namespace ns = env.getNamespace();
	refs = ns.getReferences();	 
	objs = (Hashtable) refs.get("Element");
                  
            Vector ListElements=new Vector(1,1);
             
            if (objs!=null) {
		for ( enum_ = objs.keys() ; enum_.hasMoreElements() ;) {
                    String k = (String)enum_.nextElement();
		    Element element = (Element) (objs.get(k));
                    if(element instanceof Network||element instanceof AbstractNeuron)
                    {
                        PopulationNode pn = new PopulationNode( 0.0,  0.0, xsz, ysz,
							    new RGBColour("-df25e0") );	

                        //PREVIOUS
                        Population po = (Population)NeuromlSys.makeNeuromlObject("Population");
                        po.setName(Namespace.getShortClassName(element.getName()));
                        if (k != null) {
                            po.elementClass.setTargetName( k );
                      //      po.elementClass.setContentClassName(element.getClass().getName());
                        }
                        pn.setData( po );
                        pn.setElement(k, element); 
                        
                        //NEW
                  /*  pn.setData(element);
                      pn.setElement(k, element);*/

                        ((MenuPanel)menuPanel).addNode( pn );
                    }
		}
	    } 
            else {
		System.out.println("Couldn't find any Elements ns "+ns);
	    }
	    Link l1 = new ProjectionLink(0.0, 0.0, projl, 0.0, 5, 
					 new RGBColour("-f3f3a5"));
            Projection pr=new Projection("Projection");
            l1.setData(pr);
	    ((MenuPanel)menuPanel).addLink( l1 );
            Link l2 = new ProjectionLink(0.0, 0.0, projl, 0.0, 5, 
					 new RGBColour("-100"));
            Attachment pr2=new Attachment("Attachment");
            l2.setData(pr2);
	    ((MenuPanel)menuPanel).addLink( l2 );
            
            if(n!=null)
                ((MenuPanel)menuPanel).setNetPanel((NetEditPanel)panel);         
            ((MenuPanel)menuPanel).organize();
        return menuPanel;
    }    
    public void ChangeCurrentNetwork(Network Net){
        super.ChangeCurrentNetwork(Net);
        Top.remove(menuPanel);
        BuildMenuPanel();
        Top.add(menuPanel,BorderLayout.CENTER);
        panel.rerender();
        Top.validate();  
        HideSide();   
    }
    
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getActionCommand().equals("Block")) {
            ((MenuPanel)menuPanel).rerender();
            ((MenuPanel)menuPanel).repaint();
        }        
    }
    
    public void elementChanged(Object oldn, Object newn) {
        if(oldn instanceof String&&((String)oldn).startsWith("NetworksPanel_General")){ 
           if(newn==null||newn instanceof Network)
                ChangeCurrentNetwork((Network)newn);
           if(n!=null)
                ((MenuPanel)menuPanel).setNetPanel((NetEditPanel)panel);
        }
        else{ 
            Environment env = SpecialEditors.getEnvironment();
            if (newn instanceof String) {
                ((NetEditPanel)panel).setPath(path+".networks."+newn);
                env.getNamespace().rename(path+".networks."+oldn, path+".networks."+newn);
                First.remove(this.MainNetPanel);
                if(this.BuildMainNetPanel()!=null)
                {
                    GridBagConstraints c=new GridBagConstraints();
                    c.fill = GridBagConstraints.BOTH;
                    c.gridwidth = 1;
                    c.gridheight = 1;
                    c.gridy = 0;                        
                    c.gridx =13;
                    c.weightx = 6;
                    First.add(MainNetPanel,c);
                }
                First.validate();
                notifyParent.elementChanged( n,n );

                ((MenuPanel)menuPanel).organize(); 
                 ((MenuPanel)menuPanel).rerender();
                 ((MenuPanel)menuPanel).repaint();  
                 ((NetEditPanel)panel).rerender();
                 ((NetEditPanel)panel).repaint();                   
            }            
        }
    }

    protected JPanel BuildNetworkName(){
         if(n!=null){
            name = new NameNode( n, n.getName() );
            namep = new EditStringPanel( name );
            ((EditStringPanel)namep).setElementChangedListener(this);
            return namep;
        }
         else return null;
    }
    
    protected JPanel BuildNetworksPanel(){
        JPanel stuff=new JPanel();
        stuff.setLayout(new BorderLayout());       
        
        if(BuildNetworkName()!=null){
            stuff.add(namep,BorderLayout.NORTH);
        }
        ObjectNode on = new ObjectNode(netPkg,"networks");
        /*if(n!=null)
            on.setPath(path+".networks."+n.getName());
        else
            on.setPath(path+".networks");*/
         on.setPath(path+".networks");
        
	Environment env = SpecialEditors.getEnvironment();
	Namespace ns = env.getNamespace();
        NetworksPanel = new NetworksPanel_General(ns, on,this);      
        notifyParent=(ElementChangedListener)NetworksPanel;
        stuff.add(NetworksPanel,BorderLayout.CENTER);
        return stuff;
    }       
    
    protected JPanel BuildMainNetPanel(){
        ObjectNode on = new ObjectNode(netPkg,"MainNetwork"); 
        on.setPath("",".MainNetwork"); 
	Environment env = SpecialEditors.getEnvironment();
	Namespace ns = env.getNamespace();
        MainNetPanel=new EditRefPanel(ns, on); 
        MainNetPanel.setBorder( BorderFactory.createTitledBorder("Select the Main Network") );
        return MainNetPanel;
    }  
    
    public void DisplaySide(JPanel stuff){
        if(SidePanel!=null)
            Bottom.remove(SidePanel);
        int wdt=stuff.getPreferredSize().width;
        Rectangle rect=Bottom.getBounds();
        Bottom.setPreferredSize(new Dimension(rect.width,rect.height));
        panel.setPreferredSize(new Dimension(rect.width-wdt,rect.height)); 
        stuff.setPreferredSize(new Dimension(wdt,rect.height)); 
 
        rect=Top.getBounds();
        
        SidePanel=stuff;
        Bottom.add(SidePanel,BorderLayout.EAST);
        if(panel!=null && panel instanceof NetPanel) 
            ((NetPanel)panel).rerender();
        if(menuPanel!=null && menuPanel instanceof NetPanel) 
            ((NetPanel)menuPanel).rerender();
        Top.validate();
        Bottom.validate();

    }
    public void HideSide(){
        if(SidePanel==null) return;
        SidePanel.setVisible(false);
        if(panel!=null && panel instanceof NetPanel) {
            Rectangle rect=Bottom.getBounds();
            int d=0;;
            if(menuPanel!=null){
                d=menuPanel.getPreferredSize().width;
                ((MenuPanel)menuPanel).organize();
                ((MenuPanel)menuPanel).rerender();
                menuPanel.repaint();
            }
            panel.setPreferredSize(new Dimension(rect.width-d,rect.height));
            ((NetPanel)panel).rerender();
        }
        Bottom.validate();
        Bottom.repaint();
    }    
    public void addProjection(Connector pr){
        if(rnd==null){
            Date stuff=new Date();
            rnd=new Random(stuff.getTime());
        }
        if(((MenuPanel)menuPanel).ContainProjectionType(pr)) return;

        Link l1 = new ProjectionLink(0, 0, projl, 0, 5,  new RGBColour(new String(""+rnd.nextInt(16777215))));
        
        l1.setData(pr);
        int Count = BasicClickablePoint.StartSet(l1.getName());
        String str;
        if(Count<0)
            str=new String("");
        else
            str=new String("_"+Count);
        l1.setName(pr.TypeName()+str);
	((MenuPanel)menuPanel).addLink( l1 );

        ((MenuPanel)menuPanel).organize();
        ((MenuPanel)menuPanel).rerender();
        ((MenuPanel)menuPanel).repaint();
    }    
    protected JPanel BuildNetEditPanel(){
        Environment env = SpecialEditors.getEnvironment();
        if(n!=null){
            panel=new NetEditPanel_GuiKit(env,n,path+".networks."+n.getName(),this );
//            ((NetEditPanel)panel).VisibleGrid=Grid;
        }
        else
            panel=new NetPanel();
        panel.setPreferredSize(new Dimension(720,350));        
        return panel;
    }      
    
    protected JComponent BuildJTP(){
        jtp=new JTabbedPane();
        First=new JPanel(new GridBagLayout()); //new GridLayout(0,3));
        First.setPreferredSize(new Dimension(720, 180));
        GridBagConstraints c = new GridBagConstraints();        
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridy = 0;        

        
        if(BuildNetworksPanel()!=null){
            c.gridx = 0;
            c.weightx = 9;
            First.add(NetworksPanel.getParent(),c);
            NetworksPanel.setPreferredSize(new Dimension(360, 120));
        }
        if(BuildButtons()!=null){
            Buttons.setPreferredSize(new Dimension(160, 158));
            c.gridx = 9;
            c.weightx = 4;
            First.add(Buttons,c);
        }
        if(this.BuildMainNetPanel()!=null)
        {
            c.gridx =13;
            c.weightx = 6;
            First.add(MainNetPanel,c);
        }
        ((JTabbedPane)jtp).add("Network Design",First);
        return jtp;
    } 
    
   /* protected JPanel BuildMainNetPanel(){
        MainNetPanel=new JPanel();
        JLabel stuff=new JLabel(netPkg.MainNetwork.getTargetName());
        stuff.setPreferredSize( new Dimension(100, 32));
	stuff.setMinimumSize( new Dimension(10, 32));// For resizing
        MainNetPanel.setBorder( BorderFactory.createTitledBorder("Select the Main Network") );
        MainNetPanel.add(stuff);
        return MainNetPanel;
    }  */
    
   protected JPanel BuildTop(){
        Top=new JPanel(new BorderLayout());
        if(BuildMenuPanel()!=null)
            Top.add(menuPanel,BorderLayout.CENTER);
        if(BuildJTP()!=null)
            Top.add(jtp,BorderLayout.EAST);
        return Top;
    }
}
