/*
 * HHNeuron.java
 *
 * Created on 26 August 2004, 13:44
 */

package Holger_modules.module.RealNeuron;
import neuroml.util.module.*;
import neuroml.sim.run.SpikeSender;
import neuroml.sim.state.PopulationState;
import neuroml.sim.run.RunnableCellFactory;
import Holger_modules.module.channels.*;
import neuroml.model.Synapse_nml.*;
import Holger_modules.datatypes.*;
import neuroml.model.MeasurementTool.*;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 * Will need to be able to get a synapse from the position of the cell connection
 *
 */
public class RealNeuron extends HHNeuron implements SynapticCell {
    /**
     * The array containing the synapses 
     */
     protected Synapse[] ArraySynapse=new Synapse[0];
    /**
     * The array containing the connection index
     */     
     protected int[] ArrayConnectionSynapse=new int[0];
    /**
     * The key is a Synapse class, the element is an array of the index of the Synapse in the ArraySynapse 
     */
     protected Hashtable ArrayClassSynapse = new Hashtable();
     
     protected SynapticCurrent InternalIntensity=new SynapticCurrent(0.0d);

     public RealNeuron(RunnableCellFactory runnablecellfactory, PopulationState populationstate, int id, int index, SpikeSender spikesender, double IniV)
     {
        super(runnablecellfactory,populationstate,id,index,spikesender,IniV);
     }
     
     /*public void setMeasured(boolean measurement){
     }*/
     public final boolean advance(){
        double dt=((BasicChannelCellFactory)factory).dt;
         if(!stable||!formerStable){
            stable=true;
            for(int i=0;i<Channels.length;i++){
                 boolean muche=Channels[i].advance(v, dt);
                 stable&=muche;
            }
         }
         stable&=ExternalIntensity.advance(dt);

     //    double FormerInternalIntensity=InternalIntensity.doubleValue();
         /*for( Enumeration enum_ = SynapseArray.elements() ; enum_.hasMoreElements() ;) {
             ((Synapse)(enum_.nextElement())).advance(dt);
         } */        
        for(int k=0;k<ArraySynapse.length;k++)         
            ArraySynapse[k].advance(dt);
         t += dt;
        /*  double diff=(InternalIntensity.doubleValue()-FormerInternalIntensity)*1000;
          if(diff<0||diff>2*FormerInternalIntensity)
            stable=false;*/
          return false;
     }
     
    public final void handleSpike(double d, int i)
    {
        int k=-1;
        boolean found = false;
        for(k=0;k<ArrayConnectionSynapse.length&&!found;k++)
            if(ArrayConnectionSynapse[k]==i)
                found = true;
        if(found){
            k-=1;
            ArraySynapse[k].handleSpike(d, ((BasicChannelCellFactory)factory).dt);
            stable=false;
            formerStable=false;            
        }
    }
     
    public final void checkSpiking(){
        double gap=dv-OldDv;
        if(myTool_Size>0){
            if(gap>gap_time||-gap>gap_time){
                //                  BEFORE
                //curve.addPoint(new Double(t),new Double(v-0.065));
                Measure(t);
            }
        }
        OldDv=dv;
       
        if(!spiking){
            if(dv>gap_time)
                spiking=true;
        }
        else if(dv<=0){
             if(v>minTrigger){
                out.sendSpike(t, (short)1); //send spikes on port 1...  
                for( int m = 0 ; m<ArraySynapse.length;m++) {
                    ArraySynapse[m].CheckLearning(t,((BasicChannelCellFactory)factory).dt);
                }                
                if(myTool_Size>0){
                    //BEFORE
                    //curve.addPoint(new Double(t),new Double(v-0.065));
                    //out.send(curve, t, 1);
                    int j=0;
                    for(Enumeration enum_= myTool.CollectionList.keys();enum_.hasMoreElements();j++){
                        Object o=enum_.nextElement();
                        Short k=(Short)o;
                        Object obj=myTool.CollectionList.get(o);
                        out.send(curve[j], t, k.shortValue()); //send list curve
                    }
                    //BEFORE
                    //curve = new Curve();
                     curve  = new ListCurve[myTool_Size];//myTool.CollectionList.size()]; 
                     int i = 0;
                     for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); i++){
                        Object o=enum_.nextElement();
                        if(o instanceof int[]){
                            int IntArray[]=((int[])o);
                            curve[i]=new ListCurve(IntArray.length);
                        }
                     }                    
                     Measure(t);
                }
             }
             spiking=false;
        }
        if(myTool_Size==0)
            return;
        if(Counter==((HHNeuronFactory)this.factory).pointsPerCurve){
            Counter=0;
            //BEFORE
            //curve.addPoint(new Double(t),new Double(v-0.065));
            //out.send(curve, t, 2);
            //curve = new Curve();
            int j=0;
            for(Enumeration enum_= myTool.CollectionList.keys();enum_.hasMoreElements();j++){
                 Object o=enum_.nextElement();
                 Short k=(Short)o;
                 Object obj=myTool.CollectionList.get(o);
                 out.send(curve[j], t, k.shortValue()); //send list curve
            }      
                    //curve = new Curve();
            curve  = new ListCurve[myTool_Size];//myTool.CollectionList.size()]; 
            int i = 0;
            for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); i++){
                  Object o=enum_.nextElement();
                  if(o instanceof int[]){
                       int IntArray[]=((int[])o);
                       curve[i]=new ListCurve(IntArray.length);
                  }
             }                    
                    //curve.addPoint(new Double(t),new Double(v));
             Measure(t);            
        }
        Counter++;
    }
     
     public final void addSynapse(Synapse myNewSynapse, int SendingNeuronId) {
        myNewSynapse.setCurrent(this.InternalIntensity);
        ArraySynapse=AddToArraySynapse(ArraySynapse, myNewSynapse);
        ArrayConnectionSynapse=AddToArrayInt(this.ArrayConnectionSynapse, SendingNeuronId);
        int[] arraytruc=(int[])ArrayClassSynapse.get(myNewSynapse.getClass());
        if(arraytruc==null){
            arraytruc=new int[0];
            ArrayClassSynapse.put(myNewSynapse.getClass(), arraytruc);
        }
        ArrayClassSynapse.remove(myNewSynapse.getClass());
        arraytruc=AddToArrayInt(arraytruc, ArrayConnectionSynapse.length-1);
        ArrayClassSynapse.put(myNewSynapse.getClass(), arraytruc);
     }
     
    public final double getInternalCurrent(){
        double InternalIntensity=ExternalIntensity.getValue(t)+this.InternalIntensity.getValue(); //ExternalIntensity_.getExternalIntensity(t,this.index);
        FormerInternalIntensity-=InternalIntensity;//arbitrary
        if(FormerInternalIntensity>1e-18||FormerInternalIntensity<-1e-18)
            stable=false;
        else
            stable=true;
        FormerInternalIntensity=InternalIntensity;
        return InternalIntensity;
    }     
    
    /*Need to get a synapse by position*/
    
    public final Synapse getSynapse(int i) {
       // Vector truc=(Vector)((NeosimEntityImpl)out).getInConnections(-1);//-1 since the parameter does not matter
        return ArraySynapse[i];
        
    }
    
    public final Synapse[] getSynapses() {
        return ArraySynapse;
    }
    
    public final Vector getSynapses(Class ClassName) {
        Vector truc=new Vector();
        try{
            for(Enumeration enum_=ArrayClassSynapse.keys();enum_.hasMoreElements();){
                Class cls=(Class)enum_.nextElement();
                if(ClassName.isAssignableFrom(cls))
                    truc.add(ArrayClassSynapse.get(cls));
            }
        }
        catch(Exception except){
            System.out.println("Exception "+this.getClass().getName()+" ->getSynapses");
        }
        return truc;
    }
    
    public final Synapse getSynapse(int i, Class ClassName) {
        Vector truc=new Vector();
        try{
            for(Enumeration enum_=ArrayClassSynapse.keys();enum_.hasMoreElements();){
                Class cls=(Class)enum_.nextElement();
                if(ClassName.isAssignableFrom(cls))
                    truc.add(ArrayClassSynapse.get(cls));
            }
        }
        catch(Exception except){
            System.out.println("Exception "+this.getClass().getName()+" ->getSynapses");
        }        
        int size=truc.size();
        for(int k=0;k<size;k++){
            int[] chose=(int[])truc.elementAt(k);
            if(chose.length>i){
                int m=chose[i];
                return ArraySynapse[m];
            }
            else
                i-=chose.length;
        }
        return null;
    }
    
    public final double getIntensitySynapse(int i) {
        return ArraySynapse[i].getSynapseIntensity();
    }
    
    public final double getIntensitySynapse(int i, Class ClassName) {
        Vector truc=new Vector();
        try{
            for(Enumeration enum_=ArrayClassSynapse.keys();enum_.hasMoreElements();){
                Class cls=(Class)enum_.nextElement();
                if(ClassName.isAssignableFrom(cls))
                    truc.add(ArrayClassSynapse.get(cls));
            }
        }
        catch(Exception except){
            System.out.println("Exception "+this.getClass().getName()+" ->getSynapses");
        }        
        int size=truc.size();
        for(int k=0;k<size;k++){
            int[] chose=(int[])truc.elementAt(k);
            if(chose.length>i){
                int m=chose[i];
                return ArraySynapse[m].getSynapseIntensity();
            }
            else
                i-=chose.length;
        }
        return -1e35;
    }
    
    public final double getAverageIntensitySynapse() {
        double result=0;
        for(int i=0;i<ArraySynapse.length;i++)
            result=ArraySynapse[i].getSynapseIntensity();
        if(ArraySynapse.length!=0)    
            return result/ArraySynapse.length;
        else
            return -1e35;
    }
    
    public final double getAverageIntensitySynapse(Class ClassName) {
        Vector truc=new Vector();
        try{
            for(Enumeration enum_=ArrayClassSynapse.keys();enum_.hasMoreElements();){
                Class cls=(Class)enum_.nextElement();
                if(ClassName.isAssignableFrom(cls))
                    truc.add(ArrayClassSynapse.get(cls));
            }
        }
        catch(Exception except){
            System.out.println("Exception "+this.getClass().getName()+" ->getSynapses");
        }
        int size=truc.size();
        double result=0;
        int NbItems=0;
        for(int k=0;k<size;k++){
            int[] chose=(int[])truc.elementAt(k);  
            NbItems+=chose.length;
            for(int m=0;m<chose.length;m++)
                result+=ArraySynapse[chose[m]].getSynapseIntensity();
        }
        if(NbItems!=0)    
            return result/NbItems;
        else
            return -1e35;           
    }
    protected final int[] AddToArrayInt(int[] array, int obj){
        int[] array2=new int[array.length+1];
        for(int i=0;i<array.length;i++)
            array2[i]=array[i];
        array2[array.length]=obj;
        return array2;
    }
    
    protected final Synapse[] AddToArraySynapse(Synapse[] array, Synapse obj){
        Synapse[] array2=new Synapse[array.length+1];
        for(int i=0;i<array.length;i++)
            array2[i]=array[i];
        array2[array.length]=obj;
        return array2;
    }
}
