/*
 * HHNeuron.java
 *
 * Created on 26 August 2004, 13:44
 */

package Holger_modules.module.channels;
import neuroml.util.module.*;
import neuroml.sim.run.SpikeSender;
import neuroml.sim.state.PopulationState;
import neuroml.sim.run.RunnableCellFactory;
import Holger_modules.datatypes.*;
import neuroml.model.MeasurementTool.*;
import java.util.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class HHNeuron extends BasicChannelCell {
     protected ListCurve curve[]  ;//= new Curve()
     protected double OldDv=0.0;
     protected int Counter=0;

     public HHNeuron(RunnableCellFactory runnablecellfactory, PopulationState populationstate, int id, int index, SpikeSender spikesender, double IniV)
     {
        super(runnablecellfactory,populationstate,id,index,spikesender,IniV);
     }
     
     public final void setMeasured(MeasurementCollection MeasurementList){
        super.setMeasured(MeasurementList);
        curve  = new ListCurve[myTool_Size];//myTool.CollectionList.size()]; 
        int i = 0;
        for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); i++){
            Object o=enum_.nextElement();
            if(o instanceof int[]){
                int IntArray[]=((int[])o);
                curve[i]=new ListCurve(IntArray.length);
            }
        }
        Measure(t);         
    }
     public void checkSpiking(){
        double gap=dv-OldDv;
        if(myTool_Size>0){
            if(gap>gap_time||-gap>gap_time){
	             Measure(t);  
            }
        }
        OldDv=dv;
       
        if(!spiking){
            if(dv>gap_time)
                spiking=true;
        }
        else if(dv<=0){
             if(v>minTrigger){
                out.sendSpike(t, (short)1); //send spikes on port 1...  
                if(myTool_Size>0){
                    int j=0;
                    for(Enumeration enum_= myTool.CollectionList.keys();enum_.hasMoreElements();j++){
                        Object o=enum_.nextElement();
                        Short k=(Short)o;
                        Object obj=myTool.CollectionList.get(o);
                        out.send(curve[j], t, k.shortValue()); //send list curve
                    }
                    
                    //curve = new Curve();
                    curve  = new ListCurve[myTool_Size];//myTool.CollectionList.size()]; 
                    int i = 0;
                    for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); i++){
                        Object o=enum_.nextElement();
                        if(o instanceof int[]){
                            int IntArray[]=((int[])o);
                            curve[i]=new ListCurve(IntArray.length);
                        }
                    }                    
                    //curve.addPoint(new Double(t),new Double(v));
                    Measure(t);
                }
             }
             spiking=false;
        }
        if(myTool_Size==0)
            return;
        if(Counter==((HHNeuronFactory)this.factory).pointsPerCurve){
            Counter=0;
//                  BEFORE            
/*            curve.addPoint(new Double(t),new Double(v-0.065));
            out.send(curve, t, 2);
            curve = new Curve();        */    
            int j=0;
            for(Enumeration enum_= myTool.CollectionList.keys();enum_.hasMoreElements();j++){
                 Object o=enum_.nextElement();
                 Short k=(Short)o;
                 Object obj=myTool.CollectionList.get(o);
                 out.send(curve[j], t, k.shortValue()); //send list curve
            }
                    
                    //curve = new Curve();
            curve  = new ListCurve[myTool_Size];//myTool.CollectionList.size()]; 
            int i = 0;
            for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); i++){
                  Object o=enum_.nextElement();
                  if(o instanceof int[]){
                       int IntArray[]=((int[])o);
                       curve[i]=new ListCurve(IntArray.length);
                  }
             }                    
                    //curve.addPoint(new Double(t),new Double(v));
             Measure(t);            
        }
        Counter++;
    }
     
    public final void Measure(double t){
        double[] ArrayDouble=myTool.Measure(this,t);
        int j=0;
        for(Enumeration enum_= myTool.CollectionList.elements();enum_.hasMoreElements(); j++){
             Object o=enum_.nextElement();
             if(o instanceof int[]){
                 int IntArray[]=((int[])o);
                 for(int i=0;i<IntArray.length;i++)
                     ((Curve)(curve[j].CurveList.elementAt(i))).addPoint(t,ArrayDouble[IntArray[i]]);
             }
        }
    }     
    
    public final double getVoltage(double t){
        return (v-0.065); 
    }    
    
}
