/*
 * KChannel.java
 *
 * Created on 24 August 2004, 13:53
 */

package Holger_modules.module.channels;
import neuroml.model.ions_channel.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */


public final class KChannel implements Channel {
    public double Conductance=360; //120 mS/cm2
    public double RestingPotential=-0.012; 
    protected double n=0.0d;

    /** Creates a new instance of KChannel */
    public KChannel() {  
    }
    
    public Channel Clone() {
        KChannel stuff=new KChannel();
        stuff.Conductance=Conductance;
        stuff.RestingPotential=RestingPotential;
        stuff.n=n;
        return stuff;
    }
    
    public boolean advance(double VoltageSoma, double dt) {
        double AlphaN,BetaN,ratesum;
        AlphaN=(100-10000*VoltageSoma)/(java.lang.Math.exp(1-100*VoltageSoma)-1);
        BetaN=125*java.lang.Math.exp(-12.5*VoltageSoma);
        ratesum = AlphaN + BetaN;
        double dn=(AlphaN/ratesum - n) * (1 - java.lang.Math.exp(-ratesum*dt) );
        n+=dn;
        double dndt=dn/dt;
        /**arbitrary, should be in a factory*/
        if(dndt<0.001&&dndt>-0.001)
            return true;
        else
            return false;
    }
    
    public double getChannelCurrent(double VoltageSoma){
        double n2=n*n;
        return Conductance*n2*n2*(VoltageSoma-RestingPotential);
    }
    
    public double get_h() {
        return -1d; //irrelevant
    }    
   
    public double get_mORn() {
        return n;
    }    
   
}
