/*
 * NaChannel.java
 *
 * Created on 24 August 2004, 13:53
 */

package Holger_modules.module.channels;
import neuroml.model.ions_channel.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class NaChannel implements Channel {
    public double Conductance=1200; //120 mS/cm2
    public double RestingPotential=0.115;
    protected double m=0.0d,h=0.0d;
    /** Creates a new instance of NaChannel */
    public NaChannel() {
    }
    
    public Channel Clone() {
        NaChannel stuff = new NaChannel();
        stuff.Conductance=Conductance;
        stuff.RestingPotential=RestingPotential;
        stuff.h=h;
        stuff.m=m;
        return stuff;
    }
    
    public boolean advance(double VoltageSoma, double dt) {
        double AlphaM,BetaM,AlphaH,BetaH,ratesum;       
        AlphaM=(2500-100000*VoltageSoma)/(java.lang.Math.exp(2.5-100*VoltageSoma)-1);
        BetaM=4000*java.lang.Math.exp(-55.55*VoltageSoma);
        AlphaH=70*java.lang.Math.exp(-50*VoltageSoma);
        BetaH=1000/(java.lang.Math.exp(3-100*VoltageSoma)+1);
        ratesum=AlphaM+BetaM;
        double dm=(AlphaM/ratesum - m) * (1 - java.lang.Math.exp(-ratesum*dt)) ;
        m+=dm;
        ratesum=AlphaH+BetaH;
        double dh=(AlphaH/ratesum - h) * (1 - java.lang.Math.exp(-ratesum*dt)) ;
        h+=dh;
        double dmdt=dm/dt,dhdt=dh/dt;
        /**arbitrary, should be in a factory*/
        if(dmdt<0.001&&dmdt>-0.001&&dhdt<0.001&&dhdt>-0.001)
            return true;
        else
            return false;     
        //double dm=((2.5-0.1*1000*VoltageSoma)/(java.lang.Math.exp(2.5-0.1*1000*VoltageSoma)-1)*(1-m)-4*java.lang.Math.exp(1000*VoltageSoma/-18)*m)*dt;
        //double dh=(0.07*java.lang.Math.exp(1000*VoltageSoma/-20)*(1-h)-1/(java.lang.Math.exp(3-0.1*1000*VoltageSoma)+1)*h)*dt;
        //double dm=AlphaM*(1-m)-BetaM*dt;
        //double dh=AlphaH*(1-h)-BetaH*dt;
        //m+=dm;
        //h+=dh;  
    }
    
    public double getChannelCurrent(double VoltageSoma) {
        return Conductance*m*m*m*h*(VoltageSoma-RestingPotential);
    }
    
    public double get_h() {
        return h; 
    }    

    public double get_mORn() {
        return m; 
    }    
    
}
