/*
 * ProbeCtrlPanel.java
 *
 * Created on 01 June 2004, 18:32
 */

package Holger_modules.module.multiprobe;
import java.awt.*;
import java.awt.event.*;
import java.io.PrintStream;
import java.util.*;
import javax.accessibility.AccessibleContext;
import javax.swing.*;
import neuroml.sim.run.PlusMinusPanel;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class ProbeCtrlPanel extends javax.swing.JPanel implements PlusMinusPanel, ActionListener{
    
    /** Creates a new instance of ProbeCtrlPanel */
    public ProbeCtrlPanel(ProbeCtrl probectrl, String s, int i, int j, int k) {
        super();
        setBorder(BorderFactory.createTitledBorder(s));
        ctrl = probectrl;
        setLayout(null);
//        createMenu();

        setPreferredSize(new Dimension(j, k));
        setVisible(true);
        panels = new JComponent[i];
        vSize = new int[i];
    }
    
    public void Expand(){
        System.out.println("Expand");
    }
    
    public void Reduce(){
        System.out.println("Reduce");        
    }
    
    protected void layoutPanels()
    {
        Dimension dimension = getSize();
        Insets insets = getInsets();
        int i = dimension.height - (insets.bottom + insets.top);
        int j = dimension.width - (insets.left + insets.right);
        int k = insets.top;
        for(int l = 0; l < panels.length; l++)
        {
            int i1 = (int)((double)(vSize[l] * i) / 100D);
            if(panels[l] != null)
                panels[l].setBounds(insets.left, k, j, i1);
            k += i1;
        }

    }

    protected void setProbePanel(JComponent jpanel, int i, int j)
    {
        try
        {
            panels[j] = jpanel;
            vSize[j] = i;
            jpanel.setVisible(true);
            add(jpanel);
            jpanel.addMouseListener(new MouseAdapter() {

                public void mouseClicked(MouseEvent mouseevent)
                {
                    int k = mouseevent.getModifiers();
                    if((k & 4) != 0)
                    {
                        JPopupMenu jpopupmenu = new JPopupMenu();
                        final MouseEvent me = mouseevent;
                        JMenuItem jmenuitem = new JMenuItem("Fit data");
                        jmenuitem.addActionListener(new ActionListener() {

                            public void actionPerformed(ActionEvent actionevent)
                            {
                                ctrl.fitData((JPanel)me.getComponent());
                            }

                        });
                        jpopupmenu.add(jmenuitem);
                        JMenuItem jmenuitem1 = new JMenuItem("Align other diagrams");
                        jmenuitem1.addActionListener(new ActionListener() {

                            public void actionPerformed(ActionEvent actionevent)
                            {
                                ctrl.alignOthers((JPanel)me.getComponent());
                            }

                        });
                        jpopupmenu.add(jmenuitem1);
 /*                       jpopupmenu.addSeparator();
                        JMenuItem jmenuitem2 = new JMenuItem("Export XML...");
                        jmenuitem2.addActionListener(new ActionListener() {

                            public void actionPerformed(ActionEvent actionevent)
                            {
                                ctrl.exportSingle((JPanel)me.getComponent(), "XML");
                            }

                        });
                        jpopupmenu.add(jmenuitem2);
                        JMenuItem jmenuitem3 = new JMenuItem("Export EPS...");
                        jmenuitem3.addActionListener(new ActionListener() {

                            public void actionPerformed(ActionEvent actionevent)
                            {
                                ctrl.exportSingle((JPanel)me.getComponent(), "EPS");
                            }

                        });
                        jpopupmenu.add(jmenuitem3);*/
                        jpopupmenu.addSeparator();
                        JMenuItem jmenuitem4 = new JMenuItem("Configure...");
                        jmenuitem4.addActionListener(new ActionListener() {

                            public void actionPerformed(ActionEvent actionevent)
                            {
                                ctrl.configurePanel((JPanel)me.getComponent());
                            }

                        });
                        jpopupmenu.add(jmenuitem4);
                        jpopupmenu.show(mouseevent.getComponent(), mouseevent.getX(), mouseevent.getY());
                    }
                }


            });
        }
        catch(IndexOutOfBoundsException indexoutofboundsexception)
        {
            System.out.println("multiprobe.ProbeCtrlFrame.setProbePanel: IndexOutOfBoundsException: " + indexoutofboundsexception.getMessage());
        }
        repaint();
    }

    public void update(Graphics g)
    {
        super.update(g);
        layoutPanels();
    }

    public void paint(Graphics g)
    {
        super.paint(g);
        layoutPanels();
    }

    public void actionPerformed(ActionEvent actionevent)
    {
/*        if(actionevent.getActionCommand().equals("Export XML..."))
            ctrl.xmlExport();
        if(actionevent.getActionCommand().equals("Export EPS..."))
            ctrl.epsExport();*/
        if(actionevent.getActionCommand().equals("Fit all data"))
            ctrl.fitAllData();
        if(actionevent.getActionCommand().equals("Exit"))
            ctrl.windowClosed();
        if(actionevent.getActionCommand().equals("About"))
            JOptionPane.showMessageDialog(this, "1.0, February 2002\nHolger Bringmann (hcb@lambdabase.de)", "About Multiprobe", 1, new ImageIcon(getClass().getResource(resources.getString("about"))));
    }
    
    public void Close() {
    }
    
    public void Open() {
    }
    
    public void Refresh() {
         super.paint(this.getGraphics());
         layoutPanels();
         System.out.println("Refresh"); 
    }
    
    transient protected ProbeCtrl ctrl;
    protected int vSize[];
    protected JComponent panels[];
   private static ResourceBundle resources;

   /*  static 
    {
       try
        {
            resources = ResourceBundle.getBundle("de.lambdabase.neuroml.module.multiprobe.resources/ProbeCtrlFrame", Locale.getDefault());
        }
        catch(MissingResourceException missingresourceexception)
        {
            System.err.println("de/lambdabase/neuroml/module/multiprobe/resources/ProbeCtrlFrame.properties not found");
        }
    }   */ 
}
