

package neosim.iface;
 
/** A connection request is the message which a source entity sends to a dest entity
 * it wants to connect to. By default it contains the source entity
 * ID and port no, as well as the DestMethod.
 */
public interface ConnectionRequest extends java.io.Serializable {
    
    /** Return the entity originating this request */
    public int     getSrcEntityID();//EntityID

    /** Return the entity index originating this request */
    public int          getSrcEntityIndex();

    /** Return the output port of the entity to connect from */
    public short       getSrcPortID();//PortID

    /** Return the method to run at the dest entity */
    public DestMethod   getDestMethod();   
    
}
