
package neosim.iface;

import java.util.*;
/**  A control module interface.
 * This interface is provided for control
 * modules loadable by a script reader to
 * perform part of the control of a simulation.
 *
 * @author Fred Howell
 * @version 1.0
 * @date Nov 2000.
 */

public interface ControlModule {
    /** Initialise the parameters of a control module.
     * Parameters are given as a hashtable of string
     * key/value pairs
     *  @param params the string name/value parameters
     */
    public void init(Hashtable params);

    /** Run this control module.
     * @param sr the calling script reader
     */
    public void run( ScriptReader sr );
}
