package neosim.iface;
import java.util.Hashtable;

/** The part of a general projection which runs on
 * a destination entity and decides to fulfill/deny
 * connection requests.
 */
public interface DestMethod extends java.io.Serializable {

    /** The considerRequest method checks the source entity's details 
     * against the dest entity's details, and returns True or False
     * depending on whether or not the connection will be made. 
     * @param deste the destination entity
     * @param cr the connection request from the source entity
     * @return connection if a connection made, null otherwise.
     */
    public Connection considerRequest( Entity deste, ConnectionRequest cr, boolean BuildingConnection );
 
    /** 
     * This method is called by the considerRequest method to 
     * create a connection.
     * @param deste the destination entity
     * @param c the connection to make
     * @return the id of the connection
     */
     int makeConnection( Entity deste, Connection c , boolean BuildingConnection);    //ConnectionID
    /** 
     * This method is called when the method is loaded 
     * from a jar file
     * 
     * @param name name of the method
     * @param params hashtable of the method's parameters
     *
     */
    public void init( String name, Hashtable params);
}
