package neosim.iface;

/** Interface for initialising an entity to be a given
 * member of a population.  Can be used as an argument 
 * in a PopulationBuilder
 */
public interface EntityInit extends java.io.Serializable {
    /** Initialise an entity to be a member index of population p
     * @param e the entity to initialise
     * @param p the population the entity will be part of
     * @param index the index in the population
     */
    public void init( Entity e, Population p, int index);
}
