package neosim.iface;

/** A basic event just has a time stamp and a class id.
 * Derived types of event can include extra data and methods.
 */
public class Event implements Cloneable,java.io.Externalizable {// //java.io.Serializable
    Time t;
    int srce;//EntityID srce
    short srcport;//PortID
    protected ClassID cid;
    protected Connection c = null;

    protected int iType;
           
    transient boolean DelayedEvent=false;
    
    public Event( Time t ) { 
	this.t = t; this.srce = 1; this.srcport = 1;//new PortID(1);//new EntityID(1)
	this.cid = new ClassID(1); 
    }
    public Event( Time t, int srce, short srcport ) { //EntityID srce// PortID srcport
	this.t = t; this.srce = srce; this.srcport = srcport; 
        this.cid = new ClassID(-1); 
    }
    public Event( Time t, int srce, short srcport, int iType ) { //EntityID srce//PortID srcport
	this.t = t; this.srce = srce; this.srcport = srcport; this.iType = iType;
        this.cid = new ClassID(-1);
    }
    public final void setSrcEntityID( int srce ) { this.srce = srce; }//EntityID srce
    public final void setSrcPortID( short srcport) { this.srcport = srcport; }//PortID
    public final Time         getTime() { return t; }
    public final void         setTime(Time t) { this.t = t; }
    public final int          getType() { return iType; } // *** Addon for hsolve integration *** 

    public final ClassID      getClassID() {  return cid;  } 
    public NeosimClass  getNeosimClass() { return null; } // ***
    public EventClass   getEventClass()  { return null; } 
    public final int     getSrcEntityID() { return srce; }//EntityID srce
    public final short       getSrcEntityPortID() { return srcport; }//PortID
    public final Connection   getConnection() { return c; }
    public final void         setConnection(Connection c) { this.c = c; }
    public boolean      isEntityEvent() { return false; }
    public boolean      isSystemEvent() { return false; }
    public ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("Event", "Object", "neosim.kernel"); return cid;     
    }
    public Object clone() { Event e = new Event( t, srce, srcport, iType ); e.cid = cid; return e; } 

    //public String toString() { return "Event at time "+t+" from "+srce+","+srcport+" class "+cid+
//				   " connection "+c+" type "+iType; 
//    }


    /** Test of new event delivery mechanism 
     * Derived types try to cast recipient to appropriate target,
     * e.g. (SpikeHandler)e.handle(dt,this,i)
     */
    public void deliverToEntity( Time dt, Entity e, Input i ) {
	try {
	    // System.out.println("Event.deliverTo Trying to deliver default event to entity "+e);
	    ((DefaultHandler)e).handle(dt,this,i);
	} catch (Exception ex) {
	    System.out.println("Failed to deliver default event to "+e+" "+ex+" ");
	    ex.printStackTrace();
	}
    }
    
    public Event(){
        srce=-1;//new EntityID(-1);
        t=new Time();
        srcport=-1;//new PortID(-1);
        cid=new ClassID(-1);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce=objectInput.readInt();
        t.t=objectInput.readLong();
        srcport=objectInput.readShort();
        cid.id=objectInput.readInt();
        iType=objectInput.readInt();
        c=(Connection)objectInput.readObject();
        /*byte i=-1,shift,j;
        byte[] array=new byte[30];
        j=objectInput.readByte();
        objectInput.read(array,0,j);
	//srce.id
	srce.id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    srce.id |= (array[++i] & 0x7F) << shift;
	}
        //srcport.id 
	srcport.id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    srcport.id |= (array[++i] & 0x7F) << shift;
	}	
        //cid.id
	cid.id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    cid.id |= (array[++i] & 0x7F) << shift;
	}	
        //iType
        iType = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    iType |= (array[++i] & 0x7F) << shift;
	}
        //t.t
        t.t = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    t.t |= (array[++i] & 0x7F) << shift;
	}
        //c
        c=(Connection)objectInput.readObject();*/
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce);
        objectOutput.writeLong(t.t);
        objectOutput.writeShort(srcport);
        objectOutput.writeInt(cid.id);
        objectOutput.writeInt(iType);
        objectOutput.writeObject(c);
        /*int i=0;
        byte[] array=new byte[30];
        int srce_id,srcport_id,cid_id,_iType;
        long t_t;
        srce_id=srce.id;
        srcport_id=srcport.id;
        cid_id=cid.id;
        _iType=iType;
        t_t=t.t;
        //srce.id
        while ((srce_id & ~0x7F) != 0) {
	    array[i++] = (byte)((srce_id & 0x7f) | 0x80);
	    srce_id >>>= 7;
	}
	array[i++] =(byte)srce_id;
        //srcport_id  
        while ((srcport_id & ~0x7F) != 0) {
	    array[i++] = (byte)((srcport_id & 0x7f) | 0x80);
	    srcport_id >>>= 7;
	}
	array[i++] =(byte)srcport_id;  
        //cid_id
        while ((cid_id & ~0x7F) != 0) {
	    array[i++] = (byte)((cid_id & 0x7f) | 0x80);
	    cid_id >>>= 7;
	}
	array[i++] =(byte)cid_id; 
        //_iType
        while ((_iType & ~0x7F) != 0) {
	    array[i++] = (byte)((_iType & 0x7f) | 0x80);
	    _iType >>>= 7;
	}
	array[i++] =(byte)_iType;  
        //t_t
         while ((t_t & ~0x7F) != 0) {
	    array[i++] = (byte)((t_t & 0x7f) | 0x80);
	    t_t >>>= 7;
	}
	array[i++] =(byte)t_t;         
        //OutputByteArray
        objectOutput.writeByte((byte)i);
        objectOutput.write(array,0,i);
        objectOutput.writeObject(c);  */      
    }
    
    public boolean IsDelayedEvent(){
        return this.DelayedEvent;
    }
    
    public int getSize(){
        return 60;// No idea but expected to be not that small;
        //note : this object referencing is ugly, and it would be better to have the time/id direction as long/int/etc
    }     
    
}
