package neosim.iface;
import java.util.Vector;

/** A general projection defines a set of connections between
 * two populations. The projection is specified with a 
 * SourceMethod, which runs on each member of the source
 * population and issues connection requests to the 
 * destination population.  The destination method decides
 * to fulfill/deny these requests.
 */
public interface GeneralProjection extends Projection {
    public String   getSrcPopName();
    public String   getDestPopName();
    public SourceMethod getSrcMethod();
    public DestMethod   getDestMethod();
}
