package neosim.iface;
import java.util.Vector;

/**  A grouping node of the population tree - has a number of child population nodes
 */
public interface PopulationTree extends PopulationNode {
    /** Add a population to this grouping node 
     * @param n the node to add
     */
    public void addNode( PopulationNode n );

    /** Delete a population from this grouping node
     * @param name the name of the node to delete
     */
    public void deleteNode( String name );

    /** Return the child populations of this node 
     */
    Vector getChildren();

    /** Return the entity handle given the name 
     * @param entityName the name of the entity to lookup
     */
    int getEntityID( String entityName );//EntityID

    /** Returns the child node given a name
     * @param popName the name of the child
     * @return the population node
     */
    PopulationNode getChild( String popName );
}
