

package neosim.iface;

/** A population view provides a way of referring to
 * a collection of existing entities. It is specified 
 * by providing a population and a method to decide 
 * whether to add each entity to the view.  A typical view
 * would be a grid based decomposition which provides
 * a method to look up all entities in a given grid square.
 */
public interface PopulationView extends Population {
     
 
    /** Implement this method to build new types of view 
     * @param e the entity to consider adding to this view
     */
    public void buildView( Entity e );

    /** Call this method from within the buildView method
     * to add an entity to the view
     * @param e the entity to add
     */
    void addEntityToView( int e );//EntityID e
}
