package neosim.iface;
import java.util.Vector;

/** A projection stores a specification of a set
 * of connections from one population onto another,
 * and can be specified as an array of connections
 * to make from output ports of source entities
 * to input ports of destination entities.
 * If the connections to make depend on the
 * state of the source and/or destination entities,
 * a GeneralProjection should be used instead. 
 */
public interface Projection extends java.io.Serializable {
    public Vector getConnections();
    /**
     * @return whether this projection is specificed as
     *         a list of connections, or as src/dst methods
     */
    public boolean isGeneralProjection();
}
