/*
 * SpikeArray.java
 *
 * Created on 26 January 2005, 19:09
 */

package neosim.iface;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class SpikeArray implements java.io.Externalizable {//java.io.Externalizable{
    static final int nb_spike_per_array=100;
    byte array[];
    byte buffer[];
    SpikeArray next;
    int  index_write=0;
    int  index_read=0;
    int kernelID;
    
    public int getID(){
        return kernelID;
    }
    /** Creates a new instance of SpikeArray */
    public SpikeArray(){
        this(0);
    }
       
    public int getSize(){
        int total=0;
//int TimeI=0,handleI=0,portI=0;
        SpikeArray pointer=this;
        while(pointer!=null){
              int cursor=14;
              for(int i=0;i<index_write;i++){
                  long time;
                  int handle;
                  short port;
                  port=(short)array[--cursor];
                  port=(short)((port<<8)|((int)array[--cursor]&(int)0xFF));                  
                  handle=(int)array[--cursor];
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  time=(long)array[--cursor];                  
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  
                  while((time & ~0x7F)!=0){
                      total++;
                      time>>>=7;
                      //TimeI++;
                  }
                  total++;
                  //TimeI++;
                  
                  while((handle & ~0x7F)!=0){
                      total++;
                      handle>>>=7;
                      //handleI++;
                  }
                  total++;
                  //handleI++;
                  
                  while((port & ~0x7F)!=0){
                      total++;
                      //portI++;
                      port>>>=7;
                  }
                  total++;
                  //portI++;
                  cursor+=28;
              }
              
              pointer=pointer.next;
          }        
        int IDKernel=this.kernelID;
        
        while((IDKernel&~0x7F)!=0){
            total++;
            IDKernel>>>=7;
        }
        total++;
      //  if(total>5) {
      //      System.out.println("Total = "+total+ " Indexwrite = "+ index_write +" TimeI = "+ TimeI +" handleI = "+ handleI +" portI = " + portI);   
       // }
        return total;
    }
    
    public final void fill(byte[] byteArray, int inc) {
        int IDKernel=kernelID;
        long time;
        int handle;
        short port;   
        
        //write KernelID
        boolean toOutput=false;
        
        while ((IDKernel & ~0x7F) != 0) {
	    byte b = (byte)((IDKernel & 0x7f) | 0x80);
	    byteArray[inc++]=b;	    
	    IDKernel >>>= 7;
	}
	byteArray[inc++]=(byte)IDKernel;
        
        SpikeArray pointer=this;
        while(pointer!=null){
              int cursor=14;
              for(int i=0;i<index_write;i++){

                  port=(short)array[--cursor];
                  port=(short)((port<<8)|((int)array[--cursor]&(int)0xFF));                  
                  handle=(int)array[--cursor];
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  handle=(handle<<8)|((int)array[--cursor]&(int)0xFF);
                  time=(long)array[--cursor];                  
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  time=(time<<8)|((long)array[--cursor]&(long)0xFF);
                  
                //  if(time>1200)
                 //   toOutput=true;
                  
                  while ((time & ~0x7F) != 0) {
                    byte b = (byte)((time & 0x7f) | 0x80);
                    byteArray[inc++]=b;	    
                    time >>>= 7;
                  }
                  byteArray[inc++]=(byte)time;
                  
                  while ((handle & ~0x7F) != 0) {
                    byte b = (byte)((handle & 0x7f) | 0x80);
                    byteArray[inc++]=b;	    
                    handle >>>= 7;
                  }
                  byteArray[inc++]=(byte)handle;
                  
                  while ((port & ~0x7F) != 0) {
                    byte b = (byte)((port & 0x7f) | 0x80);
                    byteArray[inc++]=b;	    
                    port >>>= 7;
                  }
                  byteArray[inc++]=(byte)port;    
                  cursor+=28;                  
              }
              pointer=pointer.next;
          }                
        
       // if(toOutput)
       //     neosim.kernel.CommandQueue.PrintObject(byteArray,"fill_byteArray.txt");
    }
    
    public SpikeArray(int kernelID) {
        next=null;
        array=new byte[nb_spike_per_array*14];//4 for long Time;2 for handle hand ond one for port;
        buffer=new byte[14];//the last short is the index
        this.kernelID=kernelID;
    }
    public void addSpike(int handle, long time, short port){
 //       System.out.println("Spike "+handle+" "+time+" "+port);
        if(index_write==nb_spike_per_array){
            if(next==null)
                next=new SpikeArray();
            next.addSpike(handle, time, port);
        }
        else{
//             System.out.println("Send at "+time+" on "+handle+" port "+port); 
            
            int pos=index_write*14;
            array[pos++]=(byte)(0xFF&time);            
            time>>=8;
            array[pos++]=(byte)(0xFF&time);            
            time>>=8;
            array[pos++]=(byte)(0xFF&time);            
            time>>=8;            
            array[pos++]=(byte)(0xFF&time);  
            time>>=8;
            array[pos++]=(byte)(0xFF&time);            
            time>>=8;
            array[pos++]=(byte)(0xFF&time);            
            time>>=8;            
            array[pos++]=(byte)(0xFF&time); 
            time>>=8;            
            array[pos++]=(byte)(time);             
            
            
            array[pos++]=(byte)(0xFF&handle);            
            handle>>=8;
            array[pos++]=(byte)(0xFF&handle);              
            handle>>=8;
            array[pos++]=(byte)(0xFF&handle);  
            handle>>=8;
            array[pos++]=(byte)(handle);  
            
            array[pos++]=(byte)(0xFF&port);
            port>>=8;
            array[pos++]=(byte)(port);
            
            index_write++;
            
           
        }
    }
    public void ClearSpike() {
        index_read=0;
        this.index_write=0;
        if(next!=null){
            next.ClearSpike();//not necessary..... The GC should be able to cope with but...
            next=null;
        }
    }
    public byte[] readSpike(){

         if(index_read==nb_spike_per_array){
             if(next==null)
                return null;
             else
                return next.readSpike();
         }
         if(index_read==index_write)
             return null;
         System.arraycopy(array, index_read*14, buffer, 0, 14);
         index_read++;
         return buffer;
    }
   /* public byte[] getSpike(short index){
         if(index>=nb_spike_per_array){
                return next.getSpike((short)(index-nb_spike_per_array));
         }
         System.arraycopy(array, index*14, buffer, 0, 14);
         return array;
    }    */
    
    public void RMI_Write(java.io.ObjectOutput objectOutput) throws java.io.IOException{
          short level=1;
          SpikeArray pointer=next;
          while(pointer!=null){
              pointer=pointer.next;
              level++;
          }
          objectOutput.writeInt(index_write);
          objectOutput.writeShort(level);
          pointer=this;
          while(pointer!=null){            
              objectOutput.write(array);
              pointer=pointer.next;
          }
    }
    
     public void RMI_Read(java.io.ObjectInput objectInput) throws java.io.IOException{
        short level;
        index_write=objectInput.readInt();
        level=objectInput.readShort();
        SpikeArray pointer=this;
        while(--level!=(short)0){
            objectInput.read(pointer.array);
            pointer.next=new SpikeArray();
            pointer=pointer.next;
        }
        objectInput.read(pointer.array);
        pointer.next=null;
        pointer.index_read=0;
    }
     
     //just in case, but mainly for testing and checking they are NOT called
     public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
         int Counter=objectInput.readInt();
         SpikeArray pointer=this;
         long toread=objectInput.readLong();
         kernelID=(int)(toread>>32);
         index_write=(int)(toread&0xFFFFFFFF);
         //objectInput.read(array,0,array.length); 
         for(int j=0;j<pointer.array.length;j++){
             pointer.array[j]=objectInput.readByte();
         }     
        // pointer.array=(byte[])objectInput.readObject();
         for(int i=1;i<Counter;i++){
            pointer.next=new SpikeArray(kernelID);
            pointer=pointer.next;             
            toread=objectInput.readLong();
            pointer.kernelID=(int)(toread>>32);//useless ?
            pointer.index_write=(int)(toread&0xFFFFFFFF);
            //pointer.array=(byte[])objectInput.readObject();
            for(int j=0;j<pointer.array.length;j++){
                pointer.array[j]=objectInput.readByte();
            }
            //objectInput.read(pointer.array,0,pointer.array.length);
         }
      //  System.out.println("Read "+kernelID);         
     }
     
     public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
         SpikeArray pointer=this;
         int counter=0;
         while(pointer!=null){
             pointer=pointer.next;
             counter++;
         }
         objectOutput.writeInt(counter);
         pointer=this;
         for(int i=0;i<counter;i++){
            long towrite=((long)pointer.kernelID<<32)|pointer.index_write;
            objectOutput.writeLong(towrite);
            //objectOutput.write(pointer.array,0,pointer.array.length);
            for(int j=0;j<pointer.array.length;j++){
                objectOutput.writeByte(pointer.array[j]);
            }      
           // objectOutput.writeObject(pointer.array);
            pointer=pointer.next;
         }
      //   System.out.println("Written "+kernelID);
         //System.out.println(index_write+" "+array[0]+" "+array[1]+" "+array[2]+" "+array[3]+" "+array[4]+" "+array[5]+" "+array[6]+" "+array[7]+" "+array[8]+" "+array[9]+" "+array[10]+" "+array[11]+" "+array[12]+" "+array[13]+" "+array[14]);
        /* if(next==null)
             objectOutput.writeObject(new Integer(0));
         else
            objectOutput.writeObject(next);*/
     }
     
     public final int decode(byte[] byteArray,int inc){
         byte b;
         int finalinc;
         int handle;
         long time;
         short port;
         int counter;
         b = byteArray[inc++];
         finalinc = b & 0x7F;
         for (int shift = 7; (b & 0x80) != 0; shift += 7){
             b = byteArray[inc++];
             finalinc |= (b & 0x7F) << shift;
         }
         finalinc+=inc;
         
         kernelID = byteArray[inc++];
         for (int shift = 7; (b & 0x80) != 0; shift += 7){
             b = byteArray[inc++];
             kernelID |= (b & 0x7F) << shift;
         }         
         
         
         while(inc<finalinc){
             
            b = byteArray[inc++];
            time = b & 0x7F;
            for (int shift = 7; (b & 0x80) != 0; shift += 7){
                b = byteArray[inc++];
                time |= (b & 0x7F) << shift;
            }      
            
            b = byteArray[inc++];
            handle = b & 0x7F;
            for (int shift = 7; (b & 0x80) != 0; shift += 7){
                b = byteArray[inc++];
                handle |= (b & 0x7F) << shift;
            }
            
            b = byteArray[inc++];
            port = (short)(b & 0x7F);
            for (int shift = 7; (b & 0x80) != 0; shift += 7){
                b = byteArray[inc++];
                port |= (b & 0x7F) << shift;
            }            
            this.addSpike(handle, time, port);
           // System.out.println("decode "+handle+" "+time+" "+port); 
         }
         return inc;
     }
     
}
