package neosim.iface;

/** A Spike event.
 */
public class SpikeEvent extends Event {

    public SpikeEvent( Time t ) { super(t); }
    public SpikeEvent( Time t, int iType ) { super(t); this.iType = iType; }
    public SpikeEvent( Time t, int srce, short srcport ) {  super(t,srce,srcport); }//EntityID srce//PortID srcport
    public SpikeEvent( Time t, int srce, short srcport, int iType ) {  super(t,srce,srcport,iType);  }//EntityID srce//PortID srcport
    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("SpikeEvent", "Event", "neosim.kernel"); return cid;     
    }
    public final Object clone() { SpikeEvent e = new SpikeEvent( t, srce, srcport,iType ); e.cid = cid; return e; } 
    public static SpikeEvent inst = new SpikeEvent(Time.ZERO);

    /** Test of new event delivery mechanism 
     * Derived types try to cast recipient to appropriate target,
     * e.g. (SpikeHandler)e.handle(dt,this,i)
     */
    public final void deliverToEntity( Time dt, Entity e, Input i ) {
	try {
	    // System.out.println("Trying to deliver spike event to entity "+e);	    
	    ((SpikeHandler)e).handle(dt,this,i);
	} catch (Exception ex) { 
	    System.out.println("Failed to deliver a spike to entity "+e);
	}
    }
    
     public SpikeEvent(){
         super();
     }
    
   public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
     //   System.out.println(this.getClass().getName()+"In SpikeEvent: readObject  ");
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
    }
    
    public int getSize(){
        return 40;
    }    
}
