/*
 * SpikeIndexTable.java
 *
 * Created on 27 January 2005, 11:40
 */

package neosim.iface;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class SpikeIndexTable {
    static final int nb_max=100;
    int last_index=0;//give the size of the array
    int current_index=0;
    SpikeIndexTable next=null;
    /**indices in the TableSpikeArray of the spikes*/
    int  IndexArray[];
    long TimeArray[];
       
    /** Creates a new instance of SpikeIndexTable */
    public SpikeIndexTable() {
        IndexArray=new int[nb_max];
        TimeArray=new long[nb_max];
    }

    public synchronized void addSpike(int index,long time){
        //ASSERT
        if(index==0)
            index=index;
        if(last_index==nb_max){
            if(next==null)
                next=new SpikeIndexTable();
            next.addSpike(index,time);
        }
        else{
            IndexArray[last_index]=index;
            TimeArray[last_index]=time;
            last_index++;   
        }
            
    }
    //quick sort
    public void sortArray(){
        SpikeIndexTable pointer=this;
        int level=0;
        while(pointer!=null){
            level+=pointer.last_index;
            pointer=pointer.next;
        }
        
       
       /* long time;
      //  short port;
      //  int IncomingID;
        
        int Index;
        
        pointer=this;
        level=0;
        
        //value used to get a "median value" to the average (...) this should allow speeding up sorting the values
        //The sorting algorithm is still a quite heavy solution if there are only a few spikes per time step, and this is quite likely....
        //Furthermore, these spikes might have been sorted.
        
        long maxtime=-1,mintime=1000000000000000000l,currenttime=0,mean,comp1,comp2;
        int CurrentIndex=0;
        

        while(pointer!=null){
            for(int i=0;i<pointer.last_index;i++,level++){
           
                time=pointer.TimeArray[i];
                if(time>maxtime)
                    maxtime=time;
                if(time<mintime)
                    mintime=time;
                
                mean=(maxtime+mintime)>>1;//divide by 2=average
                
                comp1=(mean-currenttime);
                comp2=(mean-time);
                
                if((comp2<comp1&&comp2>-comp1)||(comp2>comp1&&comp2<-comp1)){
                    currenttime=time;
                    CurrentIndex=level;
                }               
            }
            pointer=pointer.next;
        }*/
        if(level!=0){
           /* int j=0;
            pointer=this;
            while(j+nb_max<=CurrentIndex){
                j+=nb_max;
                pointer=pointer.next;
            }
            CurrentIndex-=j;
            int RealIndex=pointer.IndexArray[CurrentIndex];
            pointer.TimeArray[CurrentIndex]=TimeArray[0];
            pointer.IndexArray[CurrentIndex]=IndexArray[0];

            pointer.TimeArray[0]=currenttime;
            pointer.IndexArray[0]=RealIndex;*/

            q_sort(current_index,level-1);
        }
    }
        
        //quick sort
    void q_sort(int lo0, int hi0)
    {
        int lo = lo0;
        int hi = hi0;
        if (lo >= hi) {
            return;
        }
        double mid = getTime((lo + hi) >>>1);
        while (lo < hi) {
            while (lo<hi && getTime(lo) < mid) {
                lo++;
            }
            while (lo<hi && getTime(hi) >= mid) {
                hi--;
            }
            if (lo < hi) {
                exchange(lo,hi);
            }
        }
        if (hi < lo) {
            exchange(lo,hi);
        }
        q_sort(lo0, lo);
        q_sort(lo == lo0 ? lo+1 : lo, hi0);
    }
    
    long getTime(int pos){
        int j=0;
        SpikeIndexTable pointer=this;
        while(j+nb_max<=pos){
            j+=nb_max;
            pointer=pointer.next;
        }  
        return pointer.TimeArray[pos-j];
    }
    
    void exchange(int source,int dest){
        int i=0,j=0;
        SpikeIndexTable pointer1=this,pointer2=this;
        while(i+nb_max<=source){
            i+=nb_max;
            pointer1=pointer1.next;
        }  
        while(j+nb_max<=dest){
            j+=nb_max;
            pointer2=pointer2.next;
        } 
        long temp1=pointer1.TimeArray[source-i];
        pointer1.TimeArray[source-i]=pointer2.TimeArray[dest-j];
        pointer2.TimeArray[dest-j]=temp1;
        //ASSERT        
        if(temp1==0||pointer1.TimeArray[source-i]==0)
            temp1=temp1;
              
        int temp2=pointer1.IndexArray[source-i];
        pointer1.IndexArray[source-i]=pointer2.IndexArray[dest-j];
        pointer2.IndexArray[dest-j]=temp2;        
    }
    
    public synchronized void advance(neuroml.sim.run.RunnableCell rc, long time){
        sortArray();
        while(current_index<last_index&&TimeArray[current_index]<=time){
            rc.advance(Time.convert(TimeArray[current_index]));
        //ASSERT            
            if(TimeArray[current_index]==0)
                current_index=current_index;
            rc.handleSpike(Time.convert(TimeArray[current_index]), IndexArray[current_index]);
            current_index++;
            
            if(current_index==nb_max&&next!=null){//reached last_index obviously too
                IndexArray=next.IndexArray;
                TimeArray=next.TimeArray;
                current_index=0;
                last_index=next.last_index;
                next=next.next;
            }
        }
        if(current_index==last_index){
            current_index=0;
            last_index=0;
        }
        rc.advance(Time.convert(time));
    }
}
            
        
        
        
        
        /*((((((((((((((long)buffer[7]<<8)|
        (long)buffer[6])<<8)|
        (long)buffer[5])<<8)|
        (long)buffer[4])<<8)|
        (long)buffer[3])<<8)|
        (long)buffer[2])<<8)|
        (long)buffer[1])<<8)|(long)buffer[0];
        (long)(buffer[5]<<40)|(long)(buffer[4]<<32)|(long)(buffer[3]<<24)|(long)(buffer[2]<<16)*/
   

