package neosim.iface;

/** Time is stored as an integer number of nanoseconds */
public class Time implements java.io.Serializable {
    public long t;

    /** Initialised to number of seconds */
    public Time() { this.t = 0; }
    public Time( double t ) { set(t); }
    public Time( Time t ) { this.t = t.t; }
    public final void add( Time a ) { this.t += a.ns(); }
    public final void set( double nt ) { this.t =  (long)(nt * 1000000000); }
    public final void set( Time nt ) { this.t =  nt.t; }
    public final double s() { return (double)t * 0.000000001; }
    public final double ms() { return (double)t * 0.000001; }
    public final double us() { return (double)t * 0.001; }
    public final long ns() { return t; }

    public static Time ZERO = new Time();
    public final String toString() { return ""+s();}
    public static final long convert(double nt){ 
        return (long)(nt * 1000000000);
    }
    public static final double convert(long t){ 
        return (double)t * 0.000000001;
    }    
}
