package neosim.iface;

/** A value event - used to send continuous values
 */
public class ValueEvent extends Event  {

    double value = 0.0;

    public ValueEvent( Time t, double value ) { super(t); this.value = value; }
    public ValueEvent( Time t, int iType ) { super(t); this.iType = iType; }
    public ValueEvent( Time t, int srce, short srcport ) {  super(t,srce,srcport); }//EntityID srce//PortID srcpor
    public ValueEvent( Time t, int srce, short srcport, int iType, double value ) {  //EntityID srce, PortID srcport,
	super(t,srce,srcport,iType);  
	this.value = value;
    }

    public final double getValue() { return value; }

    // Deprecate?
    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("ValueEvent", "Event", "neosim.kernel"); return cid;     
    }
    public final Object clone() { ValueEvent e = new ValueEvent( t, srce, srcport,iType,value ); e.cid = cid; return e; } 

    public static ValueEvent inst = new ValueEvent(Time.ZERO,0.0);

    /** Test of new event delivery mechanism 
     * Derived types try to cast recipient to appropriate target,
     * e.g. (ValueHandler)e.handle(dt,this,i)
     */
    public final void deliverToEntity( Time dt, Entity e, Input i ) {
	try {
	    ((ValueHandler)e).handle(dt,this,i);
	} catch (Exception ex) { 
	    System.out.println("Failed to deliver a value to entity "+e);
	}
    }
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        //System.out.println("ValueEvent: readObject  ");
        srce=objectInput.readInt();
        t.t=objectInput.readLong();
        srcport=objectInput.readShort();
        cid.id=objectInput.readInt();
        iType=objectInput.readInt();
        value=objectInput.readDouble();
        c=(Connection)objectInput.readObject();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce);
        objectOutput.writeLong(t.t);
        objectOutput.writeShort(srcport);
        objectOutput.writeInt(cid.id);
        objectOutput.writeInt(iType);        
        objectOutput.writeDouble(value);
        objectOutput.writeObject(c);
    }    
    
    public int getSize(){
        return 50;
    }    
}
