
package neosim.implementation;

import neosim.iface.*;

/** A specification of a connection to make
 */
public class ConnectionSpec implements Connection, java.io.Externalizable  {

   /* EntityID srce;
    PortID srcpid;
    EntityID deste;
    PortID destpid;
    ConnectionID destcid;
    Time delay;

    public ConnectionSpec(EntityID srce, PortID srcpid, EntityID deste, PortID destpid, Time delay) {
	this.srce    = srce;
	this.srcpid  = srcpid;
	this.deste   = deste;
	this.destpid = destpid;
	this.delay   = delay;
	destcid = new ConnectionID(0);
    }

    // Set the delay asssociated with this connection. 
    public final void setDelay(Time d) { delay = d; }

    public final EntityID     getDstEntityID() { return deste; }
    public final PortID       getDstPortID() { return destpid; }
    public final Time         getDelay() { return delay; }
    public final EntityID     getSrcEntityID() { return srce; }
    public final PortID       getSrcPortID() { return srcpid; }
    public final ConnectionID getConnectionID() { return destcid; }
    public final void         setConnectionID(ConnectionID c) { destcid=c; }
    public void sendEvent(Event e) { 
	System.out.println("Error - trying to send an event with a ConnectionSpec!");
    }

    // Place holders for setting additional src/dest parameters 
    // This can be overridden to set e.g. a threshold
    //
    public void setSrcParams( Entity srce, PortID srcp ) {
    }

    // Set any extra connection parameters at the destination end
    // e.g. a weight
    //
    public void setDstParams( Entity deste, ConnectionID destcid ) {
    }

    public final String toString() { 
	return "connection spec :"+srce.id+"."+srcpid.id+"  --->  "+deste.id+"."+destpid.id+"  connection id "+destcid+" delay "+delay;
    }
    
    public ConnectionSpec(){
        srce=new EntityID(-1);
        deste=new EntityID(-1);
        delay=new Time();
        srcpid=new PortID(-1);
        destpid=new PortID(-1);
        destcid=new ConnectionID(-1);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce.id=objectInput.readInt();
        deste.id=objectInput.readInt();
        delay.t=objectInput.readLong();
        srcpid.id=objectInput.readInt();
        destpid.id=objectInput.readInt();
        destcid.id=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce.id);
        objectOutput.writeInt(deste.id);
        objectOutput.writeLong(delay.t);
        objectOutput.writeInt(srcpid.id);
        objectOutput.writeInt(destpid.id);
        objectOutput.writeInt(destcid.id);
    }   */   
    byte[] data;//srcpid.id //destpid.id //srce.id //deste.id //delay.t 
    int destcid;
    
    public ConnectionSpec(int srce, short srcpid, int deste, short destpid, long delay) {
       setData(srce,srcpid,deste,destpid,delay);
    }  
    void setData(int srce, short srcpid, int deste, short destpid, long delay){
        int i=0;
        byte[] array=new byte[30];
        
        //srcpid
        while ((srcpid & ~0x7F) != 0) {
	    array[i++] = (byte)((srcpid & 0x7f) | 0x80);
	    srcpid >>>= 7;
	}
	array[i++] =(byte)srcpid;  
        //destpid
        while ((destpid & ~0x7F) != 0) {
	    array[i++] = (byte)((destpid & 0x7f) | 0x80);
	    destpid >>>= 7;
	}
	array[i++] =(byte)destpid;          

        //srce
        while ((srce & ~0x7F) != 0) {
	    array[i++] = (byte)((srce & 0x7f) | 0x80);
	    srce >>>= 7;
	}
	array[i++] =(byte)srce;          
        //deste
        while ((deste & ~0x7F) != 0) {
	    array[i++] = (byte)((deste & 0x7f) | 0x80);
	    deste >>>= 7;
	}
	array[i++] =(byte)deste;          
        //delay
        while ((delay & ~0x7F) != 0) {
	    array[i++] = (byte)((delay & 0x7f) | 0x80);
	    delay >>>= 7;
	}
	array[i++] =(byte)delay; 
        data=new byte[i];
        for(i=0;i<data.length;i++)
            data[i]=array[i];        
    }
    public final short       getSrcPortID() { //PortID
        byte i=-1,shift;
        int temp;
        
	//srce.id
	temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	} 
        return (short)temp;
    } 
    public final short       getDstPortID() { //PortID
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return (short)temp; 
    }
    public final int     getSrcEntityID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return temp; 
    }
    public final int     getDstEntityID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}  
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return temp;        
    }   
    public final long         getDelay() { 
        byte i=-1,shift;
        int temp;
        long temp2;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}  
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp2 = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp2 |= (data[++i] & 0x7F) << shift;
	}        
        return temp2;          
    }
    
       
    
    public final void setDelay(long d) {
        byte i=-1,shift;
        int srcpid,destpid,srce,dest;
        srcpid = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    srcpid |= (data[++i] & 0x7F) << shift;
	}
        destpid = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    destpid |= (data[++i] & 0x7F) << shift;
	}        
        srce = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    srce |= (data[++i] & 0x7F) << shift;
	}  
        dest = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    dest |= (data[++i] & 0x7F) << shift;
	}        
        setData(srce,(short)srcpid,dest,(short)destpid,d);     
    }
    
    public final int getConnectionID() { return destcid; }
    public final void         setConnectionID(int c) { destcid=c; }
    public void sendEvent(Event e) { 
	System.out.println("Error - trying to send an event with a ConnectionSpec!");
    }

    // Place holders for setting additional src/dest parameters 
    // This can be overridden to set e.g. a threshold
    //
    public void setSrcParams( Entity srce, short srcp ) {//PortID
    }

    // Set any extra connection parameters at the destination end
    // e.g. a weight
    //
    public void setDstParams( Entity deste, int destcid ) {//ConnectionID destcid
    }

    public final String toString() { 
	return "connection spec :"+getSrcEntityID()+"."+getSrcPortID()+"  --->  "+getDstEntityID()+"."+getDstEntityID()+"  connection id "+destcid+" delay "+getDelay();
    }
    
    public ConnectionSpec(){
        
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        data=new byte[objectInput.readByte()];
        objectInput.read(data);
        destcid=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeByte(data.length);
        objectOutput.write(data);
        objectOutput.writeInt(destcid);
    }     
    
    public void addSpike(long time) {
        System.out.println("neosim.implementaion.ConnectionSpec I should NOT be called ERROR");
    }
    
}
