package neosim.implementation;
import neosim.iface.*;
import java.util.Vector;

/** A general projection defines a set of connections between
 * two populations. The projection is specified with a 
 * SourceMethod, which runs on each member of the source
 * population and issues connection requests to the 
 * destination population.  The destination method decides
 * to fulfill/deny these requests.
 */
public class GeneralProjectionImpl extends ProjectionImpl implements GeneralProjection {
    String srcPopName, destPopName;
    SourceMethod sm;
    DestMethod dm;

    public GeneralProjectionImpl( String srcPopName, String destPopName, SourceMethod sm, DestMethod dm) {
	this.srcPopName  = srcPopName;
	this.destPopName = destPopName;
	this.sm = sm;
	this.dm = dm;
    }
    public final String   getSrcPopName() { return srcPopName;    }
    public final String   getDestPopName() { return destPopName; }
    public final SourceMethod getSrcMethod() { return sm; }
    public final DestMethod   getDestMethod() { return dm; }
    public boolean isGeneralProjection() { return true; }
}
