
package neosim.implementation;

import neosim.iface.*;
import java.util.Hashtable;

/** A parameterised connection spec
 * Used for specifying individual connections
 * with extra parameters.
 * The entity gets a call to setSrc/DstConnectionParams( params ) 
 * which it can use to set connection-specific parameters.
 */

public class ParamConnectionSpec extends ConnectionSpec {
    Hashtable params;
    public ParamConnectionSpec(int srce, short srcpid, int deste, short destpid, long delay,  Hashtable params) {//EntityID srce, PortID srcpid, EntityID deste, PortID destpid, Time delay,
	super( srce, srcpid,deste,destpid,delay);
	this.params = params;
    }
    
    public final void setSrcParams( Entity srce, short srcp ) {//PortID srcp
	srce.setSrcConnectionParams( this, srcp, params );
    }

    public final void setDstParams( Entity deste, int destcid ) {//ConnectionID destcid
	//System.out.println("ParamConnectionSpec setDstParams"+destcid+params);
	deste.setDstConnectionParams( this, destcid, params );
    }
    public final void sendEvent(Event e) { 
	System.out.println("Error - trying to send an event with a ParamConnectionSpec!");
    }
    
    public ParamConnectionSpec(){
        /*srce=-1;//new EntityID(-1);
        deste=-1;//new EntityID(-1);
        delay=0;//new Time();
        srcpid=-1;//=new PortID(-1);
        destpid=-1;//=new PortID(-1);
        destcid=-1;//new ConnectionID(-1);*/
        
    }
    
    /*public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce.id=objectInput.readInt();
        deste.id=objectInput.readInt();
        delay.t=objectInput.readLong();
        srcpid.id=objectInput.readInt();
        destpid.id=objectInput.readInt();
        destcid.id=objectInput.readInt();
        params=(Hashtable)objectInput.readObject();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce.id);
        objectOutput.writeInt(deste.id);
        objectOutput.writeLong(delay.t);
        objectOutput.writeInt(srcpid.id);
        objectOutput.writeInt(destpid.id);
        objectOutput.writeInt(destcid.id);
        objectOutput.writeObject(objectOutput);
    }  */
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        data=new byte[objectInput.readByte()];
        objectInput.read(data);
        destcid=objectInput.readInt();
        params=(Hashtable)objectInput.readObject();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeByte(data.length);
        objectOutput.write(data);
        objectOutput.writeInt(destcid);
        objectOutput.writeObject(params);
    }        
}
