

package neosim.implementation;
import neosim.iface.*;
import neuroml.model.I_Clamp.*;
import neuroml.sim.state.PositionState;
import neuroml.util.module.*;
import neosim.neuroml.*;
import neuroml.sim.run.*;
import neuroml.model.I_Clamp.*;

/**  A population builder builds a number of entities of
 * a given class and initialises each one according to
 * its index in the population.
 */
public class PopulationBuilderImpl extends PopulationImpl implements PopulationBuilder {

    EntityClass ec;
    EntityInit ei;
    protected I_Clamp Intensity;
    
 //   public String toString(){
 //       if(Intensity!=null)
 //           System.out.println(" Intensity " + Intensity.toString() );
 //      return ("EntityClass "+ ec!=null?ec.toString():""+" EntityInit "+ei!=null?ei.toString():"");
 //   }

    /** Build size instances of entity class ec.
     * @param name the population name
     * @param ec the class of entities to build
     * @param size the number of entities to build
     * @param ei the initialisation to apply to each entity
     */
    public PopulationBuilderImpl( String name, int size, EntityClass ec, EntityInit ei, I_Clamp stuff ) { //SOCKET_ERROR PopulationNode parent,PopulationNode parent,
	super(name,  size); //SOCKET_ERROR //parent,
	this.ec = ec;
        if(ei==null){
            ei=new EntityInit() {
		public void init( Entity e, Population p, int index) {
		    // Make sure Entity has a setPos method
		    // Entity3D could be an interface? - better.
		    try {
			PositionState e3d = (PositionState) e;
			PopulationBuilderImpl p3d = (PopulationBuilderImpl) p;
			e3d.setPos( (double)index,0,0 );
                        if(e instanceof NeosimEntityImpl){
                            RunnableCell rc=((NeosimEntityImpl)e).getRunnableCell();
                            if(rc instanceof BasicRunnableCell){
                                _Function stuff;
                                if(p3d.Intensity==null)
                                    stuff=new _Function_step(0.0);
                                else
                                    stuff=p3d.getFunction(index);
                                ((BasicRunnableCell)rc).setIntensity(stuff);
                            }
                        }
		    } catch (Exception ex) {
			System.out.println("Error - Grid3DPopulation can only be made for Entity3D"+ex);
		    }
		}
            };
            
        }else
            this.ei = ei;
//	parent = null; //SOCKET_ERROR
        Intensity=stuff;
        // Can't xmit a population builder!!!!
    }

    /** Return the entity initialisation method */
    public final EntityInit  getEntityInit() {
	return ei;
    }

    /** Return the entity class of the population */
    public final EntityClass getEntityClass() {
	//	System.out.println("PBI getEntityClass called");
	return ec;
    }
    public final _Function getFunction(int i){
        return Intensity.getFunction(i);
    }

    /** This method should not get called - you need to call
     * the Population.getEntityID method instead.
     * This should be enforced more neatly - e.g. passing the 
     * calls to the actual Population object, throwing an exception, 
     * performing an automatic lookup.
     */
    //    public EntityID getEntityID( int i ) {
    //	System.err.println("Error - attempted to call PopulationBuilderImpl.getEntityID");
    //	System.err.println("  --- should only use populations obtained by lookup: ");
    //	System.err.println("    Population sgPop = (Population)root.getChild( 'SpikeGen' );");
    //	return new EntityID(-1);
    //    }

}
