

package neosim.implementation;
import neosim.iface.*;
import java.util.Vector;

/**  A grouping node of the population tree - has a number of child population nodes
 */
public class PopulationTreeImpl extends PopulationNodeImpl implements PopulationTree  {

    protected Vector nodes;

    public PopulationTreeImpl( String name ) {//SOCKET_ERROR , PopulationNode parent
	super( name ); //SOCKET_ERROR , parent
	nodes = new Vector();
    }

    /** Add a population to this grouping node 
     * @param n the node to add
     */
    public final void addNode( PopulationNode n ) {
	nodes.addElement(n);
    }

    /** Delete a population from this grouping node
     * @param n the node to delete
     */
    public final void deleteNode( String nname ) {
	for (int i=0; i<nodes.size(); i++) {
	    PopulationNode pn = (PopulationNode)(nodes.elementAt(i));
	    if (nname.equals( pn.getName())) {
		nodes.removeElementAt(i);
		break;
	    }
	}
    }

    /** Return the child populations of this node 
     */
    public final Vector getChildren() {
	return nodes;
    }

    /** Return the entity handle given the name 
     * @param entityName the name of the entity to lookup
     */
    public final int getEntityID( String entityName ) {//EntityID
	System.out.println("Pop Tree Impl :: getEntityID Not yet implemented");
	return 0; ///new EntityID(0);
    }

    /** Return the entity handle given the name 
     * @param popName the name of the population to lookup
     */
    public final PopulationNode getChild( String popName ) {
	PopulationNode ret = null;
	for (int i=0; i<nodes.size() && ret==null; i++) {
	    PopulationNode pn = (PopulationNode)(nodes.elementAt(i));
	    if (popName.equals( pn.getName())) {
		ret = pn;
	    }
	}
	return ret;
    }

    public final boolean isLeaf() { return false; }
}
