/*
 * Position3DPopulation.java
 *
 * Created on 13 July 2004, 15:50
 */

package neosim.implementation;
import neosim.iface.*;
import neuroml.sim.state.PositionState;
import neuroml.model.network.PositionModule;
import neuroml.util.module.*;
import neosim.neuroml.*;
import neuroml.sim.run.*;
import neuroml.model.I_Clamp.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class Position3DPopulation extends PopulationBuilderImpl {
    protected PositionModule PositionBuilder;
    /** Creates a new instance of Position3DPopulation */
     public Position3DPopulation( String name, int nb, EntityClass ec, PositionModule  PositionBuilder, I_Clamp stuff ) { //SOCKET_ERROR , PopulationNode parent
	super(name, nb,ec, new EntityInit() { //SOCKET_ERROR, parent
		public void init( Entity e, Population p, int index) {
		    // Make sure Entity has a setPos method
		    // Entity3D could be an interface? - better.
		    try {
			PositionState e3d = (PositionState) e;
			Position3DPopulation p3d = (Position3DPopulation) p;
			p3d.setEntityPos( e3d, index );
                        if(e instanceof NeosimEntityImpl){
                            RunnableCell rc=((NeosimEntityImpl)e).getRunnableCell();
                            if(rc instanceof BasicRunnableCell){
                                _Function stuff;
                                if(p3d.Intensity==null)
                                    stuff=new _Function_step(0.0);
                                else
                                    stuff=p3d.getFunction(index);
                                ((BasicRunnableCell)rc).setIntensity(stuff);                                
                            }
                        }                        
		    } catch (Exception ex) {
			System.out.println("Error - Grid3DPopulation can only be made for Entity3D"+ex);
		    }
		}
	    }	
	 , stuff);
         this.PositionBuilder=PositionBuilder;
    }
     public final void setEntityPos( PositionState e, int index ) {
	PositionBuilder.setEntityPos(e,index);
    }
    
}
