package neosim.implementation;
import neosim.iface.*;
import neosim.kernel.*;
import java.util.Hashtable;
/** Connect from a specified output port to (potentially) all
 * entities in destination population.
 *
 * This is the superclass for user source methods.
 */
public class SourceMethodImpl implements SourceMethod {
    protected short srcPort;//PortID

    public SourceMethodImpl( ) {

    }

    public SourceMethodImpl( short srcPort ) {//PortID
	this.srcPort = srcPort;
    }
	

    // *** User derivable method goes Here ***
    public void sendRequests( Entity srce, Population destPop, DestMethod dm, boolean BuildingConnection ) {
	// Here, send a request to all members of the destination population.
	//	System.out.println(" Source Method Running on "+srce.getName());
	bcastRequest( srce, destPop, 
		      new ConnectionRequestImpl( srce.getID(), 
						 srcPort, 
						 dm)
                                                 , BuildingConnection );
    }

    public final void sendRequest( Entity srce, int deste, ConnectionRequest cr, boolean BuildingConnection) {//EntityID deste
        //neosim.kernel.Deadlock_Message ecp1=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(srce,ecp1);  
	srce.sendEvent( deste, 
			PortID.SYSTEM_PORT,
			new ConnectionRequestEvent( srce.getLocalTime(), // ***
						    srce.getID(), 
						    srcPort, 
						    cr, 
                                                    BuildingConnection) );         
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp1);        
	// OK, prepare entity for an acknowledgement.
    }    
  
    public final void bcastRequest( Entity srce, Population destPop, ConnectionRequest cr, boolean BuildingConnection ) {
	// Here, doing a bcast in a loop
	// Should be using a Kernel broadcast for speed
	for (int i=0; i<destPop.getNumEnts(); i++) {	  
	    sendRequest( srce, destPop.getEntityID(i), cr, BuildingConnection );
	}
    }
     /** 
     * This method is called when the method is loaded 
     * from a jar file
     * 
     * @param name name of the method
     * @param params hashtable of the method's parameters
     *
     */
    public void init( String name, Hashtable params){

    }
    
}
