package neosim.kernel;

import neosim.iface.*;
import neosim.implementation.*;
import java.util.Vector;

/** Class which collects responses from SysEntEvents
 * and delivers them as one event back to the originating entity.
 */
public class CallbackHandler extends Thread {
    protected int qid;
    protected int proc;
    protected int nresponses;
    protected int srce;//EntityID srce
    protected short srcp;//short
    protected BasicKernel bk;
    protected Callback c;
    protected Time t;

    public CallbackHandler( int qid, int proc, Time t, BasicKernel bk, 
			    int srce, short srcp, Callback c ) {//EntityID srce//PortID srcp
	this.qid = qid; this.proc = proc; this.t = t; this.bk = bk;
	this.srce = srce; this.srcp = srcp; this.c = c;
        setName(getName()+" "+this.getClass().getName()+ " "+qid+ " "+proc+ " "+srce+ " "+srcp);
    }

    public final Time getTime() { return t; }
    public final int  getQid()  { return qid; }

    /** Just wait for answers, then post them as an event to the originating entity */
    public void run() { 
	//	System.out.println("CallbackHandler started up, waiting for QID:"+qid);
	Vector retv = bk.waitForAnswers(qid);
	//	System.out.println("CallbackHandler got answers, sending callback event to entity");
	bk.eventRmt(proc, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, srce, srcp, 
		    new EntityCallbackEvent(t, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, c, retv )
		    );
	bk.callbackDone(qid);
	//	System.out.println("CallbackHandler done");
    }
}
