package neosim.kernel;

import neosim.iface.*;


/** Callback to call on src entity when connection made
 */
class ConfirmCallback implements Callback {
    public ConfirmCallback(){
    }
    
    public void callback( Entity e, Object o ) {
	Connection c = (Connection)o;
	//	System.out.println("Making src end of connection on "+e.getName());	
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);
	e.addOutConnection( c.getSrcPortID(), //new PortID(
			    c.getDelay(),  
			    c.getDstEntityID(),
			    c.getDstPortID());//new PortID(
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
	// c.setSrcParams(e, c.getSrcPortID());
    }
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
    }    
}

class RemoveCallback implements Callback { 
    public RemoveCallback(){
    }
    
    public void callback( Entity e, Object o ) {
	Connection c = (Connection)o;
	//	System.out.println("Making src end of connection on "+e.getName());	
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);        
	e.removeOutConnection( c.getSrcPortID(), //new PortID(
			    c.getDelay(),  
			    c.getDstEntityID(),
			    c.getDstPortID());//new PortID(
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
	// c.setSrcParams(e, c.getSrcPortID());
    }
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
    }    
}

class CancelCallback implements Callback { 
    public CancelCallback(){
    }
    
    public void callback( Entity e, Object o ) {
	//	System.out.println("NOT Making src end of connection on "+e.getName());	
    }
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
    }    
}

/** The event which requests making a connection to
 * another entity. It contains and runs a ConnectionRequest
 * at the far end.
 */
public class ConnectionRequestEvent extends EntityEvent {
    ConnectionRequest cr;
    boolean BuildingConnection; 
    public ConnectionRequestEvent(Time t, int srce, short srcport, ConnectionRequest cr, boolean BuildingConnection ) { //EntityID srce//PortID srcport
	super( t, srce, srcport );
	this.cr = cr;
        this.BuildingConnection=BuildingConnection;
    }
    public void doOnEntity( Entity e ) {
	DestMethod dm = cr.getDestMethod();
	Connection c = dm.considerRequest( e, cr, BuildingConnection );
       
	if (c!=null) {
            if(BuildingConnection){     
                       
	    //	    System.out.println("ConnectionRequestEvent making a connection to "+e.getName());
                e.sendEvent( getSrcEntityID(), PortID.SYSTEM_PORT,
			 new EntityCallbackEvent( getTime(), 
						  e.getID(), 
						  PortID.SYSTEM_PORT, 
						  new ConfirmCallback( ), 
						  c ) );	
            }
            else{
                e.sendEvent( getSrcEntityID(), PortID.SYSTEM_PORT,
			 new EntityCallbackEvent( getTime(), 
						  e.getID(), 
						  PortID.SYSTEM_PORT, 
						  new RemoveCallback( ), 
						  c ) );	
            }
	} else {
	    //	    System.out.println("ConnectionRequestEvent NOT making a connection to "+e.getName());
	    e.sendEvent( getSrcEntityID(), PortID.SYSTEM_PORT,
			 new EntityCallbackEvent( getTime(), 
						  e.getID(), 
						  PortID.SYSTEM_PORT, 
						  new CancelCallback( ), 
						  new Integer(42) ) 
			     );	    
	}
	
    }
    public ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("ConnectionRequestEvent", "EntityEvent", "neosim.kernel"); 
	return cid;
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
      //  System.out.println("readExternal: I am here and it works");
        super.readExternal(objectInput);
       // System.out.println(this.getClass().getName()+"In ConnectionRequestEvent: Before ConnectionRequest readObject");
        cr=(ConnectionRequest)objectInput.readObject();
        BuildingConnection=objectInput.readBoolean();
      //  System.out.println("readExternal: Done my work");
    }
    
    public ConnectionRequestEvent(){
        super();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
   //     System.out.println("writeExternal: I am here and it works");        
        super.writeExternal(objectOutput);
        objectOutput.writeObject(cr);         
        objectOutput.writeBoolean(BuildingConnection);
   //     System.out.println("writeExternal: Done my work");          
    }     
    
    public int getSize(){
        return 100;
    }    
}
