/*
 * DeadlockTrackerKernel.java
 *
 * Created on 19 May 2005, 13:29
 */

package neosim.kernel;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class DeadlockTrackerKernel extends Thread{
    int current_report = 0;
    boolean InADeadlock=false;
    Vector CurrentStackVector=new Vector();
    Vector OldStackVector=new Vector();
    Vector BlockedThreadVector=new Vector();
    static boolean running = false;
    /** Creates a new instance of DeadlockTrackerKernel */
    public DeadlockTrackerKernel() {
    }
    
    public static void kill(){
        running=false;
    }
    
    public synchronized void add(Deadlock_Message e, Object caller ){
         CurrentStackVector.add(e);
         BlockedThreadVector.add(caller);
         InADeadlock=false;
    }
    
    public synchronized void remove(Deadlock_Message e){
          int i=CurrentStackVector.indexOf(e);
          CurrentStackVector.remove(e);
          BlockedThreadVector.removeElementAt(i);
          InADeadlock=false;
    }    
    
    public void run(){
        boolean running = true;        
        while(running){
            try{
                Thread.sleep(10000);//10s
                
                synchronized(this){
                    int csize=CurrentStackVector.size();
                    int osize=OldStackVector.size();                    
                    if(!InADeadlock){
                        if((csize>0)&&(csize==osize)){
                            boolean continue_=true;
                            for(int i=0;i<csize&&continue_;i++)
                                continue_=OldStackVector.contains(CurrentStackVector.elementAt(i));
                           
                            if(continue_){
                                System.out.println("Likely Dealock at:");                                
                                    if(current_report==0&&SimSystem.getKernel().getID()==0)
                                        java.awt.Toolkit.getDefaultToolkit().beep();
                                                                   
                                for(int i=0;i<csize;i++){
                                    Deadlock_Message e=(Deadlock_Message)(CurrentStackVector.elementAt(i));
                                    Object dlt=BlockedThreadVector.elementAt(i);

                                    neosim.kernel.CommandQueue.PrintObject(dlt, "POSSIBLE_DEADLOCK_"+current_report+"_"+SimSystem.getKernel().getID()+".txt");                                 

			            e.printStackTrace();                                    
                                }
                                
                                InADeadlock=true;
                                current_report++;
                            }
                        }
                    }
                    OldStackVector=new Vector();                    
                    for(int i=0;i<csize;i++){
                        OldStackVector.add(CurrentStackVector.elementAt(i));
                    }
                }
            }
            catch(java.lang.InterruptedException x){x.printStackTrace();}
        }
    }
}
