package neosim.kernel;

/** Kill all kernels - issued by a script reader
 */
public class DestroyKernelCommand extends QueryCommand {
    public DestroyKernelCommand(int id) {  super(id); setBlocking(true); }
    public final String getType() { return "DestroyKernel"; }
    public final void doit(SimKernel sp, Collective comms)  throws ResetException { 


	// System.out.println("DestroyKernelCommand Issued");

	if (needResponse()) {
//JAG DANGEROUS OPTIMIZATION         
        //sp.sendCommand(id, new QueryResponse(sp.getID(), qid, new Integer(0)));
        sp.sendCommand(id, new QueryResponseInteger(sp.getID(), qid, new Integer(0)));                  
        
	}
	
	// Destroy is special - the ack is sent before doing the
	// destroy
	sp.destroyRmt(sp.getID());
    }
}

