package neosim.kernel;
import neosim.iface.*;

/** The event which calls entity.callback() 
 * with the results of a query
 */
public class EntityCallbackEvent extends EntityEvent {
    Object ans;
    Callback cb;
    public EntityCallbackEvent(Time t, int srce, short srcport, Callback cb, Object ans ) { //Time t, EntityID srce, PortID srcport,
	super( t, srce, srcport );
	this.cb = cb;
	this.ans = ans;
    }
    public final void doOnEntity( Entity e ) {
        if(cb==null) return;
	cb.callback(e, ans);
    }
    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("EntityCallbackEvent", "EntityEvent", "neosim.kernel"); 
	return cid;
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
        cb=(Callback)objectInput.readObject();
        ans=objectInput.readObject();
    }
    
    public EntityCallbackEvent(){
        super();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
        objectOutput.writeObject(cb);        
        objectOutput.writeObject(ans);          
    }       
    
    public int getSize(){
        return 100;
    }          
}
