package neosim.kernel;
import neosim.iface.*;

/** An EntityEvent contains a doOnEntity() method which is executed
 * by the default event handler when an event arrives.
 * It is the superclass for EntityQueries/Updates/Callback events.
 */
public class EntityEvent extends Event  {
    static boolean debug = false;

    
    public EntityEvent(Time t, int srce, short srcport ) { //EntityID srce// PortID srcport
	super( t, srce, srcport );
    }
    /** This method is overridden in derived events. 
     */
    public void doOnEntity( Entity e ) {
	System.out.println("Error - raw EntityEvent called");
	// A null place holder.
    }
    public ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("EntityEvent", "Event", "neosim.kernel"); return cid; 
    }
    public final boolean      isEntityEvent() { return true; }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
  //      System.out.println("EntityEvent: readObject Before inheriting class ");
    }
    
    public EntityEvent(){
        super();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
    }   
    
    public int getSize(){
        return 40;
    }     
}
