package neosim.kernel;
import neosim.iface.*;

/** This event encapsulates an EntityQuery to 
 * perform on an entity
 */
public class EntityQueryEvent extends EntityEvent {
    EntityQuery eq;
    Callback cb;
    public EntityQueryEvent(Time t, int srce, short srcport, EntityQuery eq, Callback cb ) { //Time t, EntityID srce, PortID srcport,
	super( t, srce, srcport );
	this.eq = eq; 
	this.cb = cb;
    }
    public final void doOnEntity( Entity e ) {
	if (debug) System.out.println("Doing entity query event");
	Object ans = eq.query(e);
	e.sendEvent( getSrcEntityID(), PortID.SYSTEM_PORT,
		     new EntityCallbackEvent( getTime(), 
					      e.getID(), PortID.SYSTEM_PORT, cb, ans ) );
    }
    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("EntityQueryEvent", "EntityEvent", "neosim.kernel"); 
	return cid;
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
        eq=(EntityQuery)objectInput.readObject();
        cb=(Callback)objectInput.readObject();
    }
    
    public EntityQueryEvent(){
        super();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
        objectOutput.writeObject(eq);
        objectOutput.writeObject(cb);
    }     
    
    public int getSize(){
        return 100;
    }    
}
