package neosim.kernel;

import neosim.iface.*;

/** Event command from given entity/connection
 */
public class EventCommand extends CommandObj implements java.io.Externalizable {
    int srce;//EntityID srce
    short pid;//PortID
    Event ev;
    public final String getType() { return "Event Command"; }
    public EventCommand(int id, int srce, short pid, Event ev) { //EntityID srce//PortID pid
	super(id); this.srce = srce; this.pid = pid; this.ev = ev;}
    public final void doit(SimKernel sk) {  
	try {
	    sk.eventRmt(id,srce,pid,ev);  
	} catch (Exception e ) {
	    System.out.println("Event Command Exception "+e);
	    e.printStackTrace();
	}
    }
    public EventCommand(){
        super(0);
        srce=0;//new EntityID(0);
        pid=0;//new PortID(
    }
    
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce=objectInput.readInt();
        id=objectInput.readInt();
        pid=objectInput.readShort();
        blocking=objectInput.readBoolean();
        ev=(Event)objectInput.readObject();
       /* byte i=-1,shift,j;
        byte[] array=new byte[30];
        j=objectInput.readByte();
        objectInput.read(array,0,j);
	//srce.id
	srce.id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    srce.id |= (array[++i] & 0x7F) << shift;
	}        
        //id
	id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    id |= (array[++i] & 0x7F) << shift;
	}  
        //pid.id
	pid.id = array[++i] & 0x7F;
	for (shift = 7; (array[i] & 0x80) != 0; shift += 7) {
	    pid.id |= (array[++i] & 0x7F) << shift;
	}         
        blocking=(array[++i]==1);
        ev=(Event)objectInput.readObject();*/
        
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce);
        objectOutput.writeInt(id);
        objectOutput.writeShort(pid);
        objectOutput.writeBoolean(blocking);
        objectOutput.writeObject(ev);
       /* int i=0;
        byte[] array=new byte[16];
        int _id,srce_id,pid_id;//+blocking +ev
        _id=id;
        srce_id=srce.id;
        pid_id=pid.id;
        //srce_id
        while ((srce_id & ~0x7F) != 0) {
	    array[i++] = (byte)((srce_id & 0x7f) | 0x80);
	    srce_id >>>= 7;
	}
	array[i++] =(byte)srce_id;
        //_id  
        while ((_id & ~0x7F) != 0) {
	    array[i++] = (byte)((_id & 0x7f) | 0x80);
	    _id >>>= 7;
	}
	array[i++] =(byte)_id;  
        //pid_id
        while ((pid_id & ~0x7F) != 0) {
	    array[i++] = (byte)((pid_id & 0x7f) | 0x80);
	    pid_id >>>= 7;
	}
	array[i++] =(byte)pid_id; 
        array[i++] = blocking?(byte)1:(byte)0;
        //OutputByteArray
        objectOutput.writeByte((byte)i);
        objectOutput.write(array,0,i);
        objectOutput.writeObject(ev);  */
    }
    
    //public String toString(){
    //    System.out.println("EventCommand Desc");
    //    System.out.println("srce "+srce.id);
    //    System.out.println("pid "+pid.id);
    //    System.out.println("event");
    //    System.out.println(ev.toString());
    //    return new String();
        
    //}
    public final boolean isDelayed() { return ev.IsDelayedEvent(); }

    public int getSize(){
        return 25+ev.getSize();
    }      
}


