package neosim.kernel;

import neosim.iface.*;

/** Event command to given entity/port
 */
public class EventToCommand extends CommandObj  implements java.io.Externalizable { 
    int srce;//EntityID srce
    short srcpid;//PortID srcpid;
    int deste;//EntityID deste
    short destpid;//PortID destpid;
    Event ev;

    static boolean debug = false;

    public final String getType() { return "EventTo Command"; }
    public EventToCommand(){
        super(-1);
        srce=-1;//new EntityID(-1);
        srcpid=-1;//new PortID(
        deste=-1;//new EntityID(-1);
        destpid=-1;//new PortID(
        ev=new Event();
    }
    
    public EventToCommand(int id, int srce, short srcpid, int deste, short destpid, Event ev) { //EntityID srce,//EntityID deste//PortID srcpid//PortID destpid
	super(id); this.srce = srce; this.srcpid = srcpid; this.ev = ev;
	this.deste = deste; this.destpid = destpid;
    }
    public final void doit(SimKernel sp) {  
	if (debug) { System.out.println("EventToCommand calling doit "+toString()); }
	try {
	    sp.eventRmt(id,srce,srcpid,deste, destpid, ev);  
	} catch (Exception e ) {
	    System.err.println(e);
	    e.printStackTrace();
	}
	if (debug) { System.out.println("EventToCommand called doit OK "); }
    }
    public final String toString() { return getType()+" src:"+srce+","+srcpid+" dest:"+deste+","+destpid+" Event:"+ev; }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        id=objectInput.readInt();
        srce=objectInput.readInt();
        srcpid=objectInput.readShort();
        deste=objectInput.readInt();
        destpid=objectInput.readShort();
        blocking=objectInput.readBoolean();
        ev=(Event)objectInput.readObject();        
        //ev.readExternal(objectInput);
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(id);
        objectOutput.writeInt(srce);
        objectOutput.writeShort(srcpid);
        objectOutput.writeInt(deste);
        objectOutput.writeShort(destpid);
        objectOutput.writeBoolean(blocking);
        //ev.writeExternal(objectOutput);
        objectOutput.writeObject(ev);
    }
    
    public final Event  getEvent() {  
        return ev;
        /*if(ev instanceof EntityCallbackEvent){
            if(((EntityCallbackEvent)ev).getConnection()!=null)
                ev=ev;
        }*/
    }
    
     public int getSize(){
        return 31+ev.getSize();
    }    
}


