package neosim.kernel;

import neosim.iface.*;
import neosim.implementation.*;
import java.util.Vector;

/** Class which collects responses from PopulationQueryEvents
 * and delivers them as one event back to the originating entity.
 * @see CallbackHandler
 */
public class PopulationCallbackHandler extends CallbackHandler {
 
    int popsz;

    public PopulationCallbackHandler( int qid, int proc, Time t, int popsz,
				      BasicKernel bk, 
				      int srce, short srcp, Callback c ) {//EntityID srce, PortID srcp,
	super(  qid,  proc,   t,  bk,    srce,  srcp,   c );
	this.popsz = popsz;
    }

    /** Just wait for answers, then post them as an event to the originating entity */
    public final void run() { 
	//	System.out.println("PopulationCallbackHandler started up");
	Vector retv = new Vector(popsz);
	retv.setSize(popsz);

	for (int i=0; i<popsz; i++) {	    
	    PopCBObject pco = (PopCBObject)bk.waitForAnswer(qid, proc);
	    // System.out.println("PopulationCallbackHandler got response "+i+" from index "+pco.index);
	    retv.setElementAt( pco.obj, pco.index );
	}

	// System.out.println("PopulationCallbackHandler got answers, sending callback event to entity");
	bk.eventRmt(proc, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, srce, srcp, 
		    new EntityCallbackEvent(t, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, c, retv )
			);
	bk.callbackDone(qid);
	// System.out.println("PopulationCallbackHandler done");
    }
}
