package neosim.kernel;

/** Pos - stores a 3D position
 */
public class Pos extends Object implements java.io.Serializable {
    public double x,y,z;
    public Pos(double x, double y, double z) { this.x = x; this.y = y; this.z = z; }
    public Pos() { x=0; y=0; z=0; }
    public Pos(Pos p) { x=p.x; y=p.y; z=p.z; }
    /** Return magnitude of this vector */
    public final double mag() { return java.lang.Math.sqrt( x*x + y*y +z*z ); }

    /** Return vector sum p1 + p2 */
    static final public Pos vsum(Pos p1, Pos p2) { return new Pos(p2.x +p1.x, p2.y+p1.y, p2.z+p1.z); }
    /** Return vector difference p1 - p2 */
    static final public Pos vdiff(Pos p1, Pos p2) { return new Pos(p2.x - p1.x, p2.y-p1.y, p2.z-p1.z); }
    /** Return distance b/w two points */
    static final public double dist(Pos p1, Pos p2) {
	return vdiff(p1,p2).mag();
    }
    public final String toString() { return "("+x+","+y+","+z+")"; }
}
