package neosim.kernel;


/** A command with a unique query ID.
 * If doit(SimKernel) method called, sends a QueryResponse.
 * Otherwise it is an event mode command and doesn't send a response.
@see SysEntCommand
 */
public class QueryCommand extends CommandObj {
    protected int qid;
    protected boolean resp = false;
    public QueryCommand(int id) {  
	super(id); 
	this.qid = 0;
    }
    public final void setQid(int qid) { this.qid = qid; }
    public final int getQid() { return qid; }
    public String getType() { return "Query Command"; }
    public final boolean needResponse() { return resp; }
    /** This method called from SimKernel.syncCommand */
    public final void doit(SimKernel sk) {
	resp = true;
	try {doit(sk,sk);} catch (Exception e) {
	    System.err.println(e);
	    e.printStackTrace();
	}
    }
    /** Call this method from SysEntCommand */
    public void doit(SimKernel sp, Collective comms) throws ResetException {
	//	System.out.println("[--- Query cmd "+qid+" doit ---]");
	Object ret = new Integer(42);
	if (needResponse()) {
            
//JAG DANGEROUS OPTIMIZATION            
	    //QueryResponse qr = new QueryResponse(sp.getID(), qid, ret);
            QueryResponse qr = new QueryResponseInteger(sp.getID(), qid, ret);
            
	    sp.sendCommand(id, qr);
	}
	//	System.out.println("[--- Query cmd "+qid+" doneit ---]");
    }
    public int getSize(){
        return 20;
    }    
}
