package neosim.kernel;
import neosim.iface.*;
import neosim.implementation.*;

/** The system entity deals with constructing and linking 
 * entities
 */
public final class SystemEntity extends EntityImpl {

    transient SimKernel k;
    static boolean debug = false;

    public SystemEntity(SimKernel k) {
	super(null, null, 0); // population, class both not set.
	this.k = k;
    }

    public SimKernel getSimKernel() { return k; }

    /** Deal with incoming events
     */
    public Time handleEvents(EventList el, Time t) {
        SysEntEvent e=null;

        boolean goon=true;
            while (goon) {
                //neosim.kernel.Deadlock_Message ecp6=new neosim.kernel.Deadlock_Message();
                //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp6);                   
                synchronized(el){
                    goon=el.hasMoreElements();
                    if(goon)
                        e = (SysEntEvent)el.pop();
                }
                //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp6);
                
                if (debug) 
                    System.out.println("*** System entity dealing with an event");
                if(goon){
               //     neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
               //     neosim.kernel.DeadlockTracker.LockDeadlockTracker(e,ecp);                        
                    e.doOnSysEntity( this );
               //      neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
                }
                if (debug) 
                    System.out.println("*** System entity dealt with an event!");
            }
        
        
	return t;
    }

}
