package neosim.kernel;


import java.util.Vector;

/** A vector command - a bundle of simpler commands
 * packaged together for efficient use of communications channel.
 * @see CommandQueue
 * @see CommandObj
 */
public final class VectorCommand extends CommandObj {
    Vector v;
    public VectorCommand(int id) {  
	super(id);  this.v = new Vector(); 
    }
    public VectorCommand() {  
	super();  this.v = new Vector(); 
    }    
    public String getType() { return "Vector Command"; }
    public void add(CommandObj co) { v.addElement(co); }
    public void doit(SimKernel sp) { 
	try {
            int k=v.size();
                       
	    for (int i=0; i<k; i++) {
            //    neosim.kernel.CommandQueue.PrintObject(v.elementAt(0), "Debug_"+SimSystem.getKernel().getID()+".txt"); 
                sp.command( (CommandObj)(v.remove(0)) );
	    }
	} catch (Exception e) {
	    System.out.println("Vector cmd exception "+e);
	}
    }
    
     public int getSize(){
        int total=20;
        for(int i=0;i<v.size();i++){
           CommandObj cmd=(CommandObj)v.elementAt(i);
           total+=cmd.getSize();
        }
        return total;
    }   
}
