package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;

import neuroml.sim.run.*;

/**
 * The connectionImpl which gets sent back to the source
 * @date Aug 2001
 */
public final class NeosimConnectionImpl implements neosim.iface.Connection, java.io.Externalizable {
   /* int srce;//EntityID
    int deste;//EntityID
    PortID srcport, destport;
    ConnectionID cid;
    Time delay;
    public NeosimConnectionImpl(int srcID, int srcPortID, int destID, int destPortID, int cid, double delay){
	//	this.connection = connection;
	srce    = srcID ;//EntityID
	srcport = new PortID( srcPortID );
	this.deste   =  destID ;//EntityID
	this.destport   = new PortID( destPortID );	
	this.cid = new ConnectionID( cid );
	this.delay = new Time(delay);
    }
    public final int     getDstEntityID() { return deste; }//EntityID
    public final PortID       getDstPortID() { return destport; }
    public final Time         getDelay() { return delay; }
    public final int     getSrcEntityID() { return srce; }//EntityID
    public final PortID       getSrcPortID() { return srcport; }
    public final ConnectionID getConnectionID() { return cid; }
    public final void setConnectionID(ConnectionID c) { cid=c; }

    public final void sendEvent(Event ev) {}
    
    public NeosimConnectionImpl(){
        srce=-1;//EntityID
        deste=-1;//EntityID
        delay=new Time();
        srcport=new PortID(-1);
        destport=new PortID(-1);
        cid=new ConnectionID(-1);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce.id=objectInput.readInt();
        deste.id=objectInput.readInt();
        delay.t=objectInput.readLong();
        srcport.id=objectInput.readInt();
        destport.id=objectInput.readInt();
        cid.id=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce.id);
        objectOutput.writeInt(deste.id);
        objectOutput.writeLong(delay.t);
        objectOutput.writeInt(srcport.id);
        objectOutput.writeInt(deste.id);
        objectOutput.writeInt(cid.id);
    }    */
    byte[] data;//srcpid.id //destpid.id //srce.id //deste.id //delay.t 
    int destcid;
    
    public NeosimConnectionImpl(int srce, short srcpid, int deste, short destpid, int cid, long delay) {
       setData(srce,srcpid,deste,destpid,delay);
       this.destcid=cid;
    }  
    void setData(int srce, short srcpid, int deste, short destpid, long delay){
        int i=0;
        byte[] array=new byte[30];
        
        //srcpid
        while ((srcpid & ~0x7F) != 0) {
	    array[i++] = (byte)((srcpid & 0x7f) | 0x80);
	    srcpid >>>= 7;
	}
	array[i++] =(byte)srcpid;  
        //destpid
        while ((destpid & ~0x7F) != 0) {
	    array[i++] = (byte)((destpid & 0x7f) | 0x80);
	    destpid >>>= 7;
	}
	array[i++] =(byte)destpid;          

        //srce
        while ((srce & ~0x7F) != 0) {
	    array[i++] = (byte)((srce & 0x7f) | 0x80);
	    srce >>>= 7;
	}
	array[i++] =(byte)srce;          
        //deste
        while ((deste & ~0x7F) != 0) {
	    array[i++] = (byte)((deste & 0x7f) | 0x80);
	    deste >>>= 7;
	}
	array[i++] =(byte)deste;          
        //delay
        while ((delay & ~0x7F) != 0) {
	    array[i++] = (byte)((delay & 0x7f) | 0x80);
	    delay >>>= 7;
	}
	array[i++] =(byte)delay; 
        data=new byte[i];
        for(i=0;i<data.length;i++)
            data[i]=array[i];        
    }
    public final short       getSrcPortID() { //PortID
        byte i=-1,shift;
        int temp;
        
	//srce.id
	temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	} 
        return (short)temp;
    } 
    public final short       getDstPortID() { //PortID
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return (short)temp; 
    }
    public final int     getSrcEntityID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return temp; 
    }
    public final int     getDstEntityID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}  
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return temp;        
    }   
    public final long         getDelay() { 
        byte i=-1,shift;
        int temp;
        long temp2;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}  
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp2 = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp2 |= (data[++i] & 0x7F) << shift;
	}        
        return temp2;          
    }    
    
    public final int getConnectionID() { return destcid; }
    public final void setConnectionID(int c) { destcid=c; }

    public final void sendEvent(Event ev) {}
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        data=new byte[objectInput.readByte()];
        objectInput.read(data);
        destcid=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeByte(data.length);
        objectOutput.write(data);
        objectOutput.writeInt(destcid);
    }   
    
    public void addSpike(long time) {
        System.out.println("neosim.neuroml.NeosimConnectionImpl : I should NOT be called ERROR");
    }
    
    public NeosimConnectionImpl(){
        
    }    
}
