package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;

/**
 * Neuroml converter
 *  utility functions that allows Neosim to communicate with NeuroML modules
 * @author Paul Rogister
 * @date Aug 2001
 */
public final class NeosimEntityClassImpl extends EntityClassImpl {

    RunnableCellFactory rFactory;

    /** convert RunnableCellFactory to an entityclass
     */
    public  NeosimEntityClassImpl (RunnableCellFactory rFactory){
	this.rFactory =	rFactory;
	// ---------- Ports stuff will change -----------
	addInPort(SpikeEvent.inst.getEventClass(), "in"); 
        addInPort(SpikeEvent.inst.getEventClass(), "Curve_in");
	addOutPort(SpikeEvent.inst.getEventClass(), "out");
        addOutPort(SpikeEvent.inst.getEventClass(), "Curve_out");
    }

    /** class NeuromlRunnableCell implements neuroml.SpikeSender {}
     */
    public Entity makeEntity(Population p, int i) {
	NeosimEntityImpl rce = new NeosimEntityImpl(this,p,i);
	SpikeSender ss = rce;
	NeuromlPopulationState pstate = new NeuromlPopulationState(p);
	RunnableCell rc = rFactory.makeRunnableCell(pstate,rce.getID(), i,ss);  // incomplete
	rce.setRunnableCell(rc);
	return rce;
    }

    /** Initialise from the NeuroML parameters
     * @deprecated
     */
    public void init(  String name, Hashtable args ) {
	System.out.println("NeosimEntityClassImpl init *** Called in error ***");
	rFactory.setModel(args.get("_Model"));	
    }

    /** Initialise from the NeuroML parameters 
     */
    public void init( Object model ) {
	System.out.println("NeosimEntityClassImpl call init");
	rFactory.setModel(model);	
    }
    
    public String toString(){
        System.out.println(rFactory.toString());
        return super.toString();
    }    
    
    public boolean IsInParent() {
        return rFactory.IsProbe();
    }
}
