package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;

/**
 * Neuroml converter
 * utility functions that allows Neosim to communicate with NeuroML modules
 * @author Paul Rogister
 * @date Aug 2001
 * @comment this class not used at present
 */
public final class NeosimPopulationImpl extends PopulationImpl {

    neuroml.sim.state.PopulationState pop;   

    public NeosimPopulationImpl(neuroml.sim.state.PopulationState pop ){
	super("",pop.getNumElements());//SOCKET_ERROR ,null
	this.pop = pop;
    }
    
    /** Returns unique population id */
    public int getID() {
	return pop.getID();
    }

    /** Sets unique population id */
    public void setID(int i) {
	 pop.setID(i);
    }

    /** Return number of entities */
    public int getNumEnts() {
	return pop.getNumElements();
    }

    /** return index of a given entity handle 
     * @param eid handle of entity
     * @return index of entity in population if present, or -1 otherwise.
     */
    public int getIndex( int eid ) {//EntityID
	return pop.getIndex(eid);
    }

    /** return index of a given entity handle 
     * @param i index in population
     * @return  handle of entity
     */
    public int getEntityID( int i ) {	//return EntityID
	return pop.getElementID(i);//new EntityID(pop.getElementID(i))
    }

    /** return whether a given entity is a member
     * @param eid handle of entity
     * @return true if entity is a member of this population
     */
    public boolean isMember( int eid ) {//EntityID
	return pop.isMember(eid);
    }

    /** Add a member to this population
     * @param eid handle of entity
     */
    public void addMember(int eid) {//EntityID
	pop.addElement(eid,"");
    }

    /** Return a list of all members 
     */
    public Vector getMemberList() {
	Vector ret = new Vector();
	java.util.List eids = pop.getElementIDs();
	for (int i=0; i<eids.size(); i++) {
	    ret.add( ((Integer)eids.get(i)).intValue());//new EntityID(((Integer)eids.get(i)).intValue())
	}
	return ret;
    }

    public boolean isLeaf() { return true; }

    Vector locals = new Vector();

    /** Add a local member to this population (kernel method)
     * @param e entity to add
     */
    public void addLocalMember( Entity e ) { locals.addElement( e ); }

    /** Add a local member to this population (kernel method)
     * @return the vector of lcoal entities
     */
    public Vector getLocalMembers() { return locals; }
}
