package neosim.neuroml;

import neosim.util.*;
import neuroml.sim.state.*;
import neosim.iface.*;


//JAG's rubish
import neosim.implementation.*;

/** A Neuroml connection request bundles a neosim one, which will
 * itself be a bundling of a neuroml one.
 * This gets made at the target end.
 *
 */
public class NeuromlConnectionRequest extends neuroml.sim.run.ConnectionRequest {
  
    /** Construct NeuroML view of a neosim connection request
     */
    public NeuromlConnectionRequest(neosim.iface.ConnectionRequest c) { 
	super(-1,(short)-1,null);
	if (c instanceof NeosimConnectionRequest) {
	    neuroml.sim.run.ConnectionRequest orig = ((NeosimConnectionRequest)c).getNeuromlConnectionRequest();
	    srcID = orig.getSrcID();
	    srcPortID  = orig.getSrcPortID();
	    destMethod = orig.getDestMethod();
	    srcData = orig.getSrcData();
	}
        //JAG
       else if(c instanceof neosim.implementation.ConnectionRequestImpl)
        {
            neosim.implementation.ConnectionRequestImpl orig = ( neosim.implementation.ConnectionRequestImpl)c;
            srcID = orig.getSrcEntityID();
	    srcPortID = orig.getSrcPortID();
            destMethod = new NeuromlDestMethod(orig.getDestMethod());
            System.out.println("TEMPORARY CODE: NEED TO BE CHECKED");
        }
        else{
	    System.out.println("Fatal error in neosim.neuroml.NeuromlConnectionRequest"+
			       " --- connection request not recognised");
	}
    }  
}
