package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import neosim.kernel.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;

/**
 * ConnectionRequestSender allows Neuroml modules to request connection through Neosim
 * @author Paul Rogister
 * @date Sep 2001
 */
public final class NeuromlConnectionRequestSender implements neuroml.sim.run.ConnectionRequestSender {
    Entity srce;

    static boolean debug = false;
   
    public NeuromlConnectionRequestSender() {
    }

    public NeuromlConnectionRequestSender(Entity srce) {
	this.srce = srce;
    }

    /** Send a request to connect to destination entity
     * Info coded in a connection request.
     */
    public void sendRequest(neuroml.sim.run.ConnectionRequest ncr, int desteid, boolean BuildingConnection) {
        //neosim.kernel.Deadlock_Message ecp1=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(ncr,ecp1); 
	if (debug) System.out.println("NeuromlConnectionRequestSender sending request from "+ncr.getSrcID()+"."+
				      ncr.getSrcPortID()+" to "+desteid);
	//EntityID deste = new EntityID(desteid);
        int deste=desteid;
	short srcPort = ncr.getSrcPortID();//PortID//new PortID(

	neosim.iface.DestMethod dm = new NeosimDestMethodImpl( ncr.getDestMethod() );
	neosim.iface.ConnectionRequest cr = new NeosimConnectionRequest( ncr ); 
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp1);  
	// was ConnectionRequestImpl( srce.getID(), srcPort, dm );
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(cr,ecp);  
                
	srce.sendEvent( deste, PortID.SYSTEM_PORT,
			new ConnectionRequestEvent( srce.getLocalTime(), // *** !!!
						    srce.getID(), 
						    srcPort, 
						    cr, 
                                                    BuildingConnection) );
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);        
	// OK, prepare entity for an acknowledgement.
    } 

    /** Alternative version of sendRequest
     */
    public void sendRequest(int srceid, short srcpid, int desteid, neuroml.sim.run.DestMethod dm, boolean BuildingConnection) {
	neuroml.sim.run.ConnectionRequest ncr = new neuroml.sim.run.ConnectionRequest( srceid, srcpid, dm );
	sendRequest( ncr, desteid, BuildingConnection );
    }    
}
