/*
 *	@(#)CubeQA.java 1.5 00/02/10 13:14:39
 *
 * Copyright (c) 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */
package neosim.renderer;
import javax.media.j3d.*;
import javax.vecmath.*;

final class CubeQA extends QuadArray {
    CubeQA() {
	super(24, GeometryArray.COORDINATES  );


	Point3f verts[] = new Point3f[8];
 
	
	verts[0] = new Point3f(0.5f, 0.5f,  0.5f);
	verts[1] = new Point3f(-0.5f, 0.5f, 0.5f);
	verts[2] = new Point3f(-0.5f,-0.5f, 0.5f);
	verts[3] = new Point3f( 0.5f,-0.5f, 0.5f);
	verts[4] = new Point3f( 0.5f, 0.5f,-0.5f);
	verts[5] = new Point3f( -0.5f, 0.5f,-0.5f);
	verts[6] = new Point3f( -0.5f,-0.5f,-0.5f);
	verts[7] = new Point3f( 0.5f,-0.5f,-0.5f);
 
	
	Point3f pnts[] = new Point3f[24];
 

	pnts[0] = verts[0];
	// 0] = colors[0];
	pnts[1] = verts[3];
	// 1] = colors[0];
	pnts[2] = verts[7];
	// 2] = colors[0];
	pnts[3] = verts[4];
	// 3] = colors[0];

	pnts[4] = verts[1];
	// 4] = colors[1];
	pnts[5] = verts[5];
	// 5] = colors[1];
	pnts[6] = verts[6];
	// 6] = colors[1];
	pnts[7] = verts[2];
	// 7] = colors[1];

	pnts[8]  = verts[0];
	// 8]  = colors[2];
	pnts[9]  = verts[4];
	// 9]  = colors[2];
	pnts[10] = verts[5];
	// 10] = colors[2];
	pnts[11] = verts[1];
	// 11] = colors[2];

	pnts[12] = verts[3];
	// 12] = colors[3];
	pnts[13] = verts[2];
	// 13] = colors[3];
	pnts[14] = verts[6];
	// 14] = colors[3];
	pnts[15] = verts[7];
	// 15] = colors[3];

	pnts[16] = verts[0];
	// 16] = colors[4];
	pnts[17] = verts[1];
	// 17] = colors[4];
	pnts[18] = verts[2];
	// 18] = colors[4];
	pnts[19] = verts[3];
	// 19] = colors[4];

	pnts[20] = verts[7];
	// 20] = colors[5];
	pnts[21] = verts[6];
	// 21] = colors[5];
	pnts[22] = verts[5];
	// 22] = colors[5];
	pnts[23] = verts[4];
	// 23] = colors[5];


	setCoordinates(0, pnts);

    }
}
