
package neosim.rmikernel;

import neosim.kernel.*;
import neosim.iface.*;
import neosim.implementation.*;

import java.util.*;
import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
/** RMI Server process
 */

public final class RmiServer extends UnicastRemoteObject implements RmtServer, RmtProcMgr
{
    
    private String name;
    private Vector names = new Vector();
    private Vector VIPAddress = new Vector();
    private Vector gone = new Vector();
    private int numFinished = 0;
    private int narrived = 0;
    public static int ntot = 0;
    Vector v=new Vector();
    private Vector barrier_counts = new Vector(10,10);
    private int barrier_count = -1;
    Integer Monitor1=new Integer(0);//jus a flag
    Integer Monitor2=new Integer(0);//jus a flag
    

    private static boolean debug = false;
    
    Vector cqs = new Vector();
    ProcManager pm = new ProcManager();
    
    public final synchronized ProcManager getProcManager() throws java.rmi.RemoteException {
	return pm;
    }
    
    /** Server barrier routine (no longer used) */
    public final void barrier(int rid) throws java.rmi.RemoteException {
	if (debug) System.out.println("--- SERVER GOT BARRIER FROM "+rid);
	int bval = ((Integer)barrier_counts.elementAt(rid)).intValue();
	bval ++; 
	if (debug) System.out.println("--- SERVER BVAL = "+bval);
	barrier_counts.setElementAt(new Integer(bval), rid);
	if (barrier_count == -1) {
	    barrier_count = v.size();
	}
	if (bval==1) barrier_count --;
	if (barrier_count==0) {
	    if (debug) System.out.println("--- SERVER BARRIER DONE< RESTARTINGl ");
	    for (int i=0; i<v.size(); i++) {
		if (!((Boolean)gone.elementAt(i)).booleanValue()) {
		    try { ((CommandQueue)cqs.elementAt(i)).add(new RestartCommand(i)); } 
		    catch (Exception e) { 
			 System.out.println("server barrier exception "+e);
		    }
		}
		barrier_counts.setElementAt(new Integer(((Integer)barrier_counts.elementAt(i)).intValue() -1) ,i);
	    } 	
	    barrier_count = -1;
	} else {
	    if (debug) System.out.println("--- SERVER COUNT =="+barrier_count);
	}
	if (debug) System.out.println("--- SERVER LEAVING BARRIER FROM "+rid);
    }

    /** Access server's ProcManager */
    public final RmtProc getProcessor(int i) throws java.rmi.RemoteException {
	return pm.getProcessor(i);
    }
    public final void setSleeping(RmtProc p) throws java.rmi.RemoteException {
	pm.setSleeping(p);
    }  
    public final void setRunning(RmtProc p, Time rw) throws java.rmi.RemoteException{
        //neosim.kernel.Deadlock_Message ecp3=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(p,ecp3);           
	pm.setRunning(p,rw);
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp3);
    }
    public final void setStopped(RmtProc p) throws java.rmi.RemoteException {
        //neosim.kernel.Deadlock_Message ecp5=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(p,ecp5);          
	pm.setStopped(p);
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp5);
    }
    public final Time getMinTime() throws java.rmi.RemoteException {
	return pm.getMinTime();
    }
    public final void setMinTime(Time t) throws java.rmi.RemoteException {
	pm.setMinTime(t);
    }
    public final void updateMinTime(Time rw) throws java.rmi.RemoteException {
	pm.updateMinTime(rw);
    }
    public final void calcMinTime() throws java.rmi.RemoteException {
        //neosim.kernel.Deadlock_Message ecp4=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(pm,ecp4);   
	pm.calcMinTime();
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp4);
    }
 
    /** Non-blocking add */
    public final synchronized int add(RmtApp obj, String name, int IPAddress) throws RemoteException {
        int id=-1;
       /* try{
            while(numFinished!=0){
                Thread.sleep(20);//sleep 20 ms while some kernel are finishing : works as a barrier
            }
        }
        catch(java.lang.InterruptedException exc){
            System.out.println("server.add Interrupted");
            exc.printStackTrace();
        }*/
        boolean expanded=true;
        System.out.println("there "+id);
        for(int i=0;i<v.size();i++){
            if(gone.elementAt(i)==Boolean.TRUE)
            {
                id=i;
                i=v.size();
                expanded=false;
            }
        }
        System.out.println("there "+id);
        if(expanded){
            v.addElement(obj);
            names.addElement(name);
            VIPAddress.addElement(new Integer(IPAddress));
            gone.addElement(Boolean.FALSE);
            barrier_counts.addElement(new Integer(0));
            id=v.size()-1;
        }
        else{
            v.setElementAt(obj,id);
            names.setElementAt(name,id);
            VIPAddress.setElementAt(new Integer(IPAddress),id);
            gone.setElementAt(Boolean.FALSE,id);
            barrier_counts.setElementAt(new Integer(0),id);
            
        }
        
        System.out.println("there alpha "+id);
	CommandQueue cq = new CommandQueue(obj);
	cqs.addElement(cq);
	cq.setQName("FROMSERVER");
	cq.start();
        System.out.println("there beta "+id);
	//int id = v.size()-1;
	
	if (debug) System.out.println("Server add: bcasting other names");
	// Broadcast the other names
	for (int i=0; i<v.size(); i++) {
	    try { 
                if(i!=id)
                    cq.add(new AddCommand(i, (String)names.elementAt(i), (RmtApp)v.elementAt(i))); 
            } 
	    catch (Exception e) {	
		 System.out.println("Exception during add1 \n"+e.getMessage()); 
	    }
	}
	System.out.println("there gamma "+id);
	// Broadcast the new name
	if (debug) System.out.println("Server add: bcasting new names");
	for (int i=0; i<v.size(); i++) {
	    try { ((CommandQueue)cqs.elementAt(i)).add(
						       new AddCommand(id, name, obj)); } 
	    catch (Exception e) {	
		System.out.println("Exception during add2 \n"+e.getMessage()); 
	    }
	}
        System.out.println("there delta "+id);
	if (debug) System.out.println("Server add: done");
	return id;	
    }
    
    /** Blocking 'done' --- signal a processor is waiting for shutdown
     */
    public final synchronized void done(int id, RmtApp obj) throws RemoteException {
	System.out.println("Server done called from "+id);
	for (int i=0; i<v.size(); i++) {
	    try { ((RmtApp)v.elementAt(i)).doneRmt(id);  } 
	    catch (Exception e) {  System.out.println("Exception "+e+" at server end");}
	}	 
    }
    
    /** Blocking 'remove' --- final shutdown, kill threads
     */
//    transient DeadlockTracker tracker0=new DeadlockTracker();
    public final synchronized void remove(int id, RmtApp obj) throws RemoteException {
	if (debug) System.out.println("Server remove called");
	numFinished++;
	gone.setElementAt(Boolean.TRUE,id);
        //commented 18/04/05 ->
	/*for (int i=0; i<v.size(); i++) {
	    try { 
		if (!((Boolean)gone.elementAt(i)).booleanValue())
		    ((RmtApp)v.elementAt(i)).removeRmt(id); 
	    } 
	    catch (Exception e) {   System.out.println("Exception "+e+" at server end");}
	}*/
        //commented <-18/04/05
	
	((CommandQueue)(cqs.elementAt(id))).terminate();
        //JAG Since we are killing the kernels and rebuilding them, it is not a very good idea to do that. Arguably, it is clumsy to kill and rebuild stuff.

	if (numFinished == v.size()) {
	    System.out.println("Finished all!");
            v=new Vector();
            names = new Vector();
            VIPAddress = new Vector();
            gone = new Vector();
            numFinished = 0;
    
            barrier_counts = new Vector();
            barrier_count = -1;
            cqs = new Vector();
           
            try{
            //SimSystem.initialise();
                pm = new ProcManager();
                //SimSystem.initialise();
                //pm = new ProcManager();
            }
            catch(Exception e){
                e.printStackTrace();
            }
            notifyAll();//<-18/04/05
	    //System.exit(0);
	} else {
            //18/04/05->
            try{
                //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
                //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);
                wait();
                //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);                
            }catch(Exception ecp){
                ecp.printStackTrace();
            }
            //<-18/04/05
	    if (debug) System.out.println("Finished "+numFinished+" of "+v.size());
	}
    }
    
    /** Pass on all commands */ 
    public final void command(CommandObj co) {//removed synchronised
        System.out.println("SERVER: Executing command "+co.toString());
	for (int i=0; i<v.size(); i++) {
	    try { ((CommandQueue)cqs.elementAt(i)).add(co); } 
	    catch (Exception e) { 
	    }
	}
    }

    public RmiServer(String s) throws RemoteException {
	super();
	name = s;
        VAllGather=new AllgatherV(ntot);
        syncBarrier=new Barrier(ntot);
	/*AllGatherV = new Vector(ntot);
        for(int i=0;i<ntot;i++)
            AllGatherV.add(new Integer(-1));*/
        try{
            //SimSystem.initialise();
            pm = new ProcManager();
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }

    public static void main(String args[])
    {
        
	// Create and install a security manager
	System.setSecurityManager(new RMISecurityManager());
	if (debug) System.out.println("RmiServer main started");
	
	//	SimSystem.initialise();       
        RmiServer.ntot=Integer.valueOf(args[0]).intValue();
        //->Test
       // RmiServer.ntot=3;
        //<-Test
	String port="1099";
	if (args.length==2) {	   
	    System.out.println("...Using port "+args[0]);
	    port = args[1];
	}

	try {
	    if (debug) System.out.println("Trying to make RmiServer");
	    RmiServer obj = new RmiServer("RmiServer");
           /* obj.VIPAddress.addElement(new Integer(3));
            obj.VIPAddress.addElement(new Integer(3));
            obj.VIPAddress.addElement(new Integer(3));
            //->Test
            int[][] truc;
            truc=obj.sortIPs_();*/
            
            //<-Test
   //         obj.sortIPs();
	    //String rebind = "//:"+port+"/RmiServer";
            String rebind = "RmiServer";
	    System.out.println("Rebinding to "+rebind);
	    Naming.rebind(rebind, obj);
	    System.out.println("RmiServer bound in registry");
	} catch (Exception e) {
	     System.out.println("RmiServer err: " + e.getMessage());
	    e.printStackTrace();
	}
    }
    
    public final void destroy() {
    }
     //   transient DeadlockTracker tracker1=new DeadlockTracker();
    public synchronized final void barrier() throws java.rmi.RemoteException {
           narrived++;
           if(narrived==ntot){
                notifyAll();
                narrived=0;
           }
           else{
                try{
                    //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
                    //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);
                    wait();
                    //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);  
                }
                catch(java.lang.InterruptedException e){
                    System.out.println("Error "+narrived);
                    e.printStackTrace();
                }
          }
        
    }
    int AllgatherArray[][];
  //          transient DeadlockTracker tracker2=new DeadlockTracker();
    public final int[] sortIPs(int id) throws java.rmi.RemoteException {
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp); 
        synchronized(this){
            //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
            narrived++;

            if(narrived==ntot){
                AllgatherArray=this.sortIPs_();
                notifyAll();
                narrived=0;
                int sequence[]=new int[AllgatherArray.length];
                
                for(int i=0;i<AllgatherArray.length;i++){
                    sequence[i]=AllgatherArray[i][id];
                }
                barrier();
                AllgatherArray=null;
                String str=new String(id+" : ");
                for(int i=0;i<sequence.length;i++){
                    str=str+sequence[i];
                    str=str+" ";
                }
                System.out.println(str);    
                return sequence;            
            }
            else{
                try{
                    //neosim.kernel.Deadlock_Message ecp2=new neosim.kernel.Deadlock_Message();
                    //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp2);
                    wait();
                    //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp2);  
                    int sequence[]=new int[AllgatherArray.length];
                
                    for(int i=0;i<AllgatherArray.length;i++){
                        sequence[i]=AllgatherArray[i][id];
                    }
                    barrier();        
                    String str=new String(id+" : ");
                    for(int i=0;i<sequence.length;i++){
                        str=str+sequence[i];
                        str=str+" ";
                    }
                    System.out.println(str);                
                    return sequence;
                }
                catch(java.lang.InterruptedException e){
                    System.out.println("Error "+narrived);
                    e.printStackTrace();
                    return null;
                }
            }
        }
    }
    
    AllgatherV VAllGather;
    Barrier syncBarrier;
    public final Vector allgather(Object o) throws java.rmi.RemoteException {
        /*synchronized(this){
            AllGatherV.setElementAt(o,narrived);
            narrived++;
            if(narrived==ntot){
                notifyAll();
                narrived=0;
            }
            else{
                try{
                    wait();
                }
                catch(java.lang.InterruptedException e){
                    System.out.println("Error "+narrived);
                    e.printStackTrace();
                }
            }
        }
        return AllGatherV;*/
        Vector v=null;
        try{
            v=VAllGather.gather(o);
        }
        catch(Exception e){
            e.printStackTrace();
        }
        return v;
    }
/**RMI TESTS ONLY*/    
    byte[][] ByteArray=new byte[4][];
    int[][] IntArray=new int[4][];
    // B10=new byte[10],B100=new byte[100],B1000=new byte[1000],B10000=new byte[10000];
    //int[] I10=new int[10],I100=new int[100],I1000=new int[1000],I10000=new int[10000];
    public void startTests() throws java.rmi.RemoteException{
        ByteArray[0]=new byte[10];
        ByteArray[1]=new byte[100];
        ByteArray[2]=new byte[1000];
        ByteArray[3]=new byte[10000];

        IntArray[0]=new int[10];
        IntArray[1]=new int[100];
        IntArray[2]=new int[1000];
        IntArray[3]=new int[10000];
    }
  public void call() throws java.rmi.RemoteException{}  
  public void sendByte(byte[] array) throws java.rmi.RemoteException{
  }
  public byte[] receiveByte(byte size) throws java.rmi.RemoteException{
      return ByteArray[size];
  }
  public void sendInt(int[] array) throws java.rmi.RemoteException{
      
  }
  public int[] receiveInt(byte size) throws java.rmi.RemoteException{
      return IntArray[size];
  }
  public void sendObject(MiscTests.SerializedClass obj) throws java.rmi.RemoteException{
      
  }
  
  public long sum(int[] array) throws java.rmi.RemoteException{
      short length=(short)array.length;
      long result=0;
      for(short i=0;i<length;i++)
        result+=array[i];
      return result;
  }
  
  public long sum(byte[] array) throws java.rmi.RemoteException{
      short length=(short)array.length;
      long result=0;
      for(short i=0;i<length;i++)
        result+=array[i];
      return result;
  }
  
  
  void sort(int a[], int b[], int lo0, int hi0) { //order a[] by IDAddress and keep track of the kernel ID
        int lo = lo0;
        int hi = hi0;
        if (lo >= hi) {
            return;
        }
        int mid = a[(lo + hi) >>>1];
        while (lo < hi) {
            while (lo<hi && a[lo] < mid) {
                lo++;
            }
            while (lo<hi && a[hi] >= mid) {
                hi--;
            }
            if (lo < hi) {
                int T = a[lo];
                a[lo] = a[hi];
                a[hi] = T;
                
                T=b[lo];
                b[lo]=b[hi];
                b[hi]=T;
            }
        }
        if (hi < lo) {
            int T = hi;
            hi = lo;
            lo = T;
        }
        sort(a, b, lo0, lo);
        sort(a, b, lo == lo0 ? lo+1 : lo, hi0);
    }   
  
  public int[][] sortIPs_(){
     int current_level=0;
     int previous_level=-1;
      
     int nbKernels=ntot;
     int ArraySortedIP[]=new int[nbKernels];
     int ArraySortedIDs[]=new int[nbKernels];
     for(int i=0;i<nbKernels;i++){
        ArraySortedIDs[i]=i;
        ArraySortedIP[i]=((Integer)VIPAddress.elementAt(i)).intValue();
     }
     
     sort(ArraySortedIP,ArraySortedIDs,0,ArraySortedIP.length-1);
     
     int nbSteps=(int)java.lang.Math.ceil(java.lang.Math.log(ArraySortedIP.length)/java.lang.Math.log(2.0d));
     int ExchangeArray[][]=new int[nbSteps][nbKernels];
     
     int TotalEntityToExchange=nbKernels;
     int TotalZeroes=nbKernels;
     int PreviousIpDifference=0;
     int CurrentIpDifference=1;
     int DiffIP;
     int IP1,IP2;
     while(current_level<=nbSteps){

         TotalZeroes=TotalEntityToExchange;
         PreviousIpDifference=0;
         CurrentIpDifference=1;
         
         while(TotalZeroes>1){
            if(previous_level>=0){                
                for(int i=0;i<nbKernels-1;i++){
		    while(i<nbKernels&&ExchangeArray[current_level][i]!=0)
                        i++;
                    if(i<nbKernels){
                        IP1=ExchangeArray[previous_level][i];
                        if(IP1>=0){
                            for(int j=i+1;j<nbKernels;j++){
				if(ExchangeArray[current_level][j]==0){
                                    IP2=ExchangeArray[previous_level][j];
	                            if(IP2>=0){
           	                        DiffIP=ArraySortedIP[j]-ArraySortedIP[i];
                	                if(DiffIP>PreviousIpDifference){
                        	            if(DiffIP<=CurrentIpDifference){
                                	        ExchangeArray[current_level][i]=(j+1);
                                        	ExchangeArray[current_level][j]=(-(i+1));
	                                        TotalZeroes-=2;                                    
        	                                i=j;
                	                        j=nbKernels;
                        	            }
                                	    else{
                                        	ExchangeArray[current_level][j]=0;
	                                        i=j;
        	                                j=nbKernels;                                
                	                    }
                        	        }
	                            }
        	                    else 
                	                ExchangeArray[current_level][j]=ExchangeArray[previous_level][j];
	                       }
                            }
                        }
                        else
                            ExchangeArray[current_level][i]=ExchangeArray[previous_level][i];
                    }   
                }   
            }
            else {               
                for(int i=0;i<nbKernels-1;i++){
		    while(i<nbKernels&&ExchangeArray[current_level][i]!=0)
                        i++;
                    for(int j=i+1;j<nbKernels;j++){
                        if(ExchangeArray[current_level][j]==0){
                            DiffIP=ArraySortedIP[j]-ArraySortedIP[i];
                            if(DiffIP>PreviousIpDifference){
                                if(DiffIP<=CurrentIpDifference){
                                    ExchangeArray[current_level][i]=(j+1);
                                    ExchangeArray[current_level][j]=-(i+1); 
                                    TotalZeroes-=2;                             
                                    i=j;
                                    j=nbKernels;
                                }
                                else{
                                    ExchangeArray[current_level][i]=0;
                                    ExchangeArray[current_level][j]=0;
                                    i=j;
                                    j=nbKernels;                                
                                }
                            }
                        }
                    }
                }             
            }
            
            PreviousIpDifference=CurrentIpDifference;
            CurrentIpDifference<<=1;
        }//while
        previous_level=current_level;
        current_level++;
        TotalEntityToExchange=(TotalEntityToExchange&0x1)+TotalEntityToExchange>>>1;    
    }
    int buffer[];
    for(int i=0;i<nbSteps;i++){
        buffer =new int[nbKernels];
        for(int j=0;j<nbKernels;j++){
            if(ExchangeArray[i][j]>0){
                buffer[j]=ArraySortedIDs[ExchangeArray[i][j]-1]+1;
                System.out.println("buffer[j]="+buffer[j]);
                buffer[buffer[j]-1]=-j-1;
            }
        }
        ExchangeArray[i]=buffer;
    }
    return ExchangeArray;
 }
}
         
