/** Thread parallel SimKernel
 */

package neosim.thrkernel;

import neosim.kernel.*;
import neosim.iface.*;
 

/** Multithreaded simulation kernel 
 * Accepts an argument of number of concurrent 
 * threads to run the simulation.
 */

public final class ThrKernel extends BasicKernel {
    int nthreads;

    boolean debug = false;

    public ThrKernel(int nthreads) {
	super();
	this.nthreads = nthreads;
    }

    /** Run the simulation */
    public void runRmt(int rid, Time t) {
	//	SimSystem.resetVars();
	if (debug) System.out.println("TheKernel run remote started to "+t);
	SimSystem.runPar(1, nthreads, getID(), t);
	if (debug) System.out.println("TheKernel run remote finished at "+t);

    }
}


