
package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;


/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell 
 *         Paul Rogister     
 *
 * @version 1.0, 14 September 2001     
 *                 
 */
public class DestMethodJarBean implements DoOnBean {
    String name;
    Hashtable params;

    DestMethod dm;
    public DestMethodJarBean(String name, Hashtable params) {
	this.name = name;
        this.params = params;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        System.out.println("Running template "+beanName);

	Object o = (Object)ji.getInstance(beanName);
	if (o instanceof neuroml.sim.run.DestMethod) {
	    // make a converter
	    dm = NeuromlConverter.convertDestMethod((neuroml.sim.run.DestMethod)o);
	    // one of the params must be _Model for entity, here too?
	    dm.init(name, params); 
	}
	else {
	    dm = (DestMethod)o;
	    dm.init(name, params);
	}
    }

    public DestMethod getDestMethod() { return dm; }
    public void error(String msg) {
        System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("Start bean exception "+msg);
   }
}
