/** Initialise an entity template bean which has been loaded from a jar file
 */

package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;

/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 October 2000     
 *                 
 */
public class EntClassBean implements DoOnBean {
    String name;
    Hashtable params;
    EntityClass ec;
    public EntClassBean(String name, Hashtable params) {
	this.name = name;
        this.params = params;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        System.out.println("Running template "+beanName);

	Object o = (Object)ji.getInstance(beanName);
	if (o instanceof neuroml.sim.run.RunnableCellFactory) {
	    // make a converter
	    ec = NeuromlConverter.convertEntityClass((neuroml.sim.run.RunnableCellFactory)o);
	    // one of the params must be _Model
	    ec.init(name, params); 
	}
	else {
	    ec = (EntityClass)o;
	    // we remove the _Model param which is irrelevant here 
	    //but have been added before as it would have been needed 
	    //if this bean had been a RunnableCellFactory
	    params.remove("_Model");
	    ec.init(name, params); 
	}
 
    }
    public EntityClass getEntityClass() { return ec; }
    public void error(String msg) {
        System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("Start bean exception "+msg);
   }
}
