
 
package neosim.util;

import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.io.IOException;
 
/**
 * FileSaver
 * Stores file events in a file.
 */
public class FileSaver implements Filecmds, FileListener {

  private PrintWriter trcstream;
  private String fname;
  private boolean isBroke = false;

  /** Creates a file saver with the given filename */
  public FileSaver(String fname) {
    this.fname = fname;
    open();
  }

  void open() {
    isBroke = false;
    try {
      if (trcstream!=null)
	trcstream.close();
      trcstream = new PrintWriter(new FileOutputStream(fname));
    } catch(IOException e) {
      isBroke = true;
      System.out.println("FileSaver: Error - couldn't open file file");
    } catch (Exception ex) {
      isBroke = true;
      System.out.println("FileSaver: file error. Probably security checks"+
 " won't allow writing of a filefile.");
    }
  }

  void close() {
    if (!isBroke) trcstream.close();
  }

  /** Responds to a file input event by writing it on to the file. */
  public void handleFile(FileEventObject e) {
    if (e.getCmd() == LINE) {
      if (!isBroke) trcstream.println(e.getLine());
    } else if (e.getCmd() == START) {
      if (!isBroke) open();
    } else if (e.getCmd() == EOF) {
      if (!isBroke) trcstream.flush();
    }
  }
}
