
package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;


/**
 * Load a population java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 Octobre 2000     
 *                 
 */
public class PopJarBean implements DoOnBean {
    String name; PopulationNode parent;int size;EntityClass ec;EntityInit ei;
    Hashtable params;
    PopulationJar pj;
    public PopJarBean(String name, PopulationNode parent, int size, EntityClass ec,
		      EntityInit ei, Hashtable params) {
	this.name = name;
	this.parent = parent; 
	this.size = size; 
	this.ec = ec;
	this.ei = ei;
        this.params = params;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        pj = (PopulationJar)ji.getInstance(beanName);
	pj.init(name, parent,  size,   ec,   ei, params); 
    }
    public PopulationJar getPopulationJar() { return pj; }
    public void error(String msg) {
        System.out.println("PopJar bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("PopJar bean exception "+msg);
   }
}
