/*
 * LinkedListDestPort.java
 *
 * Created on 11 February 2005, 17:12
 */

package neosim.util.SmallLists;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class LinkedListDestPort_Out extends LinkedList {
    LinkedListDestPort_Out next=null; 
    byte Array[];
    short destPortID;
    boolean compressed=false;
   
    /** Creates a new instance of LinkedListDestPort */
    public LinkedListDestPort_Out(short destPortID) {
        this.destPortID=destPortID;
        Array=new byte[this.ListSize<<2];//(int=4)      
        LinkedList.TotalMemoryLinkedLists+=this.getSize();
    }
  /*ReadInt
   *byte b = buf.get();
	// System.out.println("Read vint Read byte "+b+" from "+buf);
	int i = b & 0x7F;
	for (int shift = 7; (b & 0x80) != 0; shift += 7) {
	    b = buf.get();
	    i |= (b & 0x7F) << shift;
	}
	return i
   */  
    public synchronized void compress() {
        LinkedListDestPort_Out stuff=this;
        int i=0;
        do{
            i+=stuff.RealIndex_read;
            stuff=stuff.next;
        }while(stuff!=null);
        int temp[]=new int[i];
        
        stuff=this;
        int j,k,previous,current;
        i=0;
        previous=0;
        int TotalLength=0;

        byte b; 
        do{
            j=0;
            if(stuff.compressed){
                k=0;                
                while(j<stuff.RealIndex_read){
                    b=stuff.Array[k++];
                    current = b & 0x7F;
                    for(int shift=7;(b & 0x80) != 0; shift += 7){
                        b=stuff.Array[k++];
                        current |= (b & 0x7F) << shift;
                    }
		    current+=previous;
		    previous=current;
                    j++;
                    temp[i++]=previous;
                }
            }
            else{
                int index=stuff.RealIndex_read<<2;
                while(j<index){
                    int truc=(int)(stuff.Array[j+3]&0xFF);
                    truc<<=8;
                    truc|=(int)(stuff.Array[j+2]&0xFF);
                    truc<<=8;
                    truc|=(int)(stuff.Array[j+1]&0xFF);                   
                    truc<<=8;
                    truc|=(int)(stuff.Array[j]&0xFF);                                      
                    j+=4;                
                    temp[i++]=truc;
                }
            }
            TotalLength+=stuff.getSize();
            stuff=stuff.next;
        }while(stuff!=null);
        //sort
        sort(temp,0,temp.length-1);
     //Compression
        byte NewArray[]=new byte[temp.length<<2];
        previous=0;
        k=0;
        for(i=0;i<temp.length;i++){
            current=temp[i]-previous;
            previous=temp[i];
            
            while ((current & ~0x7F) != 0) {
                b = (byte)((current & 0x7f) | 0x80);
                NewArray[k++]=b;	    
                current >>>= 7;
            }
            NewArray[k++]=(byte)current;            
        }
        
        //Clean
        Array=new byte[k];
        System.arraycopy(NewArray,0, Array, 0, k);
        RealIndex_read=temp.length;
        ListSize=RealIndex_read;
        this.compressed=true;
        this.next=null;
        
        LinkedList.TotalMemoryLinkedLists+=this.getSize()-TotalLength;        
    }

    
    
    void sort(int a[], int lo0, int hi0) { //order by delay/512 (a) then source id/512 
        int lo = lo0;
        int hi = hi0;
        if (lo >= hi) {
            return;
        }
        int mid = a[(lo + hi) >>>1];
        while (lo < hi) {
            while (lo<hi && a[lo] < mid) {
                lo++;
            }
            while (lo<hi && a[hi] >= mid) {
                hi--;
            }
            if (lo < hi) {
                int T = a[lo];
                a[lo] = a[hi];
                a[hi] = T;
            }
        }
        if (hi < lo) {
            int T = hi;
            hi = lo;
            lo = T;
        }
        sort(a, lo0, lo);
        sort(a, lo == lo0 ? lo+1 : lo, hi0);
    }    
    
    public synchronized int addOutConnection(int srcID){
          if(RealIndex_read==this.ListSize){
              if(next==null)
                next=new LinkedListDestPort_Out(destPortID);
              return next.addOutConnection(srcID); 
          }
          else{
              int current=RealIndex_read<<2;
              Array[current++]=(byte)(srcID&0xFF);
              srcID>>=8;
              Array[current++]=(byte)(srcID&0xFF);
              srcID>>=8;
              Array[current++]=(byte)(srcID&0xFF);
              srcID>>=8;
              Array[current++]=(byte)(srcID&0xFF);
              RealIndex_read++;
              return RealIndex_read;
          }              
    }  

    public synchronized int[] getOutConnection(){
        LinkedListDestPort_Out stuff=this;
        int i=0;
        do{
            i+=stuff.RealIndex_read;
            stuff=stuff.next;
        }while(stuff!=null);
        int temp[]=new int[i];
        
        stuff=this;
        int j,k,previous,current;
        i=0;
        previous=0;
        int TotalLength=0;

        byte b; 
        do{
            j=0;
            if(stuff.compressed){
                k=0;                
                while(j<stuff.RealIndex_read){
                    b=stuff.Array[k++];
                    current = b & 0x7F;
                    for(int shift=7;(b & 0x80) != 0; shift += 7){
                        b=stuff.Array[k++];
                        current |= (b & 0x7F) << shift;
                    }
		    current+=previous;
		    previous=current;
                    j++;
                    temp[i++]=previous;
                }
            }
            else{
                while(j<stuff.RealIndex_read){
                    temp[i++]=stuff.Array[j++];
                }
            }
            TotalLength+=stuff.getSize();
            stuff=stuff.next;
        }while(stuff!=null);  
        return temp;
    }   
    
    public synchronized void deleteInConnection(int srcID){
        LinkedListDestPort_Out stuff=this;
        int i=0;
        do{
            i+=stuff.RealIndex_read;
            stuff=stuff.next;
        }while(stuff!=null);
        int temp[]=new int[i];
        
        stuff=this;
        int j,k,previous,current;
        i=0;
        previous=0;
        int TotalLength=0;

        byte b; 
        do{
            j=0;
            if(stuff.compressed){
                k=0;                
                while(j<stuff.RealIndex_read){
                    b=stuff.Array[k++];
                    current = b & 0x7F;
                    for(int shift=7;(b & 0x80) != 0; shift += 7){
                        b=stuff.Array[k++];
                        current |= (b & 0x7F) << shift;
                    }
		    current+=previous;
		    previous=current;
                    j++;
                    if(srcID!=previous)//remove the srcID
                        temp[i++]=previous;
                }
            }
            else{
                while(j<stuff.RealIndex_read){
                    int truc=stuff.Array[j++];
                    if(truc!=srcID)
                        temp[i++]=truc;
                }
            }
            TotalLength+=stuff.getSize();
            stuff=stuff.next;
        }while(stuff!=null);  
        int temp2[]=new int[i];
        System.arraycopy(temp, 0,temp2, 0, i);
        temp=temp2;

        sort(temp,0,temp.length-1);
     //Compression
        byte NewArray[]=new byte[temp.length<<2];
        previous=0;
        k=0;
        for(i=0;i<temp.length;i++){
            current=temp[i]-previous;
            previous=temp[i];
            
            while ((current & ~0x7F) != 0) {
                b = (byte)((current & 0x7f) | 0x80);
                NewArray[k++]=b;	    
                current >>>= 7;
            }
            NewArray[k++]=(byte)current;            
        }
        
        //Clean
        Array=new byte[k];
        System.arraycopy(NewArray,0, Array, 0, k);
        RealIndex_read=temp.length;
        ListSize=RealIndex_read;
        this.compressed=true;
        this.next=null;
        
        LinkedList.TotalMemoryLinkedLists+=this.getSize()-TotalLength;
    }
    
    public short getID(){
        return destPortID;
    }      
    
    public int getSize() {
        return 28+Array.length;
    }
    
    public void compress_final() {
        //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp); 
        compress();
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp); 
    }
    
    public int NumberPerPort() {//dont care about the port
        LinkedListDestPort_Out stuff=this;
        int k=0;
        do{
            k+=stuff.RealIndex_read;
            stuff=stuff.next;
        }while(stuff!=null);
        return k;
    }    
      
}
