
package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;


/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell 
 *         Paul Rogister     
 *
 * @version 1.0, 14 September 2001     
 *                 
 */
public class SourceMethodJarBean implements DoOnBean {
    String name;
    Hashtable params;

    SourceMethod sm;
    public SourceMethodJarBean(String name, Hashtable params) {
	this.name = name;
        this.params = params;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        System.out.println("Running template "+beanName);

	Object o = (Object)ji.getInstance(beanName);
	if (o instanceof neuroml.sim.run.SourceMethod) {
	    // make a converter
	    sm = NeuromlConverter.convertSourceMethod((neuroml.sim.run.SourceMethod)o);
	    // one of the params must be _Model
	    sm.init(name, params); 
	}
	else {
	    sm = (SourceMethod)o;
	    sm.init(name, params);
	}
    }

    public SourceMethod getSourceMethod() { return sm; }
    public void error(String msg) {
        System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("Start bean exception "+msg);
   }
}
