
package neosim.util;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

/** Useful string vector class 
 * splits a string onto a vector
 */
public class StringVector {
    protected Vector v;
    public StringVector() { v = new Vector(); }
    /* version of perl's split */
    public StringVector(String s) { 
        v = new Vector(); 
        StringTokenizer st = new StringTokenizer(s);
        while (st.hasMoreTokens())  { add(st.nextToken()); }  
    }
    public int size() { return v.size(); }
    public Vector getV() { return v; }
    public String[] getA() { 
	return getA(0,size()-1);
    }
    public String[] getA(int start) { 
	return getA(start,size()-1);
    }
    public String[] getA(int start, int end) { 
	String[] ret = new String[end-start+1]; 
	for (int i=start; i<=end; i++) { ret[i-start] = (String)v.elementAt(i); }
	return ret; 
    }
    public void add(String s) { v.addElement(s); }
    public String get( int i ) { return (String)v.elementAt(i); }
    public int find( String s ) {
        String found = null, curr;
        int foundi = 0, i=0;
        Enumeration e;  for (e = v.elements(); e.hasMoreElements();i++) {
            curr = (String)e.nextElement();
            if(s.compareTo(curr) == 0) {  found = curr; foundi = i; }
        }
        return foundi;
    }
}

