
package neuroml.core;

/**
 * A numeric double value with specified units.
 */
public class RandomVariable {
    String name="";

    public PDF pdf;
    public Ref unit;

    public RandomVariable() { 
	this(new PDF(), "null"); 
    }

    /** Constructor for random variables values, e.g.<b>
     *	RNG rng = new RNG("rng1", seed);
     *	PDF pdf = new UniformPDF(min, max, "rng1");
     *  RandomVariable rv = new RandomVariable(pdf, "m");
     * or 
     *	PDF pdf2 = new NormalPDF(mean, variance, "rng1");
     *	PDF pdf3 = new GammaPDF(alpha, beta, shape, "rng1");
     */
    public RandomVariable(PDF pdf, String unitName) { 
	this.pdf = pdf;
	unit = new Ref("Unit");
	unit.setTargetName( unitName );

    }

    public String getName() { return name; }
    public void setName(String n) { name = n; }    

    public PDF getPDF() { return pdf; }
    public void setPDF(PDF pdf) { this.pdf = pdf; }    



}
