package neuroml.core;
import neuroml.util.*;
/** Basic implementation of a serializable pointer.
 * See neuroml.util.NeuromlSys for deRef() method.
 */
public class Ref extends NamedObject implements Reference, ContentRestricted  {
    String type="";
    String targetName="";

    public Ref() { 
    }

    /** Makes a reference of a given type
     * @param type the type of the target object
     */
    public Ref(String type) {
	this.type = type; 
    }

    /** Makes a reference of a given type pointing at target
     * @param type the type of the target object
     * @param target the path name of the target
     */
    public Ref( String type, String target ) {
	this.type = type; 
        NeuromlSys.getNewestNamespace().UpdateRefered("",target,this);
	//targetName = target;
    }

    /** @Deprecated use getContentClassName */
    public String getTargetType() { return type; }
    /** @Deprecated use setContentClassName */
    public void setTargetType(String t) { type = t; } 

    public String getTargetName() { return targetName; }
    public void setTargetName(String n) { 
        NeuromlSys.getNewestNamespace().UpdateRefered(targetName,n,this);
        targetName = n;
    }   
 
    // Implementation of ContentRestricted
    public String getContentClassName() { return type; }
    public void setContentClassName(String s) { type = s; }
}
