package neuroml.environment;
 
import neuroml.core.*;
import neuroml.environment.io.*;
import neuroml.environment.schedule.*;
 
/** Top level class for NeuroML Environment definition<br>
 * The environment defines the inputs and outputs applied 
 * to the simulated model as well as the simulation schedule<p>
 *
 */
public class EnvironmentPkg extends Pkg {
 
    /** The probe definitions and attachments
     */
    public IOPkg io = new IOPkg();
 
    /** The simulation schedule
     */
    public Schedule schedule = new Schedule();

    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = { 
	    "EnvironmentPkg"
	};
	return ret;
    }
}





