/*
 * SynapseIntensity.java
 *
 * Created on 19 October 2004, 16:51
 */

package neuroml.model.MeasurementTool;
import neuroml.model.Synapse_nml.*;
import neuroml.sim.run.*;
import neuroml.core.*;
import neuroml.util.*;
import neuroml.model.cell.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class SynapseIntensity extends MeasurementTool {
    public int IndexChannel=0;
    /** Creates a new instance of SynapseIntensity */
    public SynapseIntensity() {
        super();   
    }

    public double getValue(RunnableCell obj, double t){
       SynapticCell bscc=((SynapticCell)obj);
       return bscc.getIntensitySynapse(IndexChannel); //getChannelIntensity(IndexChannel);
    }
    public String toString(){
        String toAdd=new String();
        if(this.ToBeSent)
            toAdd=new String("");
        else
            toAdd=new String("NOT_");
            
        String str=this.getClass().getName();
        int i=str.lastIndexOf('.');
        if(i>0) 
            str=str.substring(i+1);
        return toAdd+str+"_"+IndexChannel;               
    }
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "Intensity(A)";
    }    
    
    public Object Clone() {
        SynapseIntensity truc=new SynapseIntensity();
        truc.IndexChannel=this.IndexChannel;
        return truc;
    }    
}
