package neuroml.model;

import neuroml.model.cell.CellPkg;
import neuroml.model.channel.ChannelPkg;
import neuroml.model.network.NetworkPkg;
import neuroml.model.ions_channel.Ions_channelPkg;
import neuroml.model.I_Clamp.I_ClampNmlPkg;
import neuroml.model. MeasurementTool. MeasurementToolPkg;
import neuroml.core.*;

/** Top level class for NeuroML
 * It contains an instance of the top level class
 * for each package, generally called <Packagename>Pkg.java
 */
public class ModelPkg extends Pkg {
    public CellPkg    cell = new CellPkg();
    public ChannelPkg channel = new ChannelPkg();
    public NetworkPkg network = new NetworkPkg();
    public Ions_channelPkg ions_channel = new Ions_channelPkg();
    public I_ClampNmlPkg i_clamps = new I_ClampNmlPkg();
    public MeasurementToolPkg measurement_package= new MeasurementToolPkg();

    /** A set of the tools used to build all components of
     * this NeuroML file.  Each object's individual log entries contain references 
     * to elements of this list.
     */
    public Set tools = new Set("ToolInfo");
    public Set units = new Set("Unit");
}





