package neuroml.model.cell;

import neuroml.core.*;

import neuroml.model.channel.*;

/** Top Level Class for a collection of cells 
 */
public class CellPkg extends Pkg {
    public Set solutions = new Set("Solution");
    public Set sectionProperties = new Set("SectionProperties");
    public Set neurons = new Set("AbstractNeuron");
    public Set structures = new Set("NeuronStructure");

    public CellPkg() { }
    public CellPkg(String name) { super(name); }

    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = {
	    "AbstractNeuron",
	    "CableNeuron",
	    "NeuronModule",
	    "ModuleNeuron",
	    "CellPkg",
	    "ChannelAssignment",
	    "Mask",
	    "NeuronStructure",
	    "OrientedSubstructure",
	    "PointNeuron",
	    "SectionProperties",
	    "SectionSet"
	};
	return ret;
    }
}
