package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** The properties of a section.<p>
 * This is typically a list of membrane mechanisms.
 */
public class SectionProperties extends NamedObject {
    
    /** A set of ion channels in this section
     */
    public Set channels = new Set("Channel");

    /** A set of ion solutions in this section
     */
    public Set solutions = new Set("Solution");
    
    public SectionProperties() {
    }

    public SectionProperties(String name) { 
	super(name);
    }

}
