package neuroml.model.channel;

import neuroml.core.*;

/** Top level class for channels.
 * @author Fred Howell, Robert Cannon
 * @date March 2001
 */
public class ChannelPkg extends Pkg {
    public Set channels = new Set("Channel");

    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = {
	    "Channel",
	    "ChannelPkg",
	    "HHChannel",
	    "HHGate",
	    "TabulatedHHGate",
	    "TabulatedHHVGate",
	    "ParameterizedHHVGate",
	    "ThermodynamicHHVGate",
	    "HHRate",
	    "EquationHHRate",
	    "ParameterizedHHRate",
	    "KSChannel",
	    "KSState",
	    "KSTransition",
	    "KSTDepTransition",
	    "KSVDepTransition",
	    "KSConcDepTransition",
	    "KSRelativeTransition",
	    "Pore",
	    "PorePermeator",
	    "Solution",
	    "Specie"
	};
	return ret;
    }
}
