package neuroml.model.channel;

import neuroml.core.*;

/** Allows a gate's forwardRate or backwardRate to be specified by a table
 * at equally spaced voltage (or concentration) points.
 * @author David Beeman, University of Colorado, Boulder
 */
public class TabulatedHHRate extends HHRate {

    /** DoubleArray contains rate values
    */
    public DoubleArray rates = new DoubleArray();

    /** number of data points in the rates array
    */
    public int xpts;

    /** voltage (or concentration) corresponding to first point
    */
    public double xmin;

    /** voltage (or concentration) corresponding to the last point
    */
    public double xmax;

    /** number of points to use if the rate table is expanded with interpolation
    */
    public int fillPoints;

    /** Type of interpolation to use between table entries. e.g. "none"
      * (default) or "linear".
      */
    public String interpolation="none";

    public TabulatedHHRate() {
    }

    public TabulatedHHRate(String name) {
	super(name);
    }

}
