package neuroml.model.network;

import neuroml.core.*;

/** 
 * An indexed population structure.
 */
public class IndexedStructure extends PopulationStructure {
    /** The number of dimensions of this indexing scheme
     */
    
    public int ndims;
    public List dimensions = new List("IndexedDimension");
    
    public IndexedStructure() {
    }
    public IndexedStructure(String name) {super(name); }

    public IndexedStructure(String name, int xsize, int ysize) {
	super(name); 
	ndims = 2;
	IndexedDimension x = new IndexedDimension("x",xsize);
	IndexedDimension y = new IndexedDimension("y",ysize);
	dimensions.addElement(x);
	dimensions.addElement(y);
    }
    public IndexedStructure(String name, int xsize, int ysize, int zsize) {
	super(name); 
	ndims = 3;
	IndexedDimension x = new IndexedDimension("x",xsize);
	IndexedDimension y = new IndexedDimension("y",ysize);
	IndexedDimension z = new IndexedDimension("z",zsize);
	dimensions.addElement(x);
	dimensions.addElement(y);
	dimensions.addElement(z);
    }
}
