package neuroml.sim.run;
 
/** Interface to the simulator to make it instantiate a connection.
 */
public interface ConnectionMaker {
    /** 
     * This method is called by the considerRequest method of DestMethod to 
     * create a connection.
     *
     * @param srcID the source ID
     * @param srcPortID the source port ID
     * @param dstID the destination ID
     * @param dstPortID the destination port ID
     * @param delay the delay on the connection
     * @return the connectionID of this connection
     */
    public int makeConnection( int srcID, short srcPortID, int dstID, short dstPortID, double delay, boolean BuildingConnection );

    /** Alternative form of makeConnection...
     * info extracted from connection request instead.
     * Means that the connection maker has to be initialised with request / destmethod
     * @param dstPortID the destination port ID
     * @param delay the delay on the connection
     * @return unique connection ID for this synapse
     */
    public int makeConnection(short dstPortID, double delay, boolean BuildingConnection);
}
