package neuroml.sim.run;  

/** An interface an object implements if it can respond to queries.
 */
public interface Queryable {

    /** Returns the results of running query q on this object.
     * Usually implemented as "return q.query(this);"
     *
     * @param q the query to run on this object
     * @return the result of the query
     */
    public Object query(Query q);
}
