package neuroml.sim.run;
import neuroml.core.*; 
import neuroml.sim.state.*;
import neuroml.model.MeasurementTool.*;

/** A runnable cell factory - makes runnable cells
 */
public interface RunnableCellFactory {

    /** Make a runnable cell. 
     */
    public RunnableCell makeRunnableCell(PopulationState p, int id,int index, SpikeSender sps);

    /** Set the model of this cell - called by the module loader
     * Needed???
     */
    public void setModel(Object model);

    /** Get the model of this cell
     */
    public Object getModel();
    public void setFactory(MeasurementSet MeasurementList, String str);
    public boolean IsProbe();


    // --------- Temporary -------------

    /** Sets the port values
     * @deprecated - Ports not handled properly yet. Move to org.compneuro method.
     */
    //    public void setInPort(int inport);
    //    public void setOutPort(int outport);

    /** Gets the port values
     */
    //    public int getInPort();
    //    public int getOutPort();
}
