package neuroml.sim.run;
import java.util.Hashtable;

import neuroml.sim.state.*;
import java.awt.Graphics2D;

/** The part of a general projection which runs on
 * each source cell and sends requests to make connections
 * to candidate destination entities.
 */
public interface SourceMethod extends java.io.Serializable {
    /**  
     * The sendRequests method checks the source cell's details 
     * and sends connection requests to individual destination
     * entities (using crs.sendRequest)
     * @param crs Interface to use to send connection requests
     * @param srcState The instantiated source element to connect from.
     * @param dstState The target population's instantated state.
     * @param dm The target destination method, to include in the crs.sendRequest() call.
     */
    public void sendRequests(ConnectionRequestSender crs, 
			     ElementState srcState, 
			     PopulationState dstState, 
			     DestMethod dm, 
                             boolean BuildingConnection); 
        
    public void Draw(Graphics2D g, double x, double y);
    public short getSrcId();//It is the PORT !!! It corresponds to PortID !!!
}
