package neuroml.util;

import java.lang.reflect.*;

import neuroml.core.*;
import neuroml.model.channel.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
 

/**
 * Convert between native neuroml & user extended objects
 *                 
 */
public class Extend {
    
    /** convert neuroml object with default extension
     * if >1 in set, complain! - maybe find sensible extension to use
     */
    public static Object getUserObj( Object extendedNeuromlObj ) {
	return extendedNeuromlObj; // ****** TO BE DONE *****
    }


    /** convert neuroml object with given extension
     */
    public static Object getUserObj( Object extendedNeuromlObj, Extension ext ) {
	return extendedNeuromlObj; // ****** TO BE DONE *****
    }

    /** Replace all instances of old in txt with new
     */
    public static String replace( String txt, String old, String newstr ){
	StringBuffer sb = new StringBuffer();
	int lasti = 0;
	int i;
	do {
	    i = txt.indexOf(old, lasti);
	    if (i==-1) {
		sb.append( txt.substring( lasti, txt.length()));
	    } else {
		// found!
		sb.append( txt.substring( lasti, i ));
		sb.append( newstr );
		lasti = i + old.length();
	    }
	} while (i!=-1);
	return sb.toString();
    }
    
    /** Convert XML string to a quoted string
     * replaces "&lt;" with "&&lltt;;"
     * replaces &lt; with < & vice-versa
     * replaces &gt; with > & vice-versa
     */
    public static String toQuoted(String s) {
	String s1 = replace(s, "&lt;", "&&lltt;;");
	String s2 = replace(s1, "<", "&lt;");
	String s3 = replace(s2, "&gt;", "&&ggtt;;");
	String s4 = replace(s3, ">", "&gt;");
	return s4;
    }

    /** Convert a quoted string to an XML string
     * reverse of ^
     */
    public static String fromQuoted(String s) {
	String s1 = replace(s, "&lt;", "<");
	String s2 = replace(s1, "&&lltt;;", "&lt;");
	String s3 = replace(s2, "&gt;", ">");
	String s4 = replace(s3, "&&ggtt;;", "&gt;");
	return s4;
    }

    /** convert user object to neuroml object with extension field set
     * if possible (meaning user class extends a neuroml.... class
     * AND : that class has a field "public Set extensions"
     */
    public static Object getExtendedNeuromlObject( Object userObj ) {
	boolean canBeDone = false;
	Class c = userObj.getClass();	
	Class sc = null;
	Set s = null;
	Field[] baseFields = new Field[0];
	Object newObject=null;

	do {
	    sc = c.getSuperclass();
	    if (sc!=null) {
		Package p = sc.getPackage();
		if (p.getName().startsWith("neuroml")) {
		    Field f = null;
		    try {
			// *********** WARNING : THIS IS COMPLEX CODE ************
			f = sc.getField("extensions");
			baseFields = sc.getFields();			
			newObject = sc.newInstance();
			for (int j=0; j<baseFields.length; j++) {
			    baseFields[j].set(newObject, baseFields[j].get(userObj));
			}
			s = (Set)f.get(newObject);
			if (s==null) {
			    s = new Set("Extension");
			    f.set(newObject, s);
			}
			canBeDone = true;
			break;
		    } catch (Exception e) {		
			System.out.println("get Ext Obj exception "+e);
		    }				
		}
		c = sc;
	    }
	} while ( sc!=null );
	
	if (canBeDone==true) {
	    Extension e = new Extension();
	    e.extensionClassName = userObj.getClass().getName();
	    e.setName(userObj.getClass().getName()); // Is there a better thing to call it?
	    
	    Field[] extFields = userObj.getClass().getFields();
	    Field[] newFields = new Field[extFields.length - baseFields.length];
	    for (int i=0; i<newFields.length; i++) { 
		newFields[i] = extFields[i+baseFields.length];
	    }

	    //	    e.text = toQuoted( XMLOut.toString( newFields, userObj ) );
	    e.text = XMLOut.toString( newFields, userObj );

	    s.addElement( e );

	    return newObject;
	}
	
	return userObj;
    } 
}
