/** Load a java bean from a jar file
 */

package neuroml.util;

import java.util.*;
import java.beans.*;

/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 October 2000     
 *                 
 */
public class ObjectBean implements DoOnBean {
    String name;
    String beanName;
    Object o;
    static boolean debug = true;
    public ObjectBean(String name) {
	this.name = name;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        if (debug) { System.out.println("NeuroML Module Loader Loading "+beanName); }
        o = ji.getInstance(beanName);
        if(o instanceof neosim.util.loaders.nmllauncher.XML_Reader)
            System.out.println("found "+o.getClass().getName());
        else
            System.out.println("not found " +o.getClass().getName());
	this.beanName = beanName;
    }
    public Object getObject() { return o; }
    public String getBeanName() { return beanName; }
    public void error(String msg) {
        System.out.println("NeuroML Module Loader error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("NeuroML Module Loader exception "+msg);
   }
}
