/*
 * BasicChannelCellFactory.java
 *
 * Created on 19 August 2004, 17:45
 */

package neuroml.util.module;
import neuroml.model.ions_channel.*;
import neuroml.core.*;
import neuroml.sim.run.RunnableCell;
import neuroml.sim.run.SpikeSender;
import neuroml.sim.state.PopulationState;
import neuroml.model.MeasurementTool.*;
import java.awt.*;
import guikit.*;
import java.awt.geom.*;
import neuroml.model.network.*;
import neuroml.model.I_Clamp.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class BasicChannelCellFactory extends BasicRunnableCellFactory {
    public double Capacity_Membrane=0.01;
    public Set Channels = new Set("ModuleChannel");
    public double diameter=5e-5;
    public double dt;  
    public double InitialV=-0.065;
    public double dv_trigger;
    public double minV_trigger;
    /** Creates a new instance of BasicChannelCellFactory */
    
    
    public BasicChannelCellFactory()
    {
        dt = 0.050000000000000003D;
        
        
    }

    public void setFactory(MeasurementSet MeasurementList, String str) {
        super.setFactory(MeasurementList,str);
        
//let's consider 4 channels, if there are less then don't use them
        // if more then use the index to use them if required
        ModuleMeasurement mdlmr=new ModuleMeasurement();
        MeasurementTool msTool = new ChannelIntensityMeasurement(str); 
        ((ChannelIntensityMeasurement)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);
        
        mdlmr=new ModuleMeasurement();
        msTool = new ChannelIntensityMeasurement(str); 
        ((ChannelIntensityMeasurement)msTool).IndexChannel=1;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);        

        mdlmr=new ModuleMeasurement();
        msTool = new ChannelIntensityMeasurement(str); 
        ((ChannelIntensityMeasurement)msTool).IndexChannel=2;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);                
        
//        MeasurementList.add(new ChannelIntensityMeasurement(str));
        
        mdlmr=new ModuleMeasurement();
        msTool = new Channel_mORn_measurement(str);
        ((Channel_mORn_measurement)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);
        
        mdlmr=new ModuleMeasurement();
        msTool = new Channel_mORn_measurement(str);
        ((Channel_mORn_measurement)msTool).IndexChannel=1;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);
        
        mdlmr=new ModuleMeasurement();
        msTool = new Channel_mORn_measurement(str);
        ((Channel_mORn_measurement)msTool).IndexChannel=2;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);        
        
 //       MeasurementList.add(new Channel_mORn_measurement(str));
        
        mdlmr=new ModuleMeasurement();
        msTool = new Channel_h_measurement(str);
        ((Channel_h_measurement)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);   
        
        mdlmr=new ModuleMeasurement();
        msTool = new Channel_h_measurement(str);
        ((Channel_h_measurement)msTool).IndexChannel=1;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);   

        mdlmr=new ModuleMeasurement();
        msTool = new Channel_h_measurement(str);
        ((Channel_h_measurement)msTool).IndexChannel=2;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);   
                
//        MeasurementList.add(new Channel_h_measurement(str));
        
    }   
    public RunnableCell makeRunnableCell(PopulationState populationstate, int id,int index, SpikeSender spikesender)
    {
        return new BasicChannelCell(this, populationstate, id,index, spikesender, InitialV);
    }
    
    public void DrawExtra(Graphics2D g, Object pop, double x, double y, double width, double height, String msg, boolean selected, Font f){
        g.setStroke(new BasicStroke(4.0f));
        g.setColor(Color.green);
//draw 3 channels        
        g.draw(new Line2D.Double(x ,y-height*0.25,x,y-height*0.45));
        g.draw(new Line2D.Double(x-0.17*0.25*width,y-height*0.25*0.984,x-0.17*0.45*width,y-height*0.45*0.984));
        g.draw(new Line2D.Double(x+0.17*0.25*width,y-height*0.25*0.984,x+0.17*0.45*width,y-height*0.45*0.984));
        
        //Very nasty hack having nothing to do with visualization, but necessary to ensure that Channels are named
/*        if(((ChannelMeasurement)(MeasurementList.elementAt(4))).EmptySet()){
            for(int i=4;i<12;i++){
	    	Object obj=MeasurementList.elementAt(i);
                if(obj instanceof ChannelMeasurement)
                    ((ChannelMeasurement)obj).setChannelSet(Channels);
            }
        }*/
            
   }
    public Color getColorSoma(){
        return Color.YELLOW;
    }    
}
