/**
 * Basic projection module
 */

package neuroml.util.module;

import neuroml.sim.run.*;
import neuroml.sim.state.*;

 
/** Basic buildable projection - just a holder for source and dest methods.
 * Useful for packaging a given projection in a single module.
 */
public class BasicProjection implements BuildableProjection {
     
    public SourceMethod sourceMethod;
    public DestMethod destMethod;

    public BasicProjection() { 
    }
    public BasicProjection(SourceMethod sm, DestMethod dm) { 
	sourceMethod = sm;
	destMethod = dm;
    }
    public SourceMethod getSourceMethod() { return sourceMethod; }
    public DestMethod getDestMethod() { return destMethod; }    
}
