// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 11/12/2003 15:36:44
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   NetActivity.java

package Holger_modules.module.netactivity;

import Holger_modules.datatypes.Curve;
import Holger_modules.module.multiprobe.*;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.*;
import java.util.*;
import javax.swing.JFrame;
import javax.swing.JPanel;
import neuroml.core.List;
import neuroml.sim.run.*;
//import neuroml.sim.state.ConnectionState;
import neuroml.sim.state.ElementState;
import neuroml.util.NeuromlSys;
import Holger_modules.ptolemy.plot.Plot;
import Holger_modules.ptolemy.plot.PlotFormatter;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
public final class NetActivity
    implements PluggableProbe, DestMethod
{

    private static final String VERSION = "1.0, January 2002";
    private static final String AUTHOR = "Holger Bringmann (hcb@lambdabase.de)";
    public int panelNdx;
    public int height;
    public double tempRes;
    public double epsilon;
    public String title;
    public String xLabel;
    public double xRangeStart;
    public double xRangeEnd;
    public String yLabel;
    public double yRangeStart;
    public double yRangeEnd;
    public boolean grid;
    public boolean color;
    protected Plot plot;
    protected Curve activity;
    protected Vector datax;
    protected Vector datay;
    protected int numNeurons;
    private boolean registerToCtrl;
    
    public NetActivity()
    {
        panelNdx = 0;
        height = 100;
        tempRes = 0.10000000000000001D;
        epsilon = 0.0D;
        title = "population activity";
        xLabel = "";
        xRangeStart = 0.0D;
        xRangeEnd = 1.0D;
        yLabel = "";
        yRangeStart = 0.0D;
        yRangeEnd = 1.0D;
        grid = true;
        color = true;
        activity = new Curve();
        datax = new Vector();
        datay = new Vector();
        numNeurons = 0;
        registerToCtrl = true;
    }

    public void reset()
    {
        registerToCtrl = true;
    }

    public void build()
    {
        datax = activity.x.getElements();
        datay = activity.y.getElements();
        activity = new Curve();
        plot = new Plot();
        plot.setBackground(Color.lightGray);
        plot.setForeground(Color.black);
        plot.addYTick((new Integer((int)yRangeStart)).toString(), (int)yRangeStart);
        plot.addYTick((new Integer((int)yRangeEnd)).toString(), (int)yRangeEnd);
        plot.setVisible(true);
        plot.setConnected(false);
        plot.setTitle(title);
        plot.setImpulses(true);
        plot.setXRange(xRangeStart, xRangeEnd);
        plot.setYRange(yRangeStart, yRangeEnd);
        plot.setMarksStyle("none");
        plot.setGrid(grid);
        plot.setColor(color);
        plot.setXLabel(xLabel);
        plot.setYLabel(yLabel);
        for(int i = 0; i < datax.size(); i++)
            plot.addPoint(0, ((Double)datax.elementAt(i)).doubleValue(), ((Double)datay.elementAt(i)).doubleValue(), false);

    }

    protected void setConnectionParameters(String s, int i, int j, double d)
    {
        build();
        title = s;
        plot.setTitle(s);
        height = i;
        panelNdx = j;
        tempRes = d;
    }

    protected int getTimeSlot(double d)
    {
        boolean flag = false;
        int i;
        for(i = 0; !flag && i < datax.size();)
            if(epsilon == 0.0D)
            {
                if(d == ((Double)datax.elementAt(i)).doubleValue())
                    flag = true;
                else
                    i++;
            } else
            {
                double d1 = ((Double)datax.elementAt(i)).doubleValue();
                if(d <= d1 + epsilon && d >= d1 - epsilon)
                    flag = true;
                else
                    i++;
            }

        if(!flag)
        {
            datax.addElement(new Double(d));
            datay.addElement(new Double(0.0D));
        }
        return i;
    }

    public void handleSpike(int i, double d)
    {
        d -= tempRes;
        if(d > plot.getXRange()[0])
        {
            plot.setXRange(xRangeStart, d);
            xRangeEnd = d;
            plot.repaint();
        }
        int j = getTimeSlot(d);
        datay.setElementAt(new Double(((Double)datay.elementAt(j)).doubleValue() + 1.0D / (double)numNeurons), j);
        plot.addPoint(0, ((Double)datax.elementAt(j)).doubleValue(), ((Double)datay.elementAt(j)).doubleValue(), false);
    }

    public void handle(Object obj, int i, double d)
    {
    }

    protected void updatePlotConfig()
    {
        title = plot.getTitle();
        double ad[] = plot.getXRange();
        xRangeStart = ad[0];
        xRangeEnd = ad[1];
        double ad1[] = plot.getYRange();
        yRangeStart = ad1[0];
        yRangeEnd = ad1[1];
        grid = plot.getGrid();
        color = plot.getColor();
        xLabel = plot.getXLabel();
        yLabel = plot.getYLabel();
    }

    public void configure()
    {
        PlotFormatter plotformatter = new PlotFormatter(plot);
        plotformatter.openModal();
        updatePlotConfig();
    }

    public JComponent getPanel()
    {
        return plot;
    }

    public int getRelativePanelSize()
    {
        return height;
    }

    public int getPanelIndex()
    {
        return panelNdx;
    }

    public void exportEPS(OutputStream outputstream)
        throws IOException
    {
        plot.export(outputstream);
    }

    public void hideXMLData()
    {
        activity = new Curve();
    }

    public void discloseXMLData()
    {
        activity.x.setElements(datax);
        activity.y.setElements(datay);
        activity.numElements = numNeurons;
    }

    public void exportXML(OutputStream outputstream)
        throws IOException
    {
        discloseXMLData();
        byte abyte0[] = NeuromlSys.toString(this).getBytes();
        outputstream.write(abyte0);
        hideXMLData();
    }

    public void setXRange(double ad[])
    {
        plot.setXRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public void setYRange(double ad[])
    {
        plot.setYRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public double[] getXRange()
    {
        return plot.getXRange();
    }

    public double[] getYRange()
    {
        return plot.getYRange();
    }

    public void fitData()
    {
        plot.fillPlot();
        plot.setYRange(yRangeStart, yRangeEnd);
        updatePlotConfig();
        plot.repaint();
    }

    public void init(String s, Hashtable hashtable)
    {
        System.out.println(this + " not supported :init/2 called");
    }

    public boolean considerRequest(ConnectionMaker connectionmaker, ElementState elementstate, ConnectionRequest connectionrequest, boolean BuildingConnection)
    {
        short i = (short)1;
        boolean flag = false;
//        ConnectionStateImpl connectionstateimpl = null;
        boolean flag1 = false;
        if(elementstate instanceof ProbeCtrlAdapter)
        {
           //JAG
           // connectionstateimpl = new ConnectionStateImpl(connectionrequest.sourceID, connectionrequest.sourceOutputID, elementstate.getID(), i, tempRes);
           // int j = connectionmaker.makeConnection(connectionstateimpl);
           int j=connectionmaker.makeConnection(connectionrequest.getSrcID(), connectionrequest.getSrcPortID(), elementstate.getID(), i, tempRes, BuildingConnection);
           ((RunnableCell)elementstate).setMeasured(connectionrequest.getSrcID(),null);
           if(BuildingConnection) {
              ProbeCtrlAdapter probectrladapter = (ProbeCtrlAdapter)elementstate;
              if(registerToCtrl)
              {
                  setConnectionParameters(title, height, panelNdx, tempRes);
                  probectrladapter.registerProbe(this);
              }
              registerToCtrl = false;
              numNeurons++;
           }
           else
              numNeurons--; 
            //JAG
           return true;
        } else
        {
            System.out.println(this + " considerRequest/3 error : cellstate " + elementstate);
            //JAG
            return false;
        }
        //JAG
       // return connectionstateimpl;
    }

    public static void main(String args[])
    {
        System.out.println("\nPackage:  de.lambdabase.neuroml.module.netactivity, v1.0, January 2002");
        System.out.println("Author :  Holger Bringmann (hcb@lambdabase.de)");
        System.out.println("Usage  :  java -classpath \"...\" -jar NetActivity.jar [input NeuroML] [output EPS]\n");
        JFrame jframe = new JFrame();
        jframe.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent windowevent)
            {
                System.exit(0);
            }

        });
        NetActivity netactivity;
        if(args.length > 0)
        {
            jframe.setTitle("Loaded from " + args[0]);
            netactivity = (NetActivity)NeuromlSys.loadXML(args[0]);
            netactivity.build();
        } else
        {
            jframe.setTitle("Generated example");
            netactivity = new NetActivity();
            netactivity.title = "Relative activity";
            netactivity.xLabel = "time [s]";
            netactivity.yLabel = "A";
            netactivity.build();
            Random random = new Random();
            for(int i = 0; i < 1500; i++)
                netactivity.plot.addPoint(0, Math.abs(Math.sin((double)i / 2D) * 0.69999999999999996D + 0.29999999999999999D * random.nextDouble()), (((double)(i % 25) / 25D) * (double)i) / 1500D, false);

        }
        jframe.pack();
        jframe.setSize(400, 250);
        jframe.getContentPane().add(netactivity.getPanel());
        jframe.setVisible(true);
        if(args.length > 1)
            try
            {
                FileOutputStream fileoutputstream = new FileOutputStream(args[1], false);
                netactivity.exportEPS(fileoutputstream);
                fileoutputstream.close();
                System.out.println("Exported EPS data to file " + args[1]);
            }
            catch(IOException ioexception)
            {
                System.out.println("Filestram exception on file " + args[1] + ": \n" + ioexception.getMessage());
            }
    }

    public short getDstPortID() {
        //JAG see considerRequest
        return (short)2; //2 for measurements
    }
    
    public void Draw(Graphics2D g, double x, double y) {
        g.setColor(Color.white);
        g.fill(new Rectangle2D.Double(x-16,y-12, 32, 24));
        g.setStroke(new java.awt.BasicStroke(1));
        g.setColor(Color.blue.darker().darker());
        g.draw(new Line2D.Double(x-16,y+8,x-12,y+8));
        g.draw(new Line2D.Double(x-12,y+8,x-6,y));
        g.draw(new Line2D.Double(x-6,y-10,x-6,y+10));
        g.draw(new Line2D.Double(x-6,y+10,x+2,y+8));
        g.draw(new Line2D.Double(x+2,y+8,x+6,y+8));
        g.draw(new Line2D.Double(x+6,y+8,x+12,y));
        g.draw(new Line2D.Double(x+12,y-10,x+12,y+10));
        g.draw(new Line2D.Double(x+12,y+10,x+16,y+8));
        
        g.setColor(Color.BLACK);
        g.draw(new Rectangle2D.Double(x-16,y-12, 32, 24));
    }
    
}