// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 11/12/2003 15:42:18
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) i
// Source File Name:   Voltmeter.java

package Holger_modules.module.voltmeter;

import Holger_modules.datatypes.Curve;
import Holger_modules.datatypes.Spiketrain;
import Holger_modules.module.multiprobe.*;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.*;
import java.util.*;
import javax.swing.*;
import neuroml.core.List;
import neuroml.sim.run.*;
//import neuroml.sim.state.ConnectionState;
import neuroml.sim.state.ElementState;
import neuroml.sim.run.RunnableCell;
import neuroml.util.NeuromlSys;
import neuroml.model.MeasurementTool.*;
import Holger_modules.ptolemy.plot.Plot;
import Holger_modules.ptolemy.plot.PlotFormatter;

import java.awt.*;
import java.awt.geom.*;

public final class Voltmeter implements PluggableProbe, DestMethod, MeasurementMethod {
    public Voltmeter(){
//        label = "voltmeter";
        panelNdx = 0;
        height = 100;
        tempRes = 0.10000000000000001D;
        title = "Untitled voltmeter";
        xLabel = "";
        xRangeStart = 0.0D;
        xRangeEnd = 1.0D;
        yLabel = "";
        yRangeStart = 0.0D;
        yRangeEnd = 1.0D;
        style = "none";
        connected = true;
        grid = true;
        color = true;
        curve = new Curve();
        spiketrain = new Spiketrain();
        curvedata = new Curve();
        spiketraindata = new Spiketrain();
//        curveLabel = null;
    }

    public void build() {
        spiketraindata = spiketrain;
        spiketrain = new Spiketrain();
        curvedata = curve;
        curve = new Curve();
        plot = new Plot();
        plot.setBackground(Color.lightGray);
        plot.setForeground(Color.black);
        plot.addYTick((new Integer((int)yRangeStart)).toString(), (int)yRangeStart);
        plot.addYTick((new Integer((int)yRangeEnd)).toString(), (int)yRangeEnd);
        plot.setVisible(true);
        plot.setConnected(connected);
        plot.setTitle(title);
        plot.setImpulses(false);
        plot.setMarksStyle(style);
        plot.setXRange(xRangeStart, xRangeEnd);
        plot.setYRange(yRangeStart, yRangeEnd);
        plot.setGrid(grid);
        plot.setColor(color);
        plot.setXLabel(xLabel);
        plot.setYLabel(yLabel);
        for(int i = 0; i < curvedata.numElements; i++)
            plot.addPoint(0, ((Double)curvedata.x.elementAt(i)).doubleValue(), ((Double)curvedata.y.elementAt(i)).doubleValue(), true);
    }

    public void reset(){ }

    protected void setConnectionParameters(String s, int i, int j, double d){
        build();
        title = s;
        plot.setTitle(s);
        height = i;
        panelNdx = j;
        tempRes = d;
    }

    public void handleSpike(int i, double d) {
        spiketraindata.spikes.addElement(new Double(d));
        spiketraindata.numSpikes++;
    }

    public void handle(Object obj, int i, double d) {
        if(i == cellCID && (obj instanceof Curve) ) {//&& (curveLabel == null || curveLabel.equals(((Curve)obj).label))
            Curve curve1 = (Curve)obj;
            d -= tempRes;
            if(d > plot.getXRange()[0]) {
                plot.setXRange(xRangeStart, d);
                xRangeEnd = d;
                plot.repaint();
            }
            for(int j = 0; j < curve1.x.getElements().size(); j++) {
                plot.addPoint(0, ((Double)curve1.x.elementAt(j)).doubleValue(), ((Double)curve1.y.elementAt(j)).doubleValue(), connected);
                curvedata.x.addElement(curve1.x.elementAt(j));
                curvedata.y.addElement(curve1.y.elementAt(j));
                curvedata.numElements++;
            }
        }
    }

    protected void updatePlotConfig() {
        title = plot.getTitle();
        style = plot.getMarksStyle();
        double ad[] = plot.getXRange();
        xRangeStart = ad[0];
        xRangeEnd = ad[1];
        double ad1[] = plot.getYRange();
        yRangeStart = ad1[0];
        yRangeEnd = ad1[1];
        grid = plot.getGrid();
        color = plot.getColor();
        xLabel = plot.getXLabel();
        yLabel = plot.getYLabel();
    }

    public void configure() {
        PlotFormatter plotformatter = new PlotFormatter(plot);
        plotformatter.openModal();
        updatePlotConfig();
    }

    public JComponent getPanel() {
        return plot;
    }

    public int getRelativePanelSize() {
        return height;
    }

    public int getPanelIndex() {
        return panelNdx;
    }

    public void exportEPS(OutputStream outputstream)
        throws IOException {
        plot.export(outputstream);
    }

    public void hideXMLData() {
        curve = new Curve();
        spiketrain = new Spiketrain();
    }

    public void discloseXMLData() {
        spiketrain = spiketraindata;
        curve = curvedata;
    }

    public void exportXML(OutputStream outputstream)
        throws IOException {
        discloseXMLData();
        byte abyte0[] = NeuromlSys.toString(this).getBytes();
        outputstream.write(abyte0);
        hideXMLData();
    }

    public void setXRange(double ad[]) {
        plot.setXRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public void setYRange(double ad[]) {
        plot.setYRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public double[] getXRange() {
        return plot.getXRange();
    }

    public double[] getYRange() {
        return plot.getYRange();
    }

    public void fitData() {
        plot.fillPlot();
        updatePlotConfig();
        plot.repaint();
    }

    public void init(String s, Hashtable hashtable) {
        System.out.println(this + " not supported :init/2 called");
    }

    public boolean considerRequest(ConnectionMaker connectionmaker, ElementState elementstate, ConnectionRequest connectionrequest, boolean BuildingConnection) {
        int i = 1;
        //StringTokenizer stringtokenizer = new StringTokenizer(label, ".");
       // int j = Integer.valueOf(stringtokenizer.nextToken()).intValue();
//        if(stringtokenizer.hasMoreElements())
//            curveLabel = label; //stringtokenizer.nextToken();
        //if(j == connectionrequest.getSrcID())
            if(elementstate instanceof ProbeCtrlAdapter) {
                 cellCID = connectionmaker.makeConnection(connectionrequest.getSrcID(), connectionrequest.getSrcPortID(), elementstate.getID(), this.getDstPortID(), tempRes, BuildingConnection);//i
                 //((MeasurementHandler)out)
                 ((RunnableCell)elementstate).setMeasured(connectionrequest.getSrcID(),new MeasurementCollection(MeasurementList,SrcId));
     //            final public void         queryEntity( Time t, EntityID e, EntityQuery eq, Callback c ) {
	//sk.queryEntity( handle, t, e, eq, c );
   // 
                 
                if(BuildingConnection){ 
                    ProbeCtrlAdapter probectrladapter = (ProbeCtrlAdapter)elementstate;
                    setConnectionParameters(title, height, panelNdx, tempRes);
                    probectrladapter.registerProbe(this);
                }
                return true;
            } else
            {
                System.out.println(this + " considerRequest/3 error : cellstate " + elementstate);
            }
        return false;
    }

    public static void main(String args[]) {
        System.out.println("\nPackage:  de.lambdabase.neuroml.module.voltmeter, v1.1, January 2002");
        System.out.println("Author :  Holger Bringmann (hcb@lambdabase.de)");
        System.out.println("Usage  :  java -classpath \"...\" -jar Voltmeter.jar [input NeuroML] [output EPS]\n");
        JFrame jframe = new JFrame();
        jframe.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent windowevent) {
                System.exit(0);
            }

        });
        Voltmeter voltmeter;
        if(args.length > 0) {
            jframe.setTitle("Loaded from " + args[0]);
            voltmeter = (Voltmeter)NeuromlSys.loadXML(args[0]);
            voltmeter.build();
        } 
        else {
            jframe.setTitle("Generated example");
            voltmeter = new Voltmeter();
            voltmeter.title = "Normalized sinus cell ;-)";
            voltmeter.xLabel = "time [ms]";
            voltmeter.yLabel = "";
            voltmeter.xRangeEnd = 2D;
            voltmeter.build();
            Random random = new Random();
            for(int i = 0; i < 1500; i++)
                voltmeter.plot.addPoint(0, (double)i / 500D, (Math.sin((double)i / 30D) / 2D + 0.5D) / ((double)i / 120D), true);
        }
        jframe.pack();
        jframe.setSize(400, 250);
        jframe.getContentPane().add(voltmeter.getPanel());
        jframe.setVisible(true);
        if(args.length > 1)
            try {
                FileOutputStream fileoutputstream = new FileOutputStream(args[1], false);
                voltmeter.exportEPS(fileoutputstream);
                fileoutputstream.close();
                System.out.println("Exported EPS data to file " + args[1]);
            }
            catch(IOException ioexception) {
                System.out.println("Filestram exception on file " + args[1] + ": \n" + ioexception.getMessage());
            }
    }

    public short getDstPortID() {
        return DestPort; //Measurements are monitored on port 2 //JAG
    }
    
    public void Draw(Graphics2D g, double x, double y) {
        g.setColor(Color.GREEN.darker());
        g.fill(new Rectangle2D.Double(x-16,y-12, 32, 24));
        g.setStroke(new java.awt.BasicStroke(1));
        g.setColor(Color.white);
        g.draw(new Line2D.Double(x-16,y-8,x-8,y-8));
        g.draw(new Line2D.Double(x-8,y-8,x,y+8));
        g.draw(new Line2D.Double(x,y+8,x+8,y-8));
        g.draw(new Line2D.Double(x+8,y-8,x+16,y-8));
        g.setColor(Color.GREEN.darker().darker());
        g.draw(new Rectangle2D.Double(x-16,y-12, 32, 24));
        
        /*
        g.setColor(Color.black);
        g.setStroke(stroke);
        g.draw(new Rectangle2D.Double(x-width*0.1,y-height*0.6, width*0.2, height*0.1));
        
        g.setColor(Color.white.darker());        
        g.fill( new RoundRectangle2D.Double( x-width*0.5, y-height*0.5, width, height,width*0.2, height*0.2) );
        
        
        
        g.setColor(Color.DARK_GRAY);
        g.fill( new RoundRectangle2D.Double( x-width*0.4, y-height*0.4, width*0.8, height*0.8,width*0.16, height*0.16) );
        g.setColor(Color.white.darker());
        g.fill(new Ellipse2D.Double(x-SIZE*0.5,  y-SIZE*0.5, SIZE,SIZE));
        g.setStroke( new BasicStroke(1.0f));
        g.setColor(Color.black);        
        
        g.fill(new Ellipse2D.Double(x-SIZE*0.4,  y-SIZE*0.4, SIZE*0.8,SIZE*0.8));
        g.draw(new Ellipse2D.Double(x-SIZE*0.5,  y-SIZE*0.5, SIZE,SIZE));
        g.draw( new RoundRectangle2D.Double( x-width*0.5, y-height*0.5, width, height,width*0.2, height*0.2) );
        g.draw( new RoundRectangle2D.Double( x-width*0.4, y-height*0.4, width*0.8, height*0.8,width*0.16, height*0.16) );   */     
    }
    
    public void SetParent(neuroml.model.network.Attachment myParent, short srcId) {
        Object[] array=myParent.MeasurementList.toArray();
        this.SrcId=srcId;
        Vector MeasurementVector=new Vector();
        for(int i=0;i<array.length;i++){
            if(((MeasurementTool)array[i]).ToBeSent)
                MeasurementVector.add((MeasurementTool)array[i]);
        }
        MeasurementList=new MeasurementTool[MeasurementVector.size()];
        for(int i=0;i<MeasurementList.length;i++)
            MeasurementList[i]=(MeasurementTool)MeasurementVector.elementAt(i);
    }
    protected short SrcId=(short)0;
    private static final String VERSION = "1.1, January 2002";
    private static final String AUTHOR = "Holger Bringmann (hcb@lambdabase.de)";
//    public String label;
    public int panelNdx;
    public int height;
    public short DestPort=(short)2;
    public double tempRes;
    public String title;
    public String xLabel;
    public double xRangeStart;
    public double xRangeEnd;
    public String yLabel;
    public double yRangeStart;
    public double yRangeEnd;
    public String style;
    public boolean connected;
    public boolean grid;
    public boolean color;
    protected Plot plot;
    protected Curve curve;
    protected Spiketrain spiketrain;
    protected Curve curvedata;
    protected Spiketrain spiketraindata;
    protected int cellCID;
//    protected String curveLabel;
    protected MeasurementTool[] MeasurementList;
}