// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:05
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   EPSGraphics.java

package Holger_modules.ptolemy.plot;

import java.awt.*;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.image.ImageObserver;
import java.io.*;
import java.text.AttributedCharacterIterator;
import java.util.Hashtable;

public class EPSGraphics extends Graphics
{

    public EPSGraphics(OutputStream out, int width, int height)
    {
        _currentColor = Color.black;
        _linepattern = new Hashtable();
        _buffer = new StringBuffer();
        _patternIndex = 0;
        _width = width;
        _height = height;
        _out = out;
        _buffer.append("%!PS-Adobe-3.0 EPSF-3.0\n");
        _buffer.append("%%Creator: UC Berkeley Plot Package\n");
        _buffer.append("%%BoundingBox: 50 50 " + (50 + width) + " " + (50 + height) + "\n");
        _buffer.append("%%Pages: 1\n");
        _buffer.append("%%Page: 1 1\n");
        _buffer.append("%%LanguageLevel: 2\n");
    }

    private Point _convert(int x, int y)
    {
        return new Point(x + 50, (_height + 50) - y);
    }

    private void _fillPattern()
    {
        int red = _currentColor.getRed();
        int green = _currentColor.getGreen();
        int blue = _currentColor.getBlue();
        double bluescale = 0.59999999999999998D;
        double redscale = 0.80000000000000004D;
        double greenscale = 1.0D;
        double fullscale = Math.sqrt(65025D * (bluescale * bluescale + redscale * redscale + greenscale * greenscale));
        double graylevel = Math.sqrt((double)(red * red) * redscale * redscale + (double)(blue * blue) * bluescale * bluescale + (double)(green * green) * greenscale * greenscale) / fullscale;
        _buffer.append(graylevel + " setgray\n");
        _buffer.append("%---- rgb: " + red + " " + green + " " + blue + "\n");
    }

    private boolean _polygon(int xPoints[], int yPoints[], int nPoints)
    {
        if(nPoints < 3 || xPoints.length < nPoints || yPoints.length < nPoints)
            return false;
        Point start = _convert(xPoints[0], yPoints[0]);
        _buffer.append("newpath " + start.x + " " + start.y + " moveto\n");
        for(int i = 1; i < nPoints; i++)
        {
            Point vertex = _convert(xPoints[i], yPoints[i]);
            _buffer.append(vertex.x + " " + vertex.y + " lineto\n");
        }

        return true;
    }

    public void clearRect(int i, int j, int k, int l)
    {
    }

    public void clipRect(int i, int j, int k, int l)
    {
    }

    public void copyArea(int i, int j, int k, int l, int i1, int j1)
    {
    }

    public Graphics create()
    {
        return new EPSGraphics(_out, _width, _height);
    }

    public void dispose()
    {
    }

    public void drawArc(int i, int j, int k, int l, int i1, int j1)
    {
    }

    public boolean drawImage(Image img, int dx1, int dy1, int i, int j, int k, int l, 
            int i1, int j1, Color color, ImageObserver imageobserver)
    {
        return true;
    }

    public boolean drawImage(Image img, int dx1, int dy1, int i, int j, int k, int l, 
            int i1, int j1, ImageObserver imageobserver)
    {
        return true;
    }

    public boolean drawImage(Image img, int x, int y, int i, int j, Color color, ImageObserver imageobserver)
    {
        return true;
    }

    public boolean drawImage(Image img, int x, int y, int i, int j, ImageObserver imageobserver)
    {
        return true;
    }

    public boolean drawImage(Image img, int x, int y, Color color, ImageObserver imageobserver)
    {
        return true;
    }

    public boolean drawImage(Image img, int x, int y, ImageObserver imageobserver)
    {
        return true;
    }

    public void drawLine(int x1, int y1, int x2, int y2)
    {
        Point start = _convert(x1, y1);
        Point end = _convert(x2, y2);
        _buffer.append("newpath " + start.x + " " + start.y + " moveto\n");
        _buffer.append(end.x + " " + end.y + " lineto\n");
        _buffer.append("stroke\n");
    }

    public void drawOval(int x, int y, int width, int height)
    {
        int radius = width / 2;
        Point center = _convert(x + radius, y + radius);
        _buffer.append("newpath " + center.x + " " + center.y + " " + radius + " 0 360 arc closepath stroke\n");
    }

    public void drawPolygon(int xPoints[], int yPoints[], int nPoints)
    {
        if(!_polygon(xPoints, yPoints, nPoints))
        {
            return;
        } else
        {
            _buffer.append("closepath stroke\n");
            return;
        }
    }

    public void drawPolyline(int ai[], int ai1[], int i)
    {
    }

    public void drawRect(int x, int y, int width, int height)
    {
        Point start = _convert(x, y);
        _buffer.append("newpath " + start.x + " " + start.y + " moveto\n");
        _buffer.append("0 " + -height + " rlineto\n");
        _buffer.append(width + " 0 rlineto\n");
        _buffer.append("0 " + height + " rlineto\n");
        _buffer.append(-width + " 0 rlineto\n");
        _buffer.append("closepath stroke\n");
    }

    public void drawRoundRect(int i, int j, int k, int l, int i1, int j1)
    {
    }

    public void drawString(String str, int x, int y)
    {
        Point start = _convert(x, y);
        _buffer.append(start.x + " " + start.y + " moveto\n");
        _buffer.append("(" + str + ") show\n");
    }

    public void drawString(AttributedCharacterIterator iterator, int x, int y)
    {
        throw new RuntimeException("Sorry, drawString(java.text.AttributedCharacterIterator, int , int) is not implemented in EPSGraphics");
    }

    public void fillArc(int i, int j, int k, int l, int i1, int j1)
    {
    }

    public void fillOval(int x, int y, int width, int height)
    {
        int radius = width / 2;
        Point center = _convert(x + radius, y + radius);
        _buffer.append("newpath " + center.x + " " + center.y + " " + radius + " 0 360 arc closepath fill\n");
    }

    public void fillPolygon(int xPoints[], int yPoints[], int nPoints)
    {
        if(!_polygon(xPoints, yPoints, nPoints))
        {
            return;
        } else
        {
            _buffer.append("closepath fill\n");
            return;
        }
    }

    public void fillRect(int x, int y, int width, int height)
    {
        Point start = _convert(x, y);
        _fillPattern();
        _buffer.append("newpath " + start.x + " " + start.y + " moveto\n");
        _buffer.append("0 " + -height + " rlineto\n");
        _buffer.append(width + " 0 rlineto\n");
        _buffer.append("0 " + height + " rlineto\n");
        _buffer.append(-width + " 0 rlineto\n");
        _buffer.append("closepath gsave fill grestore\n");
        _buffer.append("0.5 setlinewidth 0 setgray [] 0 setdash stroke\n");
        _buffer.append("1 setlinewidth\n");
    }

    public void fillRoundRect(int i, int j, int k, int l, int i1, int j1)
    {
    }

    public Shape getClip()
    {
        return null;
    }

    public Rectangle getClipBounds()
    {
        return null;
    }

    public Color getColor()
    {
        return _currentColor;
    }

    public Font getFont()
    {
        return _currentFont;
    }

    public FontMetrics getFontMetrics(Font f)
    {
        return null;
    }

    public void setClip(int i, int j, int k, int l)
    {
    }

    public void setClip(Shape shape)
    {
    }

    public void setColor(Color c)
    {
        if(c == Color.black)
        {
            _buffer.append("0 setgray\n");
            _buffer.append("[] 0 setdash\n");
            _buffer.append("1 setlinewidth\n");
        } else
        if(c == Color.white)
        {
            _buffer.append("1 setgray\n");
            _buffer.append("[] 0 setdash\n");
            _buffer.append("1 setlinewidth\n");
        } else
        if(c == Color.lightGray)
        {
            _buffer.append("0.9 setgray\n");
            _buffer.append("[] 0 setdash\n");
            _buffer.append("0.5 setlinewidth\n");
        } else
        if(_linepattern.containsKey(c))
        {
            _buffer.append((String)_linepattern.get(c) + " 0 setdash\n");
            _buffer.append("1 setlinewidth\n");
        } else
        {
            _buffer.append("0 setgray\n");
            if(_patternIndex >= _patterns.length)
                _patternIndex = 0;
            _buffer.append(_patterns[_patternIndex] + " 0 setdash\n");
            _buffer.append("1 setlinewidth\n");
            _linepattern.put(c, _patterns[_patternIndex]);
            _patternIndex++;
        }
        _currentColor = c;
    }

    public void setFont(Font font)
    {
        if(font == null)
            return;
        int size = font.getSize();
        boolean bold = font.isBold();
        if(bold)
            _buffer.append("/Helvetica-Bold findfont\n");
        else
            _buffer.append("/Helvetica findfont\n");
        _buffer.append(size + " scalefont setfont\n");
        _currentFont = font;
    }

    public void setPaintMode()
    {
    }

    public void setXORMode(Color color)
    {
    }

    public void showpage()
    {
        _buffer.append("showpage\n");
        if(_out != null)
        {
            PrintWriter output = new PrintWriter(new BufferedOutputStream(_out));
            output.println(_buffer.toString());
            output.flush();
        } else
        {
            if(_clipboard == null)
                _clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
            StringSelection sel = new StringSelection(_buffer.toString());
            _clipboard.setContents(sel, sel);
        }
    }

    public void translate(int i, int j)
    {
    }

    private Color _currentColor;
    private Font _currentFont;
    private int _width;
    private int _height;
    private Hashtable _linepattern;
    private OutputStream _out;
    private StringBuffer _buffer;
    private Clipboard _clipboard;
    private static String _patterns[] = {
        "[]", "[1 1]", "[4 4]", "[4 4 1 4]", "[2 2]", "[4 2 1 2 1 2]", "[5 3 2 3]", "[3 3]", "[4 2 1 2 2 2]", "[1 2 5 2 1 2 1 2]", 
        "[4 1 2 1]"
    };
    private int _patternIndex;

}