// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:04
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   EditablePlot.java

package Holger_modules.ptolemy.plot;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            Plot, EditListener, PlotBox, PlotPoint

public class EditablePlot extends Plot
{
    public class EditMouseListener
        implements MouseListener
    {

        public void mouseClicked(MouseEvent mouseevent)
        {
        }

        public void mouseEntered(MouseEvent mouseevent)
        {
        }

        public void mouseExited(MouseEvent mouseevent)
        {
        }

        public void mousePressed(MouseEvent event)
        {
            if((event.getModifiers() & 4) != 0)
                _editStart(event.getX(), event.getY());
        }

        public void mouseReleased(MouseEvent event)
        {
            if((event.getModifiers() & 4) != 0)
                _edit(event.getX(), event.getY());
        }

        public EditMouseListener()
        {
        }
    }

    public class ModifyListener
        implements MouseMotionListener
    {

        public void mouseDragged(MouseEvent event)
        {
            if((event.getModifiers() & 4) != 0)
                _editPoint(event.getX(), event.getY());
        }

        public void mouseMoved(MouseEvent mouseevent)
        {
        }

        public ModifyListener()
        {
        }
    }

    public class UndoListener
        implements KeyListener
    {

        public void keyPressed(KeyEvent e)
        {
            int keycode = e.getKeyCode();
            switch(keycode)
            {
            default:
                break;

            case 17: // '\021'
                _control = true;
                break;

            case 90: // 'Z'
                if(_control)
                    undo();
                break;

            case 89: // 'Y'
                if(_control)
                    redo();
                break;
            }
        }

        public void keyReleased(KeyEvent e)
        {
            int keycode = e.getKeyCode();
            switch(keycode)
            {
            case 17: // '\021'
                _control = false;
                break;
            }
        }

        public void keyTyped(KeyEvent keyevent)
        {
        }

        private boolean _control;

        public UndoListener()
        {
            _control = false;
        }
    }


    public EditablePlot()
    {
        _dataset = 0;
        _undoStack = new Stack();
        _redoStack = new Stack();
        _editListeners = null;
        addMouseListener(new EditMouseListener());
        addMouseMotionListener(new ModifyListener());
        addKeyListener(new UndoListener());
    }

    private synchronized void _edit(int x, int y)
    {
        if(_dataset < 0)
            return;
        Object save[] = new Object[2];
        save[0] = new Integer(_dataset);
        save[1] = getData(_dataset);
        _undoStack.push(((Object) (save)));
        for(; !_redoStack.empty(); _redoStack.pop());
        Graphics graphics = getGraphics();
        if(y > super._lry)
            y = super._lry;
        if(y < super._uly)
            y = super._uly;
        if(x > super._lrx)
            x = super._lrx;
        if(x < super._ulx)
            x = super._ulx;
        _editPoint(x, y);
        Vector pts = (Vector)super._points.elementAt(_dataset);
        for(int i = 0; i < pts.size(); i++)
        {
            PlotPoint pt = (PlotPoint)pts.elementAt(i);
            if(pt.x >= super._xMin && pt.x <= super._xMax)
            {
                int index = (int)((pt.x - super._xMin) * super._xscale) - (super._lrx - super._ulx - _editSpecX.length);
                if(index >= 0 && index < _editSpecX.length && _editSpecSet[index])
                {
                    pt.y = super._yMax - (double)(_editSpecY[index] - super._uly) / super._yscale;
                    if(pt.y < super._yBottom)
                        super._yBottom = pt.y;
                    if(pt.y > super._yTop)
                        super._yTop = pt.y;
                }
            }
        }

        repaint();
        graphics.setXORMode(_editColor);
        for(int i = 0; i < _editSpecX.length; i++)
            if(_editSpecSet[i])
                graphics.drawLine(_editSpecX[i], _editSpecY[i] - 1, _editSpecX[i], _editSpecY[i] + 1);

        graphics.setPaintMode();
        _notifyListeners(_dataset);
    }

    private synchronized void _editPoint(int x, int y)
    {
        if(_dataset < 0)
            return;
        Graphics graphics = getGraphics();
        if(y > super._lry)
            y = super._lry;
        if(y < super._uly)
            y = super._uly;
        if(x > super._lrx)
            x = super._lrx;
        if(x < super._ulx)
            x = super._ulx;
        if(x <= _currentEditX || x >= super._lrx)
            return;
        for(int step = _currentEditX; step <= x; step++)
        {
            int index = step - (super._lrx - _editSpecX.length);
            double proportion = (double)(step - _currentEditX) / (double)(x - _currentEditX);
            int newY = (int)((double)_currentEditY + proportion * (double)(y - _currentEditY));
            if(!_editSpecSet[index])
            {
                _editSpecX[index] = step;
                _editSpecY[index] = newY;
                _editSpecSet[index] = true;
                graphics.setXORMode(_editColor);
                graphics.drawLine(step, newY - 1, step, newY + 1);
                graphics.setPaintMode();
            }
        }

        _currentEditX = x;
        _currentEditY = y;
    }

    private synchronized void _editStart(int x, int y)
    {
        if(_dataset < 0)
            return;
        if(y > super._lry)
            y = super._lry;
        if(y < super._uly)
            y = super._uly;
        if(x > super._lrx)
            x = super._lrx;
        if(x < super._ulx)
            x = super._ulx;
        int size = (super._lrx - x) + 1;
        _editSpecX = new int[size];
        _editSpecY = new int[size];
        _editSpecSet = new boolean[size];
        _editSpecX[0] = x;
        _editSpecY[0] = y;
        _editSpecSet[0] = true;
        _currentEditX = x;
        _currentEditY = y;
        Graphics graphics = getGraphics();
        graphics.setXORMode(_editColor);
        graphics.drawLine(x, y - 1, x, y + 1);
        graphics.setPaintMode();
    }

    private void _notifyListeners(int dataset)
    {
        if(_editListeners == null)
            return;
        for(Enumeration listeners = _editListeners.elements(); listeners.hasMoreElements(); ((EditListener)listeners.nextElement()).editDataModified(this, dataset));
    }

    private void _setData(int dataset, double data[][])
    {
        _checkDatasetIndex(dataset);
        Vector pts = (Vector)super._points.elementAt(_dataset);
        int size = pts.size();
        if(data[0].length < size)
            size = data[0].length;
        for(int i = 0; i < size; i++)
        {
            PlotPoint pt = (PlotPoint)pts.elementAt(i);
            pt.x = data[0][i];
            pt.y = data[1][i];
        }

    }

    public void addEditListener(EditListener listener)
    {
        if(_editListeners == null)
            _editListeners = new Vector();
        else
        if(_editListeners.contains(listener))
            return;
        _editListeners.addElement(listener);
    }

    public double[][] getData(int dataset)
    {
        _checkDatasetIndex(dataset);
        Vector pts = (Vector)super._points.elementAt(_dataset);
        int size = pts.size();
        double result[][] = new double[2][size];
        for(int i = 0; i < size; i++)
        {
            PlotPoint pt = (PlotPoint)pts.elementAt(i);
            result[0][i] = pt.x;
            result[1][i] = pt.y;
        }

        return result;
    }

    public void redo()
    {
        if(_redoStack.empty())
        {
            return;
        } else
        {
            Object save[] = new Object[2];
            save[0] = new Integer(_dataset);
            save[1] = getData(_dataset);
            _undoStack.push(((Object) (save)));
            Object saved[] = (Object[])_redoStack.pop();
            _setData(((Integer)saved[0]).intValue(), (double[][])saved[1]);
            repaint();
            _notifyListeners(_dataset);
            return;
        }
    }

    public void removeEditListener(EditListener listener)
    {
        if(_editListeners == null)
        {
            return;
        } else
        {
            _editListeners.removeElement(listener);
            return;
        }
    }

    public void setEditable(int dataset)
    {
        if(dataset >= 0)
            _checkDatasetIndex(dataset);
        _dataset = dataset;
    }

    public void undo()
    {
        if(_undoStack.empty())
        {
            return;
        } else
        {
            Object save[] = new Object[2];
            save[0] = new Integer(_dataset);
            save[1] = getData(_dataset);
            _redoStack.push(((Object) (save)));
            Object saved[] = (Object[])_undoStack.pop();
            _setData(((Integer)saved[0]).intValue(), (double[][])saved[1]);
            repaint();
            _notifyListeners(_dataset);
            return;
        }
    }

    private int _editSpecX[];
    private int _editSpecY[];
    private boolean _editSpecSet[];
    private int _currentEditX;
    private int _currentEditY;
    private int _dataset;
    private static final Color _editColor;
    private Stack _undoStack;
    private Stack _redoStack;
    private Vector _editListeners;

    static 
    {
        _editColor = Color.white;
    }



}