// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:13
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   PlotApplet.java

package Holger_modules.ptolemy.plot;

import java.applet.Applet;
import java.awt.*;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.JApplet;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            Plot, PlotBox

public class PlotApplet extends JApplet
{

    public PlotApplet()
    {
    }

    protected void _read(InputStream in)
        throws IOException
    {
        plot().read(in);
    }

    protected void _setPlotSize(int appletWidth, int appletHeight)
    {
        plot().setSize(appletWidth, appletHeight);
    }

    public String getAppletInfo()
    {
        return "PlotApplet 5.1p2: A data plotter.\nBy: Edward A. Lee, eal@eecs.berkeley.edu and\n Christopher Hylands, cxh@eecs.berkeley.edu\n($Id: PlotApplet.java,v 1.1.1.1 2005/07/07 14:31:48 jag Exp $)";
    }

    public String[][] getParameterInfo()
    {
        String pinfo[][] = {
            {
                "background", "hexcolor value", "background color"
            }, {
                "foreground", "hexcolor value", "foreground color"
            }, {
                "dataurl", "url", "the URL of the data to plot"
            }, {
                "height", "integer", "100"
            }, {
                "width", "integer", "100"
            }
        };
        return pinfo;
    }

    public void init()
    {
        super.init();
        if(_plot == null)
            _plot = newPlot();
        getContentPane().add(plot(), "North");
        String widthspec = getParameter("width");
        int width;
        if(widthspec != null)
            width = Integer.parseInt(widthspec);
        else
            width = 400;
        String heightspec = getParameter("height");
        int height;
        if(heightspec != null)
            height = Integer.parseInt(heightspec);
        else
            height = 400;
        _setPlotSize(width, height);
        plot().setButtons(true);
        Color background = Color.white;
        String colorspec = getParameter("background");
        if(colorspec != null)
            background = PlotBox.getColorByName(colorspec);
        setBackground(background);
        plot().setBackground(background);
        getContentPane().setBackground(background);
        Color foreground = Color.black;
        colorspec = getParameter("foreground");
        if(colorspec != null)
            foreground = PlotBox.getColorByName(colorspec);
        setForeground(foreground);
        plot().setForeground(foreground);
        plot().setVisible(true);
        String dataurlspec = getParameter("dataurl");
        if(dataurlspec != null)
            try
            {
                showStatus("Reading data");
                URL dataurl = new URL(getDocumentBase(), dataurlspec);
                InputStream in = dataurl.openStream();
                _read(in);
                showStatus("Done");
            }
            catch(MalformedURLException e)
            {
                System.err.println(e.toString());
            }
            catch(FileNotFoundException e)
            {
                System.err.println("PlotApplet: file not found: " + e);
            }
            catch(IOException e)
            {
                System.err.println("PlotApplet: error reading input file: " + e);
            }
    }

    public PlotBox newPlot()
    {
        return new Plot();
    }

    public PlotBox plot()
    {
        return _plot;
    }

    private transient PlotBox _plot;
}