// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:22
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   PlotFrame.java

package Holger_modules.ptolemy.plot;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.PrinterJob;
import java.io.*;
import java.net.URL;
import java.util.EventObject;
import javax.swing.*;

// Referenced classes of package ptolemy.plot:
//            Plot, PlotBox, PlotFormatter

public class PlotFrame extends JFrame
{
    class FileMenuListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            JMenuItem target = (JMenuItem)e.getSource();
            String actionCommand = target.getActionCommand();
            if(actionCommand.equals("Open"))
                _open();
            else
            if(actionCommand.equals("Save"))
                _save();
            else
            if(actionCommand.equals("SaveAs"))
                _saveAs();
            else
            if(actionCommand.equals("Export"))
                _export();
            else
            if(actionCommand.equals("Print"))
                _print();
            else
            if(actionCommand.equals("Close"))
                _close();
            repaint();
        }

        FileMenuListener()
        {
        }
    }

    class FormatListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            _editFormat();
            repaint();
        }

        FormatListener()
        {
        }
    }

    class SpecialMenuListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            JMenuItem target = (JMenuItem)e.getSource();
            String actionCommand = target.getActionCommand();
            if(actionCommand.equals("About"))
                _about();
            else
            if(actionCommand.equals("Help"))
                _help();
            else
            if(actionCommand.equals("Fill"))
                plot.fillPlot();
            else
            if(actionCommand.equals("Reset axes"))
                plot.resetAxes();
            else
            if(actionCommand.equals("Clear"))
            {
                plot.clear(false);
                plot.repaint();
            } else
            if(actionCommand.equals("Sample plot"))
            {
                plot.clear(true);
                samplePlot();
            }
            repaint();
        }

        SpecialMenuListener()
        {
        }
    }


    public PlotFrame()
    {
        this("Ptolemy Plot Frame");
    }

    public PlotFrame(String title)
    {
        this(title, null);
    }

    public PlotFrame(String title, PlotBox plotArg)
    {
        super(title);
        _menubar = new JMenuBar();
        _editMenu = new JMenu("Edit");
        _fileMenu = new JMenu("File");
        _specialMenu = new JMenu("Special");
        _directory = null;
        _file = null;
        if(plotArg == null)
            plot = new Plot();
        else
            plot = plotArg;
        plot.setBackground(new Color(0xe5e5e5));
        _fileMenu.setMnemonic(70);
        _editMenu.setMnemonic(69);
        _specialMenu.setMnemonic(83);
        JMenuItem fileMenuItems[] = {
            new JMenuItem("Open", 79), new JMenuItem("Save", 83), new JMenuItem("SaveAs", 65), new JMenuItem("Export", 69), new JMenuItem("Print", 80), new JMenuItem("Close", 67)
        };
        fileMenuItems[0].setAccelerator(KeyStroke.getKeyStroke(79, 2));
        fileMenuItems[1].setAccelerator(KeyStroke.getKeyStroke(83, 2));
        fileMenuItems[4].setAccelerator(KeyStroke.getKeyStroke(80, 2));
        fileMenuItems[5].setAccelerator(KeyStroke.getKeyStroke(87, 2));
        FileMenuListener fml = new FileMenuListener();
        for(int i = 0; i < fileMenuItems.length; i++)
        {
            fileMenuItems[i].setActionCommand(fileMenuItems[i].getText());
            fileMenuItems[i].addActionListener(fml);
            _fileMenu.add(fileMenuItems[i]);
        }

        _menubar.add(_fileMenu);
        JMenuItem format = new JMenuItem("Format", 70);
        FormatListener formatListener = new FormatListener();
        format.addActionListener(formatListener);
        _editMenu.add(format);
        _menubar.add(_editMenu);
        JMenuItem specialMenuItems[] = {
            new JMenuItem("About", 65), new JMenuItem("Help", 72), new JMenuItem("Clear", 67), new JMenuItem("Fill", 70), new JMenuItem("Reset axes", 82), new JMenuItem("Sample plot", 83)
        };
        SpecialMenuListener sml = new SpecialMenuListener();
        for(int i = 0; i < specialMenuItems.length; i++)
        {
            specialMenuItems[i].setActionCommand(specialMenuItems[i].getText());
            specialMenuItems[i].addActionListener(sml);
            _specialMenu.add(specialMenuItems[i]);
        }

        _menubar.add(_specialMenu);
        setJMenuBar(_menubar);
        getContentPane().add(plot, "Center");
        setSize(500, 300);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        int x = (screenSize.width - frameSize.width) / 2;
        int y = (screenSize.height - frameSize.height) / 2;
        setLocation(x, y);
    }

    protected void _about()
    {
        JOptionPane.showMessageDialog(this, "PlotFrame class\nBy: Edward A. Lee, eal@eecs.berkeley.edu and Christopher Hylands, cxh@eecs.berkeley.edu\nVersion 5.1p2, Build: $Id: PlotFrame.java,v 1.1.1.1 2005/07/07 14:31:48 jag Exp $\n\nFor more information, see\nhttp://ptolemy.eecs.berkeley.edu/java/ptplot\n\nCopyright (c) 1997-2001, The Regents of the University of California.", "About Ptolemy Plot", 1);
    }

    protected void _close()
    {
        dispose();
    }

    protected void _editFormat()
    {
        PlotFormatter fmt = new PlotFormatter(plot);
        fmt.openModal();
    }

    protected void _export()
    {
        JFileChooser fileDialog = new JFileChooser();
        fileDialog.setDialogTitle("Export EPS to...");
        if(_directory != null)
        {
            fileDialog.setCurrentDirectory(_directory);
        } else
        {
            String cwd = System.getProperty("user.dir");
            if(cwd != null)
                fileDialog.setCurrentDirectory(new File(cwd));
        }
        int returnVal = fileDialog.showDialog(this, "Export");
        if(returnVal == 0)
        {
            File file = fileDialog.getSelectedFile();
            try
            {
                FileOutputStream fout = new FileOutputStream(file);
                plot.export(fout);
            }
            catch(IOException ex)
            {
                JOptionPane.showMessageDialog(this, "Error exporting plot: " + ex, "Ptolemy II Error", 2);
            }
        }
    }

    protected void _help()
    {
        JOptionPane.showMessageDialog(this, "PlotFrame is a plot in a top-level window.\n  File formats understood: Ptplot ASCII.\n  Left mouse button: Zooming.", "About Ptolemy Plot", 1);
    }

    protected void _open()
    {
        JFileChooser fileDialog = new JFileChooser();
        fileDialog.setDialogTitle("Select a plot file");
        if(_directory != null)
        {
            fileDialog.setCurrentDirectory(_directory);
        } else
        {
            String cwd = System.getProperty("user.dir");
            if(cwd != null)
                fileDialog.setCurrentDirectory(new File(cwd));
        }
        int returnVal = fileDialog.showOpenDialog(this);
        if(returnVal == 0)
        {
            _file = fileDialog.getSelectedFile();
            setTitle(_file.getName());
            _directory = fileDialog.getCurrentDirectory();
            try
            {
                plot.clear(true);
                _read(new URL("file", null, _directory.getAbsolutePath()), new FileInputStream(_file));
                plot.repaint();
            }
            catch(FileNotFoundException ex)
            {
                JOptionPane.showMessageDialog(this, "File not found:\n" + ex.toString(), "Ptolemy Plot Error", 2);
            }
            catch(IOException ex)
            {
                JOptionPane.showMessageDialog(this, "Error reading input:\n" + ex.toString(), "Ptolemy Plot Error", 2);
            }
        }
    }

    protected void _print()
    {
        PrinterJob job = PrinterJob.getPrinterJob();
        job.setPrintable(plot);
        if(job.printDialog())
            try
            {
                job.print();
            }
            catch(Exception ex)
            {
                JOptionPane.showMessageDialog(this, "Printing failed:\n" + ex.toString(), "Print Error", 2);
            }
    }

    protected void _read(URL base, InputStream in)
        throws IOException
    {
        plot.read(in);
    }

    protected void _save()
    {
        if(_file != null)
            try
            {
                FileOutputStream fout = new FileOutputStream(_file);
                plot.write(fout);
            }
            catch(IOException ex)
            {
                JOptionPane.showMessageDialog(this, "Error writing file:\n" + ex.toString(), "Ptolemy Plot Error", 2);
            }
        else
            _saveAs();
    }

    protected void _saveAs()
    {
        JFileChooser fileDialog = new JFileChooser();
        fileDialog.setDialogTitle("Save plot as...");
        if(_directory != null)
        {
            fileDialog.setCurrentDirectory(_directory);
        } else
        {
            String cwd = System.getProperty("user.dir");
            if(cwd != null)
                fileDialog.setCurrentDirectory(new File(cwd));
        }
        int returnVal = fileDialog.showSaveDialog(this);
        if(returnVal == 0)
        {
            _file = fileDialog.getSelectedFile();
            setTitle(_file.getName());
            _directory = fileDialog.getCurrentDirectory();
            _save();
        }
    }

    public void samplePlot()
    {
        _file = null;
        _directory = null;
        plot.samplePlot();
    }

    public PlotBox plot;
    protected JMenuBar _menubar;
    protected JMenu _editMenu;
    protected JMenu _fileMenu;
    protected JMenu _specialMenu;
    protected File _directory;
    protected File _file;
}